Search.setIndex({"docnames": ["algorithm", "array", "howto", "index", "misc", "runtime", "runtime_const", "runtime_gl", "runtime_memory", "runtime_platform", "runtime_program", "runtime_queue", "tools", "types"], "filenames": ["algorithm.rst", "array.rst", "howto.rst", "index.rst", "misc.rst", "runtime.rst", "runtime_const.rst", "runtime_gl.rst", "runtime_memory.rst", "runtime_platform.rst", "runtime_program.rst", "runtime_queue.rst", "tools.rst", "types.rst"], "titles": ["Parallel Algorithms", "Multi-dimensional arrays", "How-tos", "Welcome to PyOpenCL\u2019s documentation!", "Installation", "OpenCL Runtime: Basics", "OpenCL Runtime: Constants", "OpenCL Runtime: OpenGL Interoperability", "OpenCL Runtime: Memory", "OpenCL Runtime: Platforms, Devices and Contexts", "OpenCL Runtime: Programs and Kernels", "OpenCL Runtime: Command Queues and Events", "Built-in Utilities", "OpenCL Type Mapping"], "terms": {"instanc": [0, 3, 4, 5, 7, 8, 9, 10, 11, 12], "thi": [0, 1, 3, 4, 5, 7, 8, 9, 10, 11, 12, 13], "class": [0, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12], "ar": [0, 1, 2, 3, 4, 5, 7, 8, 9, 10, 11, 12, 13], "hashabl": [0, 4, 5, 7, 8, 9, 10, 11], "two": [0, 3, 4, 5, 7, 8, 9, 10, 11, 12], "mai": [0, 1, 2, 4, 5, 7, 8, 9, 10, 11, 12], "compar": [0, 4, 5, 7, 8, 9, 10, 11], "us": [0, 1, 3, 5, 7, 9, 10, 11, 12, 13], "wa": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "ad": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "version": [0, 1, 2, 3, 6, 7, 8, 9, 10, 11, 12], "2011": [0, 1, 3, 5, 6, 7, 8, 9, 10, 11, 12], "2": [0, 1, 2, 3, 5, 6, 7, 8, 9, 10, 11, 12], "object": [0, 1, 3, 4, 5, 7, 8, 9, 10, 11], "consid": [0, 1, 4, 5, 7, 8, 9, 10, 11], "same": [0, 1, 5, 7, 8, 9, 10, 11, 12, 13], "underli": [0, 5, 7, 8, 9, 10, 11], "opencl": [0, 1, 2, 3, 12], "i": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13], "establish": [0, 5, 7, 8, 9, 10, 11], "c": [0, 1, 2, 3, 5, 7, 8, 9, 10, 11, 12], "pointer": [0, 4, 5, 7, 9, 10, 11], "equal": [0, 5, 6, 7, 8, 9, 10, 11, 12], "must": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "implement": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "python": [0, 1, 3, 4, 5, 7, 8, 9, 10, 11], "buffer": [0, 1, 3, 4, 5, 6, 7, 9, 10, 11], "e": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "g": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "being": [0, 1, 5, 7, 8, 9, 10, 11, 12], "an": [0, 1, 2, 3, 4, 5, 7, 8, 9, 10, 11, 12], "numpi": [0, 1, 2, 3, 5, 7, 9, 10, 11, 13], "ndarrai": [0, 1, 5, 7, 8, 9, 10, 11], "wait_for": [0, 1, 5, 7, 8, 9, 10, 11], "either": [0, 1, 4, 5, 7, 8, 9, 10, 11], "none": [0, 1, 2, 3, 5, 6, 7, 8, 9, 10, 11, 12], "pyopencl": [0, 1, 5, 6, 7, 8, 9, 10, 11, 12, 13], "event": [0, 1, 3, 4, 5, 7, 8, 9, 10, 12], "whose": [0, 4, 5, 7, 8, 9, 10, 11], "complet": [0, 1, 3, 5, 6, 7, 8, 9, 10, 11, 12], "command": [0, 3, 4, 5, 7, 8, 9, 10], "wait": [0, 1, 5, 7, 8, 9, 10, 11, 12], "befor": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "start": [0, 1, 4, 5, 6, 7, 8, 9, 10, 11, 12], "exeuct": [0, 5, 7, 8, 9, 10, 11], "return": [0, 1, 5, 6, 7, 8, 9, 10, 11, 12], "new": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12], "note": [0, 1, 3, 4, 5, 7, 8, 9, 10, 11, 12], "function": [0, 3, 4, 5, 6, 7, 9, 10, 12], "deprec": [0, 1, 4, 5, 6, 7, 8, 9, 10, 11, 12], "1": [0, 1, 2, 3, 5, 6, 7, 8, 9, 10, 11, 12], "enqueue_copi": [0, 1, 3, 4, 5, 7, 8, 9, 10, 11], "instead": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "global_s": [0, 5, 7, 8, 9, 10, 11], "local_s": [0, 4, 5, 7, 8, 9, 10, 11], "tupl": [0, 1, 5, 7, 8, 9, 10, 11, 12], "ident": [0, 1, 5, 7, 8, 9, 10, 11], "length": [0, 1, 5, 7, 8, 9, 10, 11], "between": [0, 1, 4, 5, 7, 8, 9, 10, 11], "one": [0, 1, 3, 4, 5, 7, 8, 9, 10, 11, 12], "three": [0, 1, 5, 7, 8, 9, 10, 11], "entri": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "specifi": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12, 13], "overal": [0, 5, 7, 8, 9, 10, 11], "comput": [0, 1, 3, 4, 5, 7, 8, 9, 10, 11, 12], "grid": [0, 5, 7, 8, 9, 10, 11], "work": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "item": [0, 1, 5, 7, 8, 9, 10, 11, 12], "launch": [0, 4, 5, 7, 8, 9, 10, 11], "everi": [0, 3, 4, 5, 7, 8, 9, 10, 11], "integ": [0, 1, 2, 4, 5, 7, 8, 9, 10, 11, 13], "point": [0, 1, 2, 5, 7, 8, 9, 10, 11, 12], "workgroup": [0, 5, 7, 8, 9, 10, 11], "which": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "evenli": [0, 5, 7, 8, 9, 10, 11], "divid": [0, 1, 5, 7, 8, 9, 10, 11], "dimens": [0, 1, 5, 7, 8, 9, 10, 11, 12], "manner": [0, 5, 7, 8, 9, 10, 11, 12], "pass": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "case": [0, 1, 4, 5, 7, 8, 9, 10, 11], "defin": [0, 1, 5, 7, 8, 9, 10, 11, 13], "If": [0, 1, 3, 4, 5, 7, 8, 9, 10, 11, 12], "g_times_l": [0, 4, 5, 7, 8, 9, 10, 11], "true": [0, 1, 4, 5, 7, 8, 9, 10, 11], "global": [0, 5, 6, 7, 8, 9, 10, 11], "multipli": [0, 1, 5, 7, 8, 9, 10, 11], "local": [0, 5, 6, 7, 8, 9, 10, 11, 12], "behavior": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "more": [0, 1, 4, 5, 7, 8, 9, 10, 11], "like": [0, 1, 2, 4, 5, 7, 8, 9, 10, 11], "nvidia": [0, 4, 5, 7, 8, 9, 10, 11, 12], "cuda": [0, 5, 7, 8, 9, 10, 11], "In": [0, 1, 4, 5, 7, 8, 9, 10, 11], "also": [0, 1, 3, 4, 5, 7, 8, 9, 10, 11, 12, 13], "do": [0, 1, 4, 5, 7, 8, 9, 10, 11], "have": [0, 1, 2, 4, 5, 7, 8, 9, 10, 11, 12, 13], "number": [0, 2, 3, 4, 5, 7, 8, 9, 10, 11, 12], "allow_empty_ndrang": [0, 4, 5, 7, 8, 9, 10, 11], "bool": [0, 1, 5, 7, 8, 9, 10, 11, 12, 13], "indic": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "how": [0, 1, 3, 4, 5, 7, 8, 9, 10, 11, 12], "empti": [0, 1, 2, 5, 7, 8, 9, 10, 11, 12, 13], "ndrang": [0, 5, 7, 8, 9, 10, 11], "treat": [0, 5, 7, 8, 9, 10, 11], "where": [0, 1, 3, 4, 5, 7, 8, 9, 10, 11, 12], "mean": [0, 1, 4, 5, 7, 8, 9, 10, 11], "zero": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "itself": [0, 5, 7, 8, 9, 10, 11], "doe": [0, 1, 3, 4, 5, 7, 8, 9, 10, 11, 13], "allow": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12, 13], "enqueu": [0, 4, 5, 7, 8, 9, 10, 11, 12], "over": [0, 4, 5, 7, 8, 9, 10, 11], "set": [0, 1, 3, 5, 7, 8, 9, 10, 11], "flag": [0, 1, 4, 5, 6, 7, 8, 9, 10, 11, 12], "marker": [0, 5, 6, 7, 8, 9, 10, 11], "clenqueuemarkerwithwaitlist": [0, 5, 7, 8, 9, 10, 11], "obtain": [0, 1, 4, 5, 7, 8, 9, 10, 11], "synchron": [0, 1, 3, 4, 5, 7, 8, 9, 10, 12], "effect": [0, 5, 7, 8, 9, 10, 11], "would": [0, 1, 2, 4, 5, 7, 8, 9, 10, 11], "result": [0, 1, 5, 7, 8, 9, 10, 11, 12], "from": [0, 1, 2, 3, 5, 7, 8, 9, 10, 11, 12, 13], "requir": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12], "newer": [0, 4, 5, 6, 7, 8, 9, 10, 11], "involv": [0, 4, 8, 10], "arrai": [0, 2, 3, 4, 9, 12, 13], "overload": [0, 1], "oper": [0, 2, 4, 11, 12], "can": [0, 1, 2, 3, 4, 8, 9, 10, 11, 12], "somewhat": 0, "ineffici": 0, "becaus": [0, 1, 2, 4, 8, 9, 10, 12, 13], "temporari": 0, "creat": [0, 1, 2, 4, 7, 8, 9, 10, 11, 13], "each": [0, 1, 9, 10, 12], "intermedi": [0, 12], "The": [0, 3, 4, 5, 8, 9, 10, 11, 12, 13], "modul": [0, 1, 3, 10, 13], "elementwis": [0, 2, 3, 4], "contain": [0, 1, 3, 4, 8, 10], "tool": [0, 1, 2, 4, 8, 12], "help": [0, 1, 3, 4, 10], "gener": [0, 2, 3, 4, 10], "multi": [0, 3], "stage": 0, "sever": [0, 4], "operand": 0, "singl": [0, 4, 9, 10], "elementwisekernel": [0, 1, 2], "context": [0, 1, 3, 4, 6, 7, 8, 10, 11, 12], "argument": [0, 1, 3, 4, 7, 8, 9, 10], "union": [0, 1, 12], "str": [0, 1, 6, 8, 10, 12], "dtypedargu": [0, 12], "name": [0, 1, 4, 5, 6, 10, 12, 13], "elwise_kernel": 0, "option": [0, 1, 4, 6, 8, 10], "ani": [0, 1, 4, 8, 10, 12], "kwarg": [0, 1, 4, 8], "sourc": [0, 1, 3, 6, 8, 9, 10, 11, 12], "A": [0, 1, 4, 5, 6, 8, 10, 11, 12], "take": [0, 1, 4, 10, 11, 12], "scalar": [0, 1, 3, 4, 8, 10], "vector": [0, 3, 4, 8, 12], "perform": [0, 1, 4, 8, 10, 11, 12], "snippet": [0, 10], "paramet": [0, 1, 4, 8, 10, 12], "string": [0, 1, 2, 4, 5, 10, 12], "format": [0, 6, 8], "carri": [0, 1], "out": [0, 1, 2, 4, 8, 10, 12], "desir": [0, 1], "current": [0, 1, 4, 7, 8, 12], "index": [0, 1, 3, 8, 10], "avail": [0, 1, 3, 4, 6, 7, 8, 9, 10, 11, 12, 13], "statement": [0, 4, 8], "pyopencl_elwise_continu": 0, "termin": 0, "process": 0, "compil": [0, 1, 4, 5, 6, 7, 10], "unmodifi": 0, "program": [0, 2, 3, 4, 6, 9, 12], "preambl": [0, 1, 2], "piec": [0, 1, 3, 4], "code": [0, 1, 3, 4, 8, 10, 12], "get": [0, 1, 4, 7], "insert": [0, 1], "outsid": [0, 8, 12], "": [0, 1, 2, 8, 10, 12], "lead": [0, 1, 4, 8, 12], "incorrect": 0, "some": [0, 1, 2, 4], "never": [0, 1, 10], "chang": [0, 1, 3, 7, 8, 9, 10, 11, 12], "2013": [0, 1, 3, 6, 8, 9, 10, 11, 12], "__call__": [0, 4, 10, 12], "arg": [0, 1, 4, 10, 12], "invok": [0, 10], "here": [0, 1, 3, 4, 8, 13], "usr": [0, 3], "bin": [0, 3, 4, 12], "python3": [0, 3], "import": [0, 1, 2, 3, 4, 9, 10, 12, 13], "np": [0, 1, 2, 3, 8, 12, 13], "cl": [0, 1, 2, 3, 4, 7, 8, 9, 10, 11, 13], "n": [0, 1, 4], "10": [0, 4], "a_np": [0, 3, 10], "random": [0, 3, 4], "randn": 0, "astyp": [0, 1, 3], "float32": [0, 1, 2, 3, 4, 8, 12, 13], "b_np": [0, 3], "ctx": [0, 1, 2, 3, 8, 9, 12], "create_some_context": [0, 1, 2, 3, 4, 9], "queue": [0, 1, 2, 3, 4, 7, 8, 9, 10, 12], "commandqueu": [0, 1, 2, 3, 4, 8, 10, 11, 12], "a_g": [0, 3, 10], "to_devic": [0, 1, 2, 4], "b_g": [0, 3, 10], "lin_comb": 0, "float": [0, 1, 2, 3, 4, 6, 8, 10, 12, 13], "k1": 0, "k2": 0, "res_g": [0, 3, 10], "empty_lik": [0, 1, 3], "3": [0, 1, 3, 6, 8, 9, 10], "check": [0, 3, 4, 5, 12], "gpu": [0, 1, 3, 6, 12], "print": [0, 1, 2, 3, 8], "cpu": [0, 3, 6], "res_np": [0, 3], "linalg": [0, 3], "norm": [0, 3], "you": [0, 1, 3, 4, 8, 9, 10, 11, 12, 13], "find": [0, 3, 4], "demo_elementwis": 0, "py": [0, 1, 3, 10], "distribut": [0, 1, 3, 4], "reduct": [0, 3, 4], "reductionkernel": [0, 1, 4], "dtype_out": 0, "neutral": 0, "reduce_expr": 0, "map_expr": 0, "reduce_kernel": 0, "least": 0, "outcom": [0, 10], "serv": [0, 8], "initi": [0, 1, 2, 4], "valu": [0, 1, 6, 7, 8, 9, 10, 11, 12], "offer": [0, 3, 4, 8], "possibl": [0, 1, 4, 8, 9, 11], "add": [0, 1, 4, 8, 10, 11], "preprocessor": 0, "direct": [0, 4, 8], "other": [0, 1, 3, 8, 12], "helper": [0, 10], "actual": [0, 1, 4, 8, 9, 12], "should": [0, 1, 2, 3, 4, 8, 9, 10, 11, 12], "formal": 0, "b": [0, 1, 4], "binari": [0, 3, 6, 10], "automat": [0, 1, 3, 4, 8, 9, 10, 11, 12], "assum": [0, 12], "onli": [0, 1, 4, 6, 7, 8, 9, 10, 11, 12], "input": [0, 1], "dtype": [0, 1, 2, 8, 10, 12, 13], "__init__": [0, 6, 8, 12], "With": 0, "offset": [0, 1, 4, 6, 8], "support": [0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 12], "store": [0, 1], "anywher": 0, "correspond": [0, 1, 4, 7, 8, 9, 10, 11, 12, 13], "part": [0, 1, 3, 4, 8], "execut": [0, 1, 4, 6, 10, 11, 12], "It": [0, 1, 4, 8, 10, 12], "suitabl": [0, 10], "profil": [0, 6, 11], "2014": [0, 1, 3], "2016": [0, 1, 3, 6, 8, 9, 10, 11], "range_": 0, "slice_": 0, "rang": [0, 1, 4, 8], "slice": [0, 1, 4, 8], "given": [0, 1, 4, 7, 8, 9, 10, 12], "time": [0, 1, 4, 8, 10, 12], "rel": 0, "first": [0, 1, 2, 4, 8, 12], "return_ev": 0, "boolean": [0, 1], "fals": [0, 1, 2, 7, 8, 9, 10, 11, 12], "otherwis": [0, 1, 4, 7, 8, 9], "scalar_arrai": 0, "arang": [0, 1, 4, 12], "400": 0, "krnl": 0, "0": [0, 1, 2, 3, 5, 6, 7, 8, 9, 10, 11, 12], "x": [0, 1, 4, 7, 8, 11], "y": [0, 1], "__global": [0, 2, 3, 10], "my_dot_prod": 0, "extra": 0, "procedur": 0, "For": [0, 1, 2, 4, 8, 9, 10, 11, 12, 13], "type": [0, 3, 6, 9, 10, 11], "As": [0, 1, 4, 8], "definit": 0, "includ": [0, 1, 4, 8, 11, 12], "run": [0, 1, 4, 6, 10, 12], "provid": [0, 1, 3, 4, 8, 10, 12, 13], "cumsum": 0, "4": [0, 3, 11, 12], "5": [0, 1, 3, 8, 9, 11], "7": [0, 1, 8, 9], "9": [0, 9], "11": 0, "13": [0, 2, 4], "15": [0, 8], "veri": [0, 1, 4, 8], "what": [0, 1, 3, 4, 8, 10, 11, 12], "turn": [0, 4, 8, 9, 10, 11, 12], "significantli": 0, "versatil": 0, "thei": [0, 1, 4, 8, 11, 12], "basic": [0, 3, 4], "block": [0, 8, 12], "non": [0, 1, 3, 4, 10], "trivial": 0, "enabl": [0, 3, 5, 11, 12], "seem": 0, "difficult": 0, "loop": 0, "depend": [0, 1, 3, 4, 8, 10], "applic": [0, 4, 8, 12], "gui": 0, "blelloch": 0, "articl": [0, 3, 4], "give": [0, 1, 3, 5, 8, 9], "overview": 0, "surpris": 0, "These": [0, 1, 4], "built": [0, 2, 3, 4, 10], "realiz": 0, "genericscankernel": 0, "illustr": 0, "simplifi": 0, "copy_if": 0, "output": [0, 1], "greater": [0, 1, 8], "than": [0, 1, 4, 8, 10, 12], "300": 0, "knl": [0, 3], "int32": [0, 2, 4, 10], "int": [0, 1, 2, 3, 8, 9, 10, 11, 12], "ari": [0, 1, 2, 8], "input_expr": 0, "scan_expr": 0, "output_stat": 0, "prev_item": 0, "a_host": 0, "out_host": 0, "assert": [0, 3, 8], "len": 0, "all": [0, 1, 2, 3, 4, 5, 6, 8, 9, 10, 11, 12], "whether": [0, 1, 4, 8, 12], "previou": [0, 8, 9, 10, 11], "differ": [0, 1, 2, 8, 9, 12], "satisfi": [0, 10, 12], "posit": [0, 10], "follow": [0, 1, 4, 8, 9, 10, 12, 13], "advanc": 0, "featur": [0, 6, 8], "segment": 0, "access": [0, 1, 3, 8, 10, 12], "comparison": [0, 1, 8], "see": [0, 1, 4, 6, 7, 8, 9, 10, 11, 12, 13], "is_segment_start_expr": 0, "input_fetch_expr": 0, "index_dtyp": 0, "name_prefix": 0, "devic": [0, 1, 2, 3, 4, 6, 7, 8, 10, 11], "arbitrari": 0, "tweak": 0, "10000": 0, "within": [0, 1, 3, 12], "structur": [0, 1, 8, 12], "regist": [0, 1, 4], "through": [0, 1, 4, 8, 12], "get_or_register_dtyp": [0, 1, 2, 4], "comma": [0, 12], "separ": [0, 4, 10, 12], "declar": [0, 1, 2, 8, 12], "known": [0, 1, 8], "associ": [0, 1, 4, 8, 12], "repres": [0, 1, 4, 5, 6, 8, 9, 12], "Its": [0, 8], "when": [0, 1, 4, 6, 7, 8, 9, 10, 11, 12], "guarante": [0, 8, 12], "updat": [0, 1, 3], "increment": 0, "thu": [0, 8], "data": [0, 2, 3, 4, 9, 10, 12], "suppos": [0, 2], "just": [0, 1, 4, 9, 10], "propag": 0, "along": [0, 1, 2], "without": [0, 1, 4, 8], "modifi": [0, 1, 4], "live": [0, 10], "call": [0, 1, 3, 4, 8, 9, 10, 11, 12], "anoth": [0, 1, 8, 10], "across_seg_boundari": 0, "cross": [0, 3], "boundari": 0, "routin": [0, 1, 3], "semant": [0, 8, 12], "its": [0, 1, 3, 4, 8, 9, 10, 11, 12], "own": [0, 1, 2, 3, 10, 12], "reli": [0, 1, 4], "alwai": [0, 1, 8], "even": [0, 3, 4, 8, 12, 13], "earli": 0, "pre": [0, 1], "releas": [0, 3, 4, 5, 8, 9, 10, 11, 12], "were": [0, 4, 8, 9], "encod": 0, "appli": [0, 1, 4, 8, 12], "match": [0, 1, 2, 8, 9, 12], "intend": [0, 10], "write": [0, 1, 3, 4, 6, 8, 10], "ha": [0, 1, 3, 4, 8, 10, 12], "preced": [0, 10], "immedi": [0, 8, 12], "small": [0, 1, 8, 10], "cost": [0, 8], "construct": [0, 4, 8, 10], "exclus": [0, 4], "refer": [0, 3, 8, 9, 10, 11, 12, 13], "last_item": 0, "last": [0, 1, 8, 12], "determin": 0, "addit": [0, 1, 4, 8, 10, 11], "spill": 0, "subsequ": [0, 8], "arg_nam": 0, "equival": [0, 11, 13], "arg_name_typ": 0, "space": [0, 1, 3, 10], "occur": [0, 8], "fragment": 0, "abov": [0, 1, 3, 4, 11, 12], "vari": [0, 8], "further": [0, 1, 4, 11], "alloc": [0, 1], "infer": 0, "genericdebugscankernel": 0, "dead": 0, "sequenti": 0, "best": 0, "platform": [0, 3, 4, 6, 7, 8, 10, 12], "isol": 0, "bug": [0, 1, 4, 10, 12], "remov": [0, 1, 4], "potenti": [0, 1, 4, 10, 12], "issu": [0, 4, 10, 12], "origin": [0, 1, 4, 8], "exclusivescankernel": 0, "obei": [0, 8], "ensur": [0, 1, 4, 8, 11, 12], "recogniz": 0, "log": [0, 1, 4, 6], "restrict": [0, 4, 6, 11], "meant": 0, "default": [0, 1, 4, 6, 8, 9, 10, 12], "self": [0, 1, 8, 10, 11, 12], "input_ari": 0, "output_ari": 0, "inclusivescankernel": 0, "now": [0, 1, 4, 8, 9, 10, 11], "inclus": 0, "6": [0, 1], "20": [0, 2], "18": 0, "rng": 0, "default_rng": 0, "seed": [0, 1], "42": [0, 13], "host_data": 0, "dev_data": 0, "cl_arrai": [0, 12], "axi": [0, 1], "extra_arg": 0, "test": [0, 3, 4, 10], "end": [0, 1, 6, 11, 12], "up": [0, 1, 4, 8, 10, 12], "fetch": 0, "host": [0, 1, 2, 3, 6, 9, 11], "manag": [0, 1, 4, 8, 11, 12], "remove_if": 0, "did": 0, "out_tru": 0, "out_fals": 0, "is_equal_expr": 0, "predecessor": 0, "yield": 0, "unix": 0, "uniq": 0, "often": [0, 3, 9, 12], "sequenc": [0, 1, 8, 11], "distinct": 0, "radixsort": 0, "key_expr": 0, "sort_arg_nam": 0, "bits_at_a_tim": 0, "key_dtyp": 0, "uint32": [0, 1, 8, 13], "scan_kernel": 0, "bitonic_sort": 0, "bitonicsort": 0, "specif": [0, 3, 6, 11], "constructor": [0, 1, 4, 7, 8, 9, 10, 12], "keyword": [0, 1, 4, 8, 10, 12], "key_bit": 0, "bit": [0, 4, 11, 12, 13], "signific": 0, "kei": [0, 1, 4, 8, 9, 11], "consist": [0, 2, 4, 11, 12], "sorted_arg": 0, "order": [0, 1, 4, 8, 9, 10, 12], "listoflistsbuild": [0, 4], "list_names_and_dtyp": 0, "generate_templ": 0, "arg_decl": 0, "count_shar": 0, "plb_build_list": 0, "complex_kernel": 0, "eliminate_empty_output_list": [0, 4], "produc": [0, 1, 8, 10], "larg": [0, 10], "simpli": [0, 1, 4, 8, 9, 10], "preview": 0, "subject": [0, 4], "until": [0, 8], "notic": [0, 4], "builder": 0, "mylist": 0, "void": [0, 2, 3, 4], "list_arg_decl": 0, "user_arg_decl": 0, "index_typ": 0, "j": [0, 4], "append_mylist": 0, "2000": [0, 12], "inf": 0, "3000": 0, "onc": [0, 4, 8, 12], "n_object": 0, "append_": 0, "multipl": [0, 3, 4, 8, 9, 12], "describ": [0, 6], "below": [0, 4], "child": 0, "mother": 0, "append": [0, 10], "happen": 0, "prevent": [0, 10], "elimin": 0, "macro": [0, 4], "identifi": [0, 1, 4, 9, 12], "expand": 0, "calcul": 0, "user_arg": 0, "escap": 0, "plg_": 0, "so": [0, 1, 2, 3, 4, 8, 10], "interfer": 0, "user": [0, 1, 3, 6, 9], "list_arg": 0, "append_nam": 0, "valid": [0, 10, 12], "correct": [0, 3], "relat": [0, 3], "trail": [0, 8, 11], "suppli": [0, 1], "intern": [0, 3], "kernel_templ": 0, "twice": [0, 8], "second": [0, 4, 8], "fill": [0, 1, 2, 8], "side": [0, 8, 11], "beyond": [0, 1], "therefor": [0, 10, 11], "ill": 0, "form": [0, 3, 4, 5, 9, 12], "2018": [0, 1, 3, 8, 11], "1d": 0, "memoryobject": [0, 1, 3, 4, 7, 8, 10, 12], "latter": [0, 1, 8], "attribut": [0, 1, 4, 6, 8, 9, 10, 11], "omit_list": 0, "iter": 0, "invoc": [0, 4, 10], "omit": 0, "undefin": [0, 1, 8, 10], "dictionari": 0, "total": 0, "combin": [0, 1, 8, 11], "th": [0, 1], "past": [0, 4], "impli": [0, 4], "contigu": [0, 1, 4], "num_nonempty_list": 0, "nonempty_indic": 0, "nonempti": 0, "network": 0, "Will": 0, "power": [0, 3], "2015": [0, 1, 3, 6, 11], "arr": 0, "idx": 0, "overwritten": 0, "track": 0, "sorted_arrai": 0, "someth": 1, "alik": 1, "amount": [1, 8], "integr": [1, 3], "system": [1, 4, 8, 12], "simpl": [1, 4], "map": [1, 3], "straightforwardli": 1, "counterpart": 1, "vec": [1, 4], "float3": 1, "long4": 1, "field": [1, 11], "z": 1, "w": [1, 8], "both": [1, 3, 4, 8, 11], "kernel": [1, 2, 3, 4, 5, 6, 7, 8, 9, 11, 12], "well": [1, 2, 3], "back": [1, 8, 9, 10, 11, 13], "forth": 1, "make_typ": 1, "make_float3": 1, "want": [1, 8, 9], "choos": [1, 9], "zeros_typ": 1, "ones_typ": 1, "filled_typ": 1, "fill_valu": 1, "compon": [1, 4, 8], "been": [1, 12], "flavor": [1, 12], "mention": 1, "your": [1, 3, 4, 8, 12], "struct": [1, 3, 4, 10], "whatev": 1, "those": [1, 4, 8], "similar": [1, 8, 9], "let": [1, 3, 4], "know": [1, 3, 8], "about": [1, 2, 4, 8, 9, 10, 11, 12], "them": [1, 4, 8, 10], "c_name": 1, "list": [1, 3, 4, 5, 7, 8, 9, 10, 11, 12], "registr": 1, "alreadi": [1, 8, 9], "typenamenotknown": 1, "rais": [1, 9, 11], "attempt": [1, 12], "previous": [1, 4, 8, 12], "yet": [1, 2, 4], "error": [1, 3, 4, 8, 11, 12], "partial": 1, "2012": [1, 3, 8, 10], "except": [1, 3, 4, 5, 9, 11, 12], "register_dtyp": [1, 4], "recommend": [1, 9, 10], "develop": [1, 4], "against": [1, 2, 5, 10], "interfac": [1, 4, 5, 7, 8, 9, 10, 11, 12], "dtype_to_ctyp": 1, "match_dtype_to_c_struct": [1, 2, 4], "c_decl": 1, "memori": [1, 3, 4, 10, 13], "layout": [1, 13], "exampl": [1, 2, 3, 4, 8, 10, 11, 12], "pad": 1, "remark": 1, "size": [1, 3, 5, 6, 7, 8, 9, 10, 11, 12, 13], "explain": [1, 3], "id": 1, "id_val": 1, "typedef": [1, 2], "unsign": [1, 13], "u4": 1, "f4": [1, 2], "show": 1, "found": [1, 9, 10, 12], "demo": [1, 3], "reduc": [1, 3], "box": [1, 10], "proce": 1, "sinc": [1, 2, 8], "earlier": [1, 3, 8], "nativ": [1, 10], "around": [1, 4, 8, 10], "defici": 1, "By": [1, 4, 8, 10], "sai": [1, 4], "h": 1, "cfloat_t": 1, "cdouble_t": 1, "cfloat_mul": 1, "cdouble_log": 1, "header": [1, 5, 10], "file": [1, 4, 10], "precis": [1, 9], "need": [1, 4, 8, 11, 12], "doubl": [1, 12], "pleas": [1, 3, 4], "pyopencl_define_cdoubl": 1, "dp": 1, "appar": 1, "cannot": [1, 4, 8], "reliabl": 1, "autodetect": 1, "under": [1, 3, 4, 12], "hood": 1, "ideal": 1, "directli": [1, 8, 9, 10, 11, 12], "incompat": [1, 4], "float2": [1, 4], "double2": [1, 4], "easili": [1, 4, 8, 12, 13], "introduc": [1, 4], "real": [1, 4], "look": [1, 3, 4, 9], "right": [1, 4, 10], "thing": [1, 2, 4, 8, 10], "silent": [1, 4], "wrong": [1, 4, 8], "cq": 1, "shape": [1, 2, 3, 4, 8, 10], "allocatorbas": [1, 12], "stride": [1, 4, 8], "_flag": 1, "_fast": 1, "_size": 1, "_context": 1, "_queue": 1, "exactli": 1, "arithmet": [1, 4, 8], "method": [1, 4, 8, 9, 10, 11], "broadcast": 1, "therebi": [1, 12], "mani": [1, 3, 4, 12], "niceti": [1, 3], "callabl": 1, "upon": [1, 8, 11], "byte": [1, 8, 10, 12], "memorypool": [1, 12], "renam": [1, 4], "cqa": [1, 4], "made": [1, 4, 8, 12, 13], "purpos": [1, 4], "disallow": 1, "fail": [1, 4, 9], "arrayhasoffseterror": [1, 4], "base_data": [1, 4], "unlik": [1, 8, 12], "base": [1, 3, 4, 5], "address": [1, 3], "begin": [1, 4, 8], "plu": 1, "retriev": [1, 4], "succe": [1, 12], "ndim": 1, "meaning": 1, "nbyte": [1, 3], "entir": [1, 8], "items": [1, 4, 8, 12], "step": [1, 2, 4], "travers": 1, "c_contigu": 1, "f_contigu": 1, "forc": 1, "queri": [1, 3, 8, 9, 10, 11], "properti": [1, 4, 6, 7, 8, 9, 11], "analogi": 1, "with_queu": 1, "copi": [1, 3, 4, 8], "__len__": 1, "reshap": 1, "ravel": 1, "flatten": 1, "view": [1, 4, 8], "reinterpret": 1, "squeez": 1, "transpos": 1, "ax": 1, "permut": 1, "revers": [1, 8], "accord": 1, "t": [1, 4, 8, 10], "async_": 1, "transfer": [1, 2, 3, 4, 9, 10, 11], "content": [1, 4], "onto": 1, "necessarili": [1, 4, 8], "To": [1, 4, 8, 10, 12], "avoid": [1, 4], "2017": [1, 3], "make": [1, 3, 4, 5, 7, 8, 9, 10, 11], "async": 1, "reserv": [1, 4], "On": [1, 4], "older": 1, "we": [1, 2, 4, 9], "continu": [1, 3, 4, 10], "accept": [1, 7, 8, 10, 11], "howev": [1, 4, 10, 12], "offici": [1, 3], "spell": 1, "newli": [1, 7], "2019": [1, 12], "replac": [1, 4, 12], "get_async": 1, "asynchron": 1, "nannyev": [1, 4, 8, 11], "_copy_queu": 1, "__str__": 1, "__repr__": [1, 4, 8], "repr": 1, "mul_add": 1, "selffac": 1, "otherfac": 1, "__add__": 1, "__sub__": 1, "subtract": 1, "__iadd__": 1, "__isub__": 1, "__pos__": 1, "__neg__": 1, "__mul__": 1, "__div__": 1, "__rdiv__": 1, "__pow__": 1, "exponenti": 1, "__and__": 1, "__xor__": 1, "__or__": 1, "__iand__": 1, "__ixor__": 1, "__ior__": 1, "__abs__": 1, "absolut": 1, "element": [1, 3, 10], "__invert__": 1, "cast": [1, 10], "imag": [1, 3, 4, 7, 10], "conj": 1, "conjug": 1, "__getitem__": [1, 4, 8], "__setitem__": [1, 4], "subscript": 1, "setitem": 1, "abil": [1, 8], "map_to_host": [1, 4], "is_block": [1, 4, 8], "evt": [1, 2, 10, 11], "enqueue_map_buff": [1, 4, 8], "detail": [1, 4, 8, 11, 12], "map_flag": [1, 3, 6, 8], "read": [1, 4, 6, 8], "int8": [1, 4], "unspecifi": [1, 8, 9], "spec": [1, 8, 10, 11, 13], "__bool__": 1, "__eq__": 1, "__ne__": 1, "__lt__": 1, "__le__": 1, "__gt__": 1, "__ge__": 1, "care": 1, "facil": 1, "section": [1, 7], "add_ev": 1, "too": [1, 4, 8], "long": [1, 4, 8, 10, 12, 13], "implicitli": [1, 8, 12], "subset": 1, "clear": [1, 8], "finish": [1, 8, 11], "val": 1, "array_queu": 1, "_same_as_transf": 1, "exact": [1, 8, 10], "sure": [1, 4, 8, 9], "implicit": [1, 8, 10, 12], "synonym": [1, 12], "uniniti": 1, "other_ari": 1, "zeros_lik": 1, "stop": 1, "apart": 1, "ceil": 1, "rule": 1, "moment": 1, "bound": [1, 12], "textur": [1, 7, 8], "concaten": [1, 4], "stack": [1, 9], "join": 1, "if_posit": 1, "criterion": 1, "then_": 1, "else_": 1, "els": 1, "maximum": 1, "minimum": [1, 8], "logical_and": 1, "x1": 1, "x2": 1, "wise": [1, 3], "AND": [1, 4], "logical_or": 1, "OR": [1, 4], "logical_not": 1, "NOT": [1, 4], "sum": [1, 3, 4, 10], "dot": 1, "vdot": 1, "subset_dot": 1, "max": 1, "min": 1, "subset_max": 1, "subset_min": 1, "count": [1, 3, 8, 12], "clmath": [1, 4], "expos": [1, 4, 8], "standard": [1, 10], "tabl": 1, "8": [1, 4, 9], "aco": 1, "acosh": 1, "acospi": 1, "asin": 1, "asinh": 1, "asinpi": 1, "atan": 1, "atan2": [1, 4], "atanh": 1, "atanpi": 1, "atan2pi": [1, 4], "cbrt": 1, "co": 1, "cosh": 1, "cospi": 1, "erfc": 1, "erf": 1, "exp": 1, "exp2": 1, "exp10": 1, "expm1": 1, "fab": 1, "floor": 1, "fmod": 1, "mod": 1, "remaind": 1, "divis": 1, "frexp": 1, "significand": 1, "expon": 1, "ilogb": 1, "ldexp": 1, "compos": [1, 4], "pair": [1, 9], "togeth": 1, "lgamma": 1, "log2": 1, "log10": 1, "log1p": 1, "logb": 1, "modf": 1, "fracpart": 1, "intpart": 1, "fraction": 1, "nan": 1, "rint": 1, "round": [1, 12], "sin": 1, "sinh": 1, "sinpi": 1, "sqrt": 1, "tan": 1, "tanh": 1, "tanpi": 1, "tgamma": 1, "trunc": 1, "random123": [1, 4], "d": [1, 4, 8], "shaw": [1, 4], "research": [1, 4], "usabl": [1, 4, 12], "conveni": [1, 4, 13], "philox": 1, "threefri": 1, "document": [1, 10, 12], "re": [1, 3, 11], "plan": 1, "had": [1, 10], "ranluxcl": [1, 4], "http": [1, 4], "bitbucket": [1, 4], "org": [1, 4], "ivarun": [1, 4], "ivar": [1, 4], "ursin": [1, 4], "nikolaisen": [1, 4], "slow": 1, "seri": [1, 3, 4], "encourag": 1, "switch": [1, 4], "philoxgener": 1, "threefrygener": 1, "clrandom": [1, 4], "counter": 1, "fill_uniform": 1, "uniform": 1, "fill_norm": 1, "mu": 1, "sigma": 1, "normal": [1, 8], "deviat": 1, "rand": [1, 3], "luxuri": 1, "fill_rand": 1, "usual": 2, "interact": [2, 8, 9], "Then": [2, 4, 12], "line": [2, 4, 8, 12], "my_struct": 2, "field1": 2, "field2": 2, "i4": 2, "Not": [2, 8, 12], "opinion": [2, 4], "laid": 2, "align": [2, 8, 12], "our": 2, "my_struct_c_decl": 2, "tell": 2, "next": [2, 4, 8], "ary_host": 2, "217": 2, "1000": [2, 8], "12": 2, "prg": [2, 3, 8, 10], "__kernel": [2, 3], "set_to_1": 2, "get_global_id": [2, 3], "build": [2, 3, 4, 8, 9, 10], "elwis": 2, "easi": [3, 5], "parallel": [3, 4], "api": [3, 10], "special": [3, 4, 8], "cleanup": [3, 12], "ti": 3, "lifetim": 3, "idiom": 3, "raii": 3, "much": [3, 10, 12], "easier": [3, 11], "leak": 3, "crash": [3, 8, 12], "free": [3, 4, 12], "put": 3, "full": [3, 5], "dispos": 3, "wish": 3, "obscur": 3, "get_info": [3, 4, 8, 9, 10, 11], "translat": 3, "speed": 3, "layer": [3, 4], "written": [3, 4, 10], "virtual": [3, 4, 12], "liber": 3, "licens": 3, "open": 3, "mit": [3, 4], "commerci": 3, "academ": 3, "privat": [3, 6], "impress": 3, "50000": 3, "mf": 3, "mem_flag": [3, 6, 8, 12], "read_onli": [3, 6], "copy_host_ptr": [3, 6], "hostbuf": [3, 4, 8], "const": [3, 6], "gid": 3, "write_onli": [3, 6], "repeat": [3, 6], "allclos": 3, "gaston": 3, "hillar": 3, "dr": 3, "dobb": 3, "journal": [3, 4], "friendli": 3, "introduct": 3, "simon": 3, "mcintosh": 3, "smith": 3, "tom": 3, "deakin": 3, "cours": [3, 8], "hand": [3, 10], "lectur": 3, "slide": 3, "exercis": 3, "solut": [3, 10], "cover": 3, "pasi": 3, "youtub": 3, "dtu": [3, 4], "gpulab": 3, "simula": 3, "problem": [3, 10, 12], "ian": 3, "johnson": 3, "jon": 3, "roos": 3, "pyclbla": 3, "bla": 3, "clbla": 3, "wrapper": [3, 4, 8, 10], "eric": 3, "hunsberg": 3, "lar": 3, "ericson": 3, "cedric": 3, "nugteren": 3, "clblast": 3, "librari": [3, 4, 6, 10], "pyclblast": 3, "gregor": 3, "thalhamm": 3, "gpyfft": 3, "fft": 3, "clfft": 3, "amd": [3, 4, 8, 9, 12], "bogdan": 3, "opanchuk": 3, "reikna": 3, "varieti": 3, "algorithm": [3, 4], "matrix": 3, "design": 3, "troel": 3, "henriksen": 3, "ken": 3, "frii": 3, "larsen": 3, "cosmin": 3, "oancea": 3, "futhark": 3, "languag": [3, 4, 8], "nice": 3, "wai": [3, 4, 10, 11], "nest": [3, 8], "scan": [3, 4, 8], "robbert": 3, "harm": 3, "alard": 3, "roebroeck": 3, "mot": 3, "linear": [3, 6], "optim": 3, "mcmc": 3, "sampl": [3, 8], "vincent": 3, "favr": 3, "nicolin": 3, "pyvkfft": 3, "vkfft": 3, "feel": [3, 4], "me": [3, 9], "better": [3, 4, 8], "send": 3, "patch": [3, 4], "runtim": [3, 4], "report": [3, 4, 12], "constant": [3, 8, 9, 10, 11], "addressing_mod": [3, 4, 6, 8], "channel_ord": [3, 6, 8], "channel_typ": [3, 6, 8], "command_execution_statu": [3, 6, 11], "command_queue_info": [3, 6, 11], "command_queue_properti": [3, 6, 11], "command_typ": [3, 6], "context_info": [3, 6, 9], "context_properti": [3, 6, 7, 9], "device_affinity_domain": [3, 6, 9], "device_atomic_cap": [3, 6], "device_device_enqueue_cap": [3, 6], "device_exec_cap": [3, 6], "device_fp_config": [3, 6], "device_info": [3, 6, 9], "device_local_mem_typ": [3, 6], "device_mem_cache_typ": [3, 6], "device_partition_properti": [3, 6, 9], "device_svm_cap": [3, 6], "device_topology_type_amd": [3, 6], "device_typ": [3, 6, 9], "event_info": [3, 6, 11], "filter_mod": [3, 6, 8], "gl_context_info": [3, 6, 7], "gl_object_typ": [3, 6], "gl_texture_info": [3, 6, 7], "image_info": [3, 6, 8], "kernel_arg_access_qualifi": [3, 6], "kernel_arg_address_qualifi": [3, 6], "kernel_arg_info": [3, 6, 10], "kernel_arg_type_qualifi": [3, 6], "kernel_info": [3, 6, 10], "kernel_sub_group_info": [3, 6], "kernel_work_group_info": [3, 6, 10], "khronos_vendor_id": [3, 6], "mem_info": [3, 6, 8], "mem_migration_flag": [3, 6, 8], "mem_object_typ": [3, 6, 8], "pipe_info": [3, 6, 8], "pipe_properti": [3, 6, 8], "platform_info": [3, 6, 9], "profiling_info": [3, 6, 11], "program_binary_typ": [3, 6], "program_build_info": [3, 6, 10], "program_info": [3, 6, 10], "program_kind": [3, 6], "queue_properti": [3, 6, 11], "sampler_info": [3, 6, 8], "sampler_properti": [3, 6, 8], "status_cod": [3, 6], "svm_mem_flag": [3, 6, 8, 12], "version_bit": [3, 6], "namevers": [3, 6], "devicetopologyamd": [3, 6], "subclass": 3, "migrat": 3, "share": [3, 4, 7, 12], "svm": [3, 4], "sampler": [3, 4, 10], "pipe": [3, 6], "alias": 3, "opengl": [3, 4], "interoper": 3, "have_gl": [3, 6, 7], "get_gl_sharing_context_properti": [3, 7], "get_apple_cgl_share_group": [3, 7], "glbuffer": [3, 7], "glrenderbuff": [3, 7], "gltextur": [3, 7], "enqueue_acquire_gl_object": [3, 7], "enqueue_release_gl_object": [3, 7], "get_gl_context_info_khr": [3, 7], "util": 3, "pool": [3, 4], "cach": [3, 4, 10], "character": [3, 4], "dimension": [3, 8], "express": [3, 4], "evalu": 3, "prefix": [3, 4], "predic": 3, "partit": 3, "uniqu": 3, "sort": 3, "radix": 3, "variabl": [3, 4, 5, 10, 12], "biton": 3, "tos": 3, "instal": [3, 9], "conda": 3, "forg": 3, "pypi": 3, "wheel": 3, "via": [3, 8], "christoph": 3, "gohlk": 3, "window": 3, "tip": 3, "syntax": 3, "highlight": 3, "ipython": 3, "guidelin": 3, "stabil": 3, "bind": 3, "visibl": 3, "unreleas": 3, "2022": [3, 8, 11, 12], "2020": [3, 6, 8, 9, 10, 12], "92": [3, 5, 6, 10, 11], "91": [3, 6, 7, 8, 9, 10, 11], "90": 3, "frequent": [3, 12], "ask": 3, "question": 3, "cite": 3, "acknowledg": 3, "contributor": 3, "fund": 3, "github": [3, 4], "download": [3, 4], "guid": [3, 4], "technologi": 3, "khrono": [3, 4], "web": 3, "site": 3, "search": 3, "page": [3, 4], "far": 4, "easiest": [4, 8], "packag": [4, 10, 13], "repositori": 4, "commun": 4, "maintain": 4, "instruct": [4, 12], "aim": 4, "maco": 4, "analog": [4, 12], "miniforg": 4, "fit": [4, 8], "curl": 4, "l": 4, "o": [4, 7], "com": 4, "latest": 4, "miniforge3": 4, "unam": 4, "m": 4, "sh": 4, "bash": 4, "answer": [4, 9], "pick": 4, "locat": [4, 8, 9, 10, 11], "activ": [4, 7, 12], "root": 4, "account": 4, "administr": 4, "privileg": 4, "environ": [4, 10, 12], "interchang": [4, 12], "common": [4, 8], "anaconda": 4, "exist": [4, 8, 9, 12], "sit": 4, "suggest": 4, "approach": 4, "scratch": 4, "fun": 4, "icd": [4, 9, 10], "client": [4, 9], "hardwar": 4, "messag": 4, "_cl": [4, 8, 9, 10, 11, 12], "logicerror": [4, 5], "clgetplatformid": 4, "platform_not_found_khr": [4, 6], "successfulli": 4, "might": [4, 12], "fact": 4, "enough": [4, 8], "pocl": 4, "mark": [4, 8], "robust": 4, "sometim": 4, "improv": [4, 8], "intel": [4, 12], "rt": 4, "broadwel": 4, "processor": 4, "graphic": 4, "card": 4, "neo": 4, "sandybridg": 4, "beignet": 4, "oclgrind": 4, "detect": 4, "readi": 4, "go": 4, "independ": 4, "fpga": 4, "extens": [4, 6, 8], "directori": [4, 10], "miniconda": 4, "etc": [4, 10], "text": [4, 5], "fulli": [4, 12], "qualifi": [4, 5], "path": [4, 10], "ran": 4, "prompt": 4, "anyth": [4, 10], "env": 4, "environmentnam": 4, "shown": 4, "parenthes": 4, "conda_prefix": 4, "ocl": 4, "wide": 4, "altern": [4, 8, 10], "manual": 4, "inform": [4, 7, 9, 10, 11], "loader": 4, "behind": 4, "libopencl": 4, "ocl_icd_wrapper_appl": 4, "appl": [4, 7], "registri": 4, "most": [4, 8, 9, 10], "popular": 4, "oss": 4, "visit": 4, "come": 4, "bundl": 4, "configur": [4, 8], "group": [4, 7], "pip": 4, "ship": 4, "recogn": 4, "debugg": 4, "mix": 4, "redirect": 4, "still": [4, 8, 12], "former": 4, "wiki": 4, "mostli": 4, "necessari": [4, 8], "unless": [4, 8], "yourself": 4, "vim": 4, "inlin": 4, "tripl": 4, "quot": 4, "seamlessli": 4, "notebook": 4, "load": [4, 8], "load_ext": 4, "ipython_ext": 4, "cl_kernel": [4, 10], "cell": 4, "magic": [4, 10], "demonstr": 4, "fast": [4, 12], "relax": 4, "math": [4, 12], "There": [4, 12], "cl_load_edit_kernel": 4, "cl_kernel_from_fil": 4, "f": 4, "stabl": 4, "That": [4, 8], "doesn": 4, "But": 4, "spew": 4, "warn": [4, 8, 10, 11, 12], "stai": 4, "compat": [4, 10, 11], "futur": [4, 12], "whole": 4, "year": 4, "perhap": 4, "later": [4, 12], "promis": [4, 12], "undocu": 4, "git": 4, "ve": 4, "tri": 4, "cl_": 4, "pep": 4, "lowercas": 4, "word": 4, "underscor": 4, "becom": 4, "creation": [4, 8], "done": 4, "extent": 4, "minim": 4, "factori": 4, "complex": 4, "refus": 4, "temptat": 4, "guess": 4, "leav": 4, "inherit": [4, 7, 8, 10, 12], "from_int_ptr": [4, 8, 9, 10, 11], "int_ptr": [4, 8, 9, 10, 11], "level": [4, 8, 9, 10, 11], "snapshot": 4, "opaqu": 4, "style": [4, 12], "svmpointer": [4, 8, 12], "svmpool": [4, 8, 12], "dealloc": [4, 8, 12], "drop": 4, "fix": [4, 8, 10, 12], "pybind11": 4, "cltype": [4, 13], "less": 4, "spir": [4, 10], "v": [4, 10], "memorymap": [4, 8], "retain": [4, 8, 9, 10, 11, 12], "ownership": [4, 8, 9, 10, 11], "properli": 4, "break": 4, "gl": [4, 6, 7], "interop": 4, "callback": [4, 11], "mingwpi": 4, "ubuntu": 4, "14": 4, "variou": [4, 12], "global_offset": [4, 10], "custom": [4, 6], "rewrit": 4, "cffi": 4, "faster": 4, "launcher": 4, "protocol": [4, 8], "numer": [4, 5], "enqueue_map_imag": [4, 8], "imageformat": [4, 8], "contribut": 4, "alex": 4, "nitz": 4, "vastli": 4, "bessel": 4, "pyopencl_no_cach": [4, 10], "aid": [4, 10], "debug": [4, 10], "favor": 4, "clean": 4, "defaultalloc": 4, "clalloc": [4, 12], "deferredalloc": [4, 12], "immediatealloc": [4, 8, 12], "coincid": 4, "capture_cal": [4, 10], "unintend": 4, "consequ": 4, "due": [4, 12], "3375": 4, "some_pyopencl_arrai": 4, "decid": [4, 10], "probabl": 4, "bright": 4, "idea": 4, "final": 4, "__rmul__": 4, "left": 4, "affect": 4, "unaffect": 4, "suddenli": 4, "extrem": 4, "slowli": 4, "blame": 4, "link": 4, "pull": 4, "request": [4, 8, 10, 12], "experiment": 4, "enqueue_migrate_mem_object": [4, 8], "image_from_arrai": [4, 8], "bugfix": 4, "broken": 4, "henrik": 4, "andresen": 4, "workshop": 4, "strang": 4, "context_dependent_memo": 4, "lion": 4, "enqueue_migrate_mem_objects_ext": 4, "create_sub_devic": [4, 9], "create_sub_devices_ext": 4, "alpha": 4, "crashi": 4, "jan": 4, "meink": 4, "particular": [4, 8, 10], "enqueue_read_buff": 4, "enqueue_write_buff": 4, "enqueue_read_buffer_rect": 4, "enqueue_write_buffer_rect": 4, "enqueue_read_imag": 4, "enqueue_write_imag": 4, "get_host_arrai": [4, 8], "flexibl": 4, "fortran": [4, 8], "among": 4, "fission": 4, "cl_khr_gl_share": [4, 6], "set_arg": [4, 10], "signatur": [4, 8, 11], "emphas": 4, "set_scalar_arg_dtyp": [4, 10], "cl_nv_device_attribute_queri": [4, 6], "boost": 4, "channel_count": [4, 8], "dtype_s": [4, 8], "miss": 4, "enqueue_copy_buff": 4, "enqueue_barri": [4, 11], "No": [4, 8, 10], "host_buff": 4, "place": 4, "captur": 4, "create_context_from_typ": 4, "localmemori": [4, 10], "notabl": 4, "nicer": 4, "represent": [4, 8, 13], "david": 4, "garcia": 4, "suit": 4, "to_str": [4, 6], "colleagu": 4, "pitch": [4, 8], "create_image_2d": 4, "create_image_3d": 4, "enqueue_": 4, "_imag": 4, "reason": [4, 9], "create_program_with_sourc": 4, "create_program_with_binari": 4, "create_buff": 4, "create_host_buff": 4, "get_image_info": [4, 8], "info": [4, 8, 9, 10, 11], "trace": 4, "gnu": 4, "ism": 4, "mac": 4, "consortium": 4, "copyright": 4, "2009": 4, "andrea": 4, "kl\u00f6ckner": 4, "permiss": [4, 8], "herebi": 4, "grant": 4, "charg": 4, "person": 4, "deal": [4, 8], "limit": 4, "merg": 4, "publish": 4, "sublicens": 4, "sell": 4, "permit": [4, 8, 12], "whom": 4, "furnish": 4, "condit": [4, 12], "shall": 4, "substanti": [4, 8], "portion": 4, "THE": 4, "AS": 4, "warranti": 4, "OF": 4, "kind": 4, "BUT": 4, "TO": 4, "merchant": 4, "FOR": 4, "noninfring": 4, "IN": 4, "NO": 4, "author": 4, "holder": 4, "BE": 4, "liabl": 4, "claim": 4, "damag": 4, "liabil": 4, "action": [4, 12], "contract": 4, "tort": 4, "aris": 4, "connect": 4, "WITH": 4, "deriv": 4, "thrust": 4, "2008": 4, "corpor": 4, "apach": 4, "complianc": 4, "www": 4, "law": 4, "agre": 4, "basi": 4, "govern": 4, "awar": [4, 8], "gpl2": 4, "2010": 4, "redistribut": 4, "modif": 4, "met": 4, "disclaim": 4, "reproduc": [4, 10], "materi": 4, "neither": [4, 8, 9], "nor": 4, "endors": 4, "promot": [4, 10], "product": 4, "prior": 4, "BY": 4, "owner": [4, 8, 9, 10, 11], "indirect": 4, "incident": 4, "exemplari": 4, "consequenti": 4, "procur": 4, "substitut": 4, "good": [4, 8], "servic": 4, "loss": 4, "profit": 4, "busi": 4, "interrupt": 4, "caus": 4, "ON": 4, "theori": 4, "strict": 4, "neglig": 4, "IF": 4, "advis": 4, "SUCH": 4, "faq": 4, "collabor": 4, "gratuit": 4, "unrel": 4, "said": 4, "discuss": [4, 10], "aspect": 4, "few": 4, "nicola": 4, "pinto": 4, "yunsup": 4, "lee": 4, "bryan": 4, "catanzaro": 4, "paul": 4, "ivanov": 4, "ahm": 4, "fasih": 4, "pycuda": 4, "script": [4, 12], "volum": 4, "38": 4, "march": 4, "157": 4, "174": 4, "bibtex": 4, "kloeckner_pycuda_2012": 4, "kl": 4, "ckner": 4, "titl": 4, "issn": 4, "0167": 4, "8191": 4, "doi": 4, "1016": 4, "parco": 4, "09": 4, "001": 4, "commit": 4, "pytenti": 4, "u": 4, "nation": 4, "scienc": 4, "foundat": 4, "dm": 4, "1418961": 4, "1654756": 4, "shf": 4, "1911019": 4, "oac": 4, "1931577": 4, "depart": 4, "energi": 4, "nuclear": 4, "secur": 4, "award": 4, "de": 4, "na0003963": 4, "ak": 4, "gratefulli": 4, "gift": 4, "herein": 4, "reflect": [4, 12], "agenc": 4, "float64": [4, 10], "cl_platform_id": [4, 9], "cl_device_id": [4, 9], "cl_context": [4, 9, 11], "cl_command_queu": [4, 11], "cl_mem": [4, 8], "cl_program": [4, 10], "cl_sampler": [4, 8], "cl_event": [4, 11], "clcreatecommandqueuewithproperti": [4, 11], "clcreatesamplerwithproperti": [4, 8], "clcreatepip": [4, 8], "svmalloc": [4, 8, 12], "_program": 4, "93": 5, "version_statu": 5, "rc4": 5, "beta": 5, "statu": [5, 6, 11], "version_text": 5, "93rc4": 5, "get_cl_header_vers": 5, "memoryerror": 5, "runtimeerror": 5, "clamp": 6, "clamp_to_edg": 6, "mirrored_repeat": 6, "abgr": 6, "bgra": 6, "intens": 6, "lumin": 6, "r": [6, 8], "ra": 6, "rg": 6, "rgb": 6, "rgba": [6, 8], "rgbx": 6, "rgx": 6, "rx": 6, "sbgra": 6, "srgb": 6, "srgba": 6, "srgbx": 6, "half_float": 6, "signed_int16": 6, "signed_int32": 6, "signed_int8": 6, "snorm_int16": 6, "snorm_int8": 6, "unorm_int16": 6, "unorm_int24": 6, "unorm_int8": 6, "unorm_int_101010": 6, "unorm_int_101010_2": 6, "unorm_short_555": 6, "unorm_short_565": 6, "unsigned_int16": 6, "unsigned_int32": 6, "unsigned_int8": 6, "queu": [6, 11], "submit": 6, "properties_arrai": 6, "reference_count": 6, "on_devic": 6, "on_device_default": 6, "out_of_order_exec_mode_en": 6, "profiling_en": 6, "acquire_gl_object": 6, "barrier": [6, 11], "copy_buff": 6, "copy_buffer_rect": 6, "copy_buffer_to_imag": 6, "copy_imag": 6, "copy_image_to_buff": 6, "fill_buff": 6, "fill_imag": 6, "map_buff": 6, "map_imag": 6, "migrate_mem_object": 6, "native_kernel": 6, "ndrange_kernel": 6, "read_buff": 6, "read_buffer_rect": 6, "read_imag": 6, "release_gl_object": 6, "svm_free": 6, "svm_map": 6, "svm_memcpi": 6, "svm_memfil": 6, "svm_migrate_mem": 6, "svm_unmap": 6, "task": [6, 10], "unmap_mem_object": 6, "write_buff": 6, "write_buffer_rect": 6, "write_imag": 6, "interop_user_sync": 6, "num_devic": 6, "cgl_sharegroup_khr": 6, "egl_display_khr": 6, "glx_display_khr": 6, "gl_context_khr": 6, "offline_devices_amd": 6, "cl_amd_offline_devic": 6, "wgl_hdc_khr": 6, "l1_cach": [6, 9], "l2_cach": 6, "l3_cach": 6, "l4_cach": 6, "next_partition": 6, "numa": 6, "order_acq_rel": 6, "order_relax": 6, "order_seq_cst": 6, "scope_all_devic": 6, "scope_devic": 6, "scope_work_group": 6, "scope_work_item": 6, "replaceable_default": 6, "correctly_rounded_divide_sqrt": 6, "denorm": 6, "fma": 6, "inf_nan": 6, "round_to_inf": 6, "round_to_nearest": 6, "round_to_zero": 6, "soft_float": 6, "address_bit": 6, "atomic_fence_cap": 6, "atomic_memory_cap": 6, "attribute_async_engine_count_nv": 6, "available_async_queues_amd": 6, "cl_amd_device_attribute_queri": 6, "board_name_amd": 6, "built_in_kernel": 6, "built_in_kernels_with_vers": 6, "compiler_avail": 6, "compute_capability_major_nv": 6, "compute_capability_minor_nv": 6, "device_enqueue_cap": 6, "double_fp_config": 6, "cl_khr_fp64": 6, "driver_vers": 6, "endian_littl": 6, "error_correction_support": 6, "execution_cap": 6, "extensions_with_vers": 6, "ext_mem_padding_in_bytes_qcom": 6, "cl_qcom_ext_host_ptr": 6, "generic_address_space_support": 6, "gfxip_major_amd": 6, "gfxip_minor_amd": 6, "global_free_memory_amd": 6, "global_mem_cacheline_s": 6, "global_mem_cache_s": 6, "global_mem_cache_typ": 6, "global_mem_channels_amd": 6, "global_mem_channel_banks_amd": 6, "global_mem_channel_bank_width_amd": 6, "global_mem_s": 6, "global_variable_preferred_total_s": 6, "gpu_overlap_nv": 6, "half_fp_config": 6, "cl_khr_fp16": 6, "host_unified_memori": 6, "ils_with_vers": 6, "il_vers": 6, "image2d_max_height": 6, "image2d_max_width": 6, "image3d_max_depth": 6, "image3d_max_height": 6, "image3d_max_width": 6, "image_base_address_align": 6, "image_max_array_s": 6, "image_max_buffer_s": 6, "image_pitch_align": 6, "image_support": 6, "integrated_memory_nv": 6, "kernel_exec_timeout_nv": 6, "linker_avail": 6, "local_mem_banks_amd": 6, "local_mem_s": 6, "local_mem_size_per_compute_unit_amd": 6, "local_mem_typ": 6, "max_atomic_counters_ext": 6, "cl_ext_atomic_counters_64": 6, "max_clock_frequ": 6, "max_compute_unit": 6, "max_constant_arg": 6, "max_constant_buffer_s": 6, "max_global_variable_s": 6, "max_mem_alloc_s": 6, "max_num_sub_group": 6, "max_on_device_ev": 6, "max_on_device_queu": 6, "max_parameter_s": 6, "max_pipe_arg": 6, "max_read_image_arg": 6, "max_read_write_image_arg": 6, "max_sampl": 6, "max_work_group_s": 6, "max_work_group_size_amd": 6, "max_work_item_dimens": 6, "max_work_item_s": 6, "max_write_image_arg": 6, "mem_base_addr_align": 6, "me_version_intel": 6, "cl_intel_advanced_motion_estim": 6, "min_data_type_align_s": 6, "native_vector_width_char": 6, "native_vector_width_doubl": 6, "native_vector_width_float": 6, "native_vector_width_half": 6, "native_vector_width_int": 6, "native_vector_width_long": 6, "native_vector_width_short": 6, "non_uniform_work_group_support": 6, "numeric_vers": 6, "num_simultaneous_interops_intel": 6, "cl_intel_simultaneous_shar": 6, "opencl_c_all_vers": 6, "opencl_c_featur": 6, "opencl_c_vers": 6, "page_size_qcom": 6, "parent_devic": 6, "partition_affinity_domain": 6, "partition_max_sub_devic": 6, "partition_properti": 6, "partition_typ": 6, "pcie_id_amd": 6, "pci_bus_id_nv": 6, "pci_domain_id_nv": 6, "pci_slot_id_nv": 6, "pipe_max_active_reserv": 6, "pipe_max_packet_s": 6, "pipe_support": 6, "preferred_constant_buffer_size_amd": 6, "preferred_global_atomic_align": 6, "preferred_interop_user_sync": 6, "preferred_local_atomic_align": 6, "preferred_platform_atomic_align": 6, "preferred_vector_width_char": 6, "preferred_vector_width_doubl": 6, "preferred_vector_width_float": 6, "preferred_vector_width_half": 6, "preferred_vector_width_int": 6, "preferred_vector_width_long": 6, "preferred_vector_width_short": 6, "preferred_work_group_size_amd": 6, "preferred_work_group_size_multipl": 6, "printf_buffer_s": 6, "profiling_timer_offset_amd": 6, "profiling_timer_resolut": 6, "queue_on_device_max_s": 6, "queue_on_device_preferred_s": 6, "queue_on_device_properti": 6, "queue_on_host_properti": 6, "registers_per_block_nv": 6, "simd_instruction_width_amd": 6, "simd_per_compute_unit_amd": 6, "simd_width_amd": 6, "simultaneous_interops_intel": 6, "single_fp_config": 6, "spir_vers": 6, "cl_khr_spir": 6, "sub_group_independent_forward_progress": 6, "svm_capabl": 6, "thread_trace_supported_amd": 6, "topology_amd": 6, "vendor": 6, "vendor_id": 6, "warp_size_nv": 6, "wavefront_width_amd": 6, "work_group_collective_functions_support": 6, "read_only_cach": 6, "read_write_cach": 6, "by_affinity_domain": [6, 9], "by_count": [6, 9], "by_counts_list_end": 6, "atom": 6, "coarse_grain_buff": 6, "fine_grain_buff": 6, "fine_grain_system": 6, "pcie": 6, "acceler": [6, 10], "command_queu": [6, 11], "nearest": 6, "current_device_for_gl_context_khr": 6, "devices_for_gl_context_khr": 6, "renderbuff": 6, "texture2d": 6, "texture3d": 6, "mipmap_level": 6, "texture_target": [6, 7], "array_s": 6, "depth": 6, "element_s": 6, "height": 6, "num_mip_level": 6, "num_sampl": 6, "row_pitch": 6, "slice_pitch": 6, "width": 6, "read_writ": [6, 12], "access_qualifi": 6, "address_qualifi": 6, "type_nam": 6, "type_qualifi": 6, "volatil": 6, "function_nam": 6, "num_arg": 6, "compile_num_sub_group": 6, "local_size_for_sub_group_count": 6, "max_sub_group_size_for_ndrang": 6, "sub_group_count_for_ndrang": 6, "compile_work_group_s": 6, "global_work_s": [6, 10], "private_mem_s": 6, "work_group_s": 6, "codeplai": 6, "write_invalidate_region": 6, "alloc_host_ptr": 6, "host_no_access": 6, "host_read_onli": 6, "host_write_onli": 6, "kernel_read_and_writ": 6, "use_host_ptr": 6, "use_persistent_mem_amd": 6, "cl_amd_device_memory_flag": 6, "associated_memobject": 6, "host_ptr": 6, "map_count": 6, "uses_svm_point": 6, "content_undefin": 6, "image1d": 6, "image1d_arrai": 6, "image1d_buff": 6, "image2d": 6, "image2d_arrai": 6, "image3d": 6, "max_packet": [6, 8], "packet_s": [6, 8], "host_timer_resolut": 6, "compiled_object": 6, "binary_typ": 6, "global_variable_total_s": 6, "binary_s": 6, "il": 6, "kernel_nam": [6, 10], "num_kernel": 6, "scope_global_ctors_pres": 6, "scope_global_dtors_pres": 6, "unknown": 6, "device_default": 6, "lod_max": 6, "lod_max_khr": 6, "cl_khr_mipmap_imag": 6, "lod_min": 6, "lod_min_khr": 6, "mip_filter_mod": 6, "mip_filter_mode_khr": 6, "normalized_coord": [6, 8], "build_program_failur": 6, "compiler_not_avail": 6, "compile_program_failur": 6, "device_not_avail": 6, "device_not_found": 6, "device_partition_fail": 6, "exec_status_error_for_events_in_wait_list": 6, "image_format_mismatch": 6, "image_format_not_support": 6, "invalid_arg_index": 6, "invalid_arg_s": 6, "invalid_arg_valu": 6, "invalid_binari": 6, "invalid_buffer_s": 6, "invalid_build_opt": 6, "invalid_command_queu": 6, "invalid_compiler_opt": 6, "invalid_context": 6, "invalid_devic": 6, "invalid_device_partition_count": 6, "invalid_device_queu": 6, "invalid_device_typ": 6, "invalid_ev": 6, "invalid_event_wait_list": 6, "invalid_global_offset": 6, "invalid_global_work_s": 6, "invalid_gl_object": 6, "invalid_gl_sharegroup_reference_khr": 6, "invalid_host_ptr": 6, "invalid_image_descriptor": 6, "invalid_image_format_descriptor": 6, "invalid_image_s": 6, "invalid_kernel": 6, "invalid_kernel_arg": 6, "invalid_kernel_definit": 6, "invalid_kernel_nam": 6, "invalid_linker_opt": 6, "invalid_mem_object": 6, "invalid_mip_level": 6, "invalid_oper": 6, "invalid_pipe_s": 6, "invalid_platform": 6, "invalid_program": 6, "invalid_program_execut": 6, "invalid_queue_properti": 6, "invalid_sampl": 6, "invalid_spec_id": 6, "invalid_valu": 6, "invalid_work_dimens": 6, "invalid_work_group_s": 6, "invalid_work_item_s": 6, "kernel_arg_info_not_avail": 6, "linker_not_avail": 6, "link_program_failur": 6, "map_failur": 6, "max_size_restriction_exceed": 6, "mem_copy_overlap": 6, "mem_object_allocation_failur": 6, "misaligned_sub_buffer_offset": 6, "out_of_host_memori": 6, "out_of_resourc": 6, "cl_khr_icd": 6, "profiling_info_not_avail": 6, "success": 6, "svm_atom": 6, "svm_fine_grain_buff": 6, "major_bit": 6, "major_mask": 6, "minor_bit": 6, "minor_mask": 6, "patch_bit": 6, "patch_mask": 6, "bu": 6, "handl": [7, 8], "cgl": 7, "bufobj": 7, "gl_object": 7, "miplevel": 7, "dim": 7, "get_gl_texture_info": 7, "param": [7, 8, 9, 10, 11], "mem_object": [7, 8], "param_nam": 7, "egl": 7, "wgl": 7, "lower": [8, 9, 10, 11], "area": [8, 12], "static": [8, 9, 10, 11], "int_ptr_valu": [8, 9, 10, 11], "relev": [8, 9, 10, 11], "clretain": [8, 9, 10, 11], "target": 8, "defer": [8, 12], "attach": [8, 10], "move": [8, 12], "get_sub_region": 8, "slc": 8, "sub": 8, "enqueue_fill_buff": 8, "mem": 8, "pattern": [8, 10], "eg": 8, "reus": 8, "freed": [8, 11, 12], "region": 8, "coars": 8, "grain": 8, "fine": 8, "awai": 8, "bring": 8, "concern": 8, "plain": 8, "perfectli": 8, "legal": 8, "worri": 8, "keep": [8, 12], "aliv": 8, "whenev": 8, "garbag": [8, 12], "collector": [8, 12], "typic": [8, 12], "corrupt": [8, 12], "after": [8, 10, 11, 12], "try": 8, "close": 8, "resembl": 8, "held": [8, 12], "ultim": 8, "buf": 8, "transit": 8, "opposit": 8, "straightforward": [8, 12], "fish": 8, "chain": 8, "main": 8, "eas": [8, 13], "tend": 8, "certain": 8, "anywai": 8, "setup": 8, "while": 8, "accomplish": 8, "subtyp": 8, "svm_ptr": 8, "denot": 8, "explicitli": 8, "svmmap": 8, "map_ro": 8, "map_rw": 8, "as_buff": 8, "eagerli": [8, 12], "irrespect": [8, 12], "pend": [8, 12], "undesir": [8, 12], "enqueue_releas": [8, 12], "bind_to_queu": [8, 12], "suffici": [8, 12], "old": [8, 10], "unbind_from_queu": [8, 12], "longer": 8, "tag": 8, "exhibit": 8, "henc": 8, "slightli": 8, "fsvm_empti": 8, "isinst": 8, "observ": [8, 10, 12], "csvm_empti": 8, "svm_ari": 8, "64": [8, 13], "17": 8, "mere": 8, "relationship": 8, "grab": 8, "kept": 8, "exit": 8, "svm_empti": 8, "belong": 8, "svm_empty_lik": 8, "csvm_empty_lik": 8, "fsvm_empty_lik": 8, "enqueue_svm_memfil": 8, "dest": 8, "byte_count": 8, "entireti": 8, "enqueue_svm_migratemem": 8, "collect": 8, "channel_data_typ": 8, "get_supported_image_format": 8, "image_typ": 8, "is_arrai": 8, "2d": 8, "3d": 8, "distanc": 8, "expect": [8, 12], "fastest": [8, 12], "wherea": 8, "arrang": 8, "convert": [8, 10], "column": 8, "major": [8, 12], "asarrai": 8, "num_channel": 8, "mode": 8, "norm_int": 8, "chosen": [8, 9, 11], "read_imagef": 8, "scale": 8, "enqueue_fill_imag": 8, "color": 8, "src": [8, 10], "unsupport": 8, "Be": 8, "delet": [8, 12], "commonli": 8, "src_offset": 8, "nonzero": 8, "dst_offset": 8, "control": [8, 12], "smaller": [8, 12], "large_dest_numpy_arrai": 8, "src_buffer": 8, "rectangular": 8, "buffer_origin": 8, "shorter": 8, "mandatori": 8, "host_origin": 8, "buffer_pitch": 8, "tightli": 8, "pack": 8, "host_pitch": 8, "src_origin": 8, "dst_origin": 8, "src_pitch": 8, "dst_pitch": 8, "dest_origin": 8, "enqueue_fil": 8, "enqueue_copy_buffer_p2p_amd": 8, "peer": 8, "2023": [8, 11], "unmap": 8, "overrid": 8, "member": 8, "usag": [8, 10], "mapped_buf": 8, "coordin": 8, "natur": 8, "pixel": 8, "2021": [8, 12], "get_pipe_info": 8, "get_platform": 9, "get_devic": 9, "referenc": [9, 10, 11], "hashable_model_and_version_identifi": 9, "model": 9, "softwar": 9, "differenti": 9, "dpp": 9, "partition_by_counts_list_end": 9, "by_nam": 9, "partition_by_names_list_end": 9, "dad": 9, "properties_list_end_ext": 9, "device_and_host_tim": 9, "device_timestamp": 9, "host_timestamp": 9, "host_tim": 9, "dev_typ": 9, "cache_dir": [9, 10], "At": 9, "recent": 9, "driver": 9, "explan": [9, 12], "cl_gl_context_khr": 9, "cl_egl_display_khr": 9, "cl_glx_display_khr": 9, "cl_wgl_hdc_khr": 9, "cl_cgl_sharegroup_khr": 9, "cl_cgl_sharegroup_appl": 9, "pyopengl": 9, "displai": 9, "set_default_device_command_queu": 9, "dev": [9, 12], "somehow": 9, "choic": [9, 12], "sy": 9, "stdin": 9, "isatti": 9, "disk": 10, "save": [10, 13], "suppress": 10, "short": 10, "pyopencl_build_opt": 10, "off": 10, "rather": 10, "get_build_info": 10, "vn": 10, "uidnam": 10, "pyvers": 10, "tempfil": 10, "gettempdir": 10, "lookup": 10, "won": 10, "ev": 10, "enqueue_nd_range_kernel": 10, "stateless": 10, "sum_knl": 10, "state": 10, "prefer": 10, "effici": 10, "ineffect": 10, "all_kernel": 10, "set_specialization_const": 10, "spec_id": 10, "create_program_with_built_in_kernel": 10, "link_program": 10, "unload_platform_compil": 10, "clone": 10, "get_work_group_info": 10, "get_arg_info": 10, "arg_index": 10, "get_sub_group_info": 10, "input_valu": 10, "size_t": 10, "null": 10, "higher": 10, "arg_dtyp": 10, "proper": 10, "n_global": 10, "thread": 10, "safe": [10, 11], "could": 10, "race": 10, "lock": 10, "mail": 10, "octob": 10, "third": 10, "throughout": 10, "cycl": 10, "backward": 10, "bare": 10, "treatment": 10, "output_fil": 10, "filenam": 10, "mainli": 10, "autom": 10, "misbehav": 10, "consum": 10, "outer": 10, "my_kernel": 10, "gsize": 10, "lsize": 10, "arg1": 10, "arg2": 10, "__local": 10, "local_work_s": 10, "global_work_offset": 10, "bitwis": 11, "enqueue_stuff": 11, "delimit": 11, "capabl": [11, 12], "transitionari": 11, "period": 11, "set_properti": 11, "prop": 11, "unavail": 11, "flush": 11, "profilinginfogett": 11, "get_profiling_info": 11, "set_callback": 11, "cb": 11, "userev": 11, "set_statu": 11, "hold": [11, 12], "guard": 11, "destruct": 11, "get_ward": 11, "wait_for_ev": 11, "enqueue_mark": 11, "expens": 12, "fresh": 12, "remedi": 12, "ones": 12, "incur": 12, "realloc": 12, "overhead": 12, "similarli": 12, "react": 12, "appropri": [12, 13], "spuriou": 12, "mem_pool": 12, "a_dev": 12, "likewis": 12, "pooledbuff": 12, "regular": 12, "failur": 12, "leading_bits_in_bin_id": 12, "largest": 12, "four": 12, "role": 12, "pure": 12, "advisori": 12, "scheme": 12, "honor": 12, "held_block": 12, "unus": 12, "active_block": 12, "managed_byt": 12, "active_byt": 12, "free_held": 12, "stop_hold": 12, "fall": 12, "pooledsvm": 12, "came": 12, "possibli": 12, "hash": 12, "dure": 12, "arg0": 12, "first_arg_dependent_memo": 12, "func": 12, "clear_first_arg_cach": 12, "memoiz": 12, "detach": 12, "remain": 12, "pytest_generate_tests_for_pyopencl": 12, "metafunc": 12, "pytest_generate_test": 12, "pytest": 12, "ctx_factori": 12, "pyopencl_test": 12, "i5": 12, "i7": 12, "abstract": 12, "vectorarg": 12, "with_offset": 12, "scalararg": 12, "otherarg": 12, "parse_arg_list": 12, "pars": 12, "clcharacterizationwarn": 12, "get_fast_inaccurate_build_opt": 12, "inaccur": 12, "get_simd_group_s": 12, "type_s": 12, "estim": 12, "across": 12, "simd": 12, "lane": 12, "warp": 12, "wavefront": 12, "has_amd_double_support": 12, "incomplet": 12, "low": 12, "board": 12, "has_struct_arg_count_bug": 12, "local_memory_access_granular": 12, "per": 12, "bank": 12, "local_memory_bank_count": 12, "present": 12, "nv_compute_cap": 12, "minor": 12, "simultaneous_work_items_on_local_access": 12, "simultan": 12, "conflict": 12, "usable_local_mem_s": 12, "narg": 12, "32": 12, "why_not_local_access_conflict_fre": 12, "array_shap": 12, "array_stored_shap": 12, "cl_long": 13, "cl_uint": 13, "uint": 13, "1235": 13, "int64": 13, "128": 13, "storag": 13, "array_of_float16": 13, "float16": 13}, "objects": {"": [[4, 0, 1, "c.clCreateCommandQueueWithProperties", "clCreateCommandQueueWithProperties"], [4, 0, 1, "c.clCreatePipe", "clCreatePipe"], [4, 0, 1, "c.clCreateSamplerWithProperties", "clCreateSamplerWithProperties"], [4, 1, 1, "c.cl_command_queue", "cl_command_queue"], [4, 1, 1, "c.cl_context", "cl_context"], [4, 1, 1, "c.cl_device_id", "cl_device_id"], [4, 1, 1, "c.cl_event", "cl_event"], [4, 1, 1, "c.cl_kernel", "cl_kernel"], [4, 1, 1, "c.cl_mem", "cl_mem"], [4, 1, 1, "c.cl_platform_id", "cl_platform_id"], [4, 1, 1, "c.cl_program", "cl_program"], [4, 1, 1, "c.cl_sampler", "cl_sampler"], [5, 3, 0, "-", "pyopencl"], [10, 10, 1, "-", "PYOPENCL_BUILD_OPTIONS"], [10, 10, 1, "-", "PYOPENCL_NO_CACHE"]], "numpy": [[4, 2, 1, "", "float64"], [4, 2, 1, "", "int32"], [4, 2, 1, "", "int8"]], "pyopencl": [[8, 2, 1, "", "Buffer"], [11, 2, 1, "", "CommandQueue"], [9, 2, 1, "", "Context"], [9, 2, 1, "", "Device"], [6, 2, 1, "", "DeviceTopologyAmd"], [5, 2, 1, "", "Error"], [11, 2, 1, "", "Event"], [7, 2, 1, "", "GLBuffer"], [7, 2, 1, "", "GLRenderBuffer"], [7, 2, 1, "", "GLTexture"], [8, 2, 1, "", "Image"], [8, 2, 1, "", "ImageFormat"], [10, 2, 1, "", "Kernel"], [10, 2, 1, "", "LocalMemory"], [5, 2, 1, "", "LogicError"], [5, 2, 1, "", "MemoryError"], [8, 2, 1, "", "MemoryMap"], [8, 2, 1, "", "MemoryObject"], [6, 2, 1, "", "NameVersion"], [11, 2, 1, "", "NannyEvent"], [8, 2, 1, "", "Pipe"], [9, 2, 1, "", "Platform"], [11, 2, 1, "", "ProfilingInfoGetter"], [10, 2, 1, "", "Program"], [5, 2, 1, "", "RuntimeError"], [8, 2, 1, "", "SVM"], [8, 2, 1, "", "SVMAllocation"], [8, 2, 1, "", "SVMMap"], [8, 2, 1, "", "SVMPointer"], [8, 2, 1, "", "Sampler"], [11, 2, 1, "", "UserEvent"], [5, 7, 1, "", "VERSION"], [5, 7, 1, "", "VERSION_STATUS"], [5, 7, 1, "", "VERSION_TEXT"], [6, 2, 1, "", "addressing_mode"], [0, 3, 0, "-", "algorithm"], [1, 3, 0, "-", "array"], [0, 3, 0, "-", "bitonic_sort"], [6, 2, 1, "", "channel_order"], [6, 2, 1, "", "channel_type"], [12, 3, 0, "-", "characterize"], [1, 3, 0, "-", "clmath"], [1, 3, 0, "-", "clrandom"], [13, 3, 0, "-", "cltypes"], [6, 2, 1, "", "command_execution_status"], [6, 2, 1, "", "command_queue_info"], [6, 2, 1, "", "command_queue_properties"], [6, 2, 1, "", "command_type"], [6, 2, 1, "", "context_info"], [6, 2, 1, "", "context_properties"], [10, 8, 1, "", "create_program_with_built_in_kernels"], [9, 8, 1, "", "create_some_context"], [8, 8, 1, "", "csvm_empty"], [8, 8, 1, "", "csvm_empty_like"], [6, 2, 1, "", "device_affinity_domain"], [6, 2, 1, "", "device_atomic_capabilities"], [6, 2, 1, "", "device_device_enqueue_capabilities"], [6, 2, 1, "", "device_exec_capabilities"], [6, 2, 1, "", "device_fp_config"], [6, 2, 1, "", "device_info"], [6, 2, 1, "", "device_local_mem_type"], [6, 2, 1, "", "device_mem_cache_type"], [6, 2, 1, "", "device_partition_property"], [6, 2, 1, "", "device_svm_capabilities"], [6, 2, 1, "", "device_topology_type_amd"], [6, 2, 1, "", "device_type"], [0, 3, 0, "-", "elementwise"], [7, 8, 1, "", "enqueue_acquire_gl_objects"], [11, 8, 1, "", "enqueue_barrier"], [8, 8, 1, "", "enqueue_copy"], [8, 8, 1, "", "enqueue_copy_buffer_p2p_amd"], [8, 8, 1, "", "enqueue_fill"], [8, 8, 1, "", "enqueue_fill_buffer"], [8, 8, 1, "", "enqueue_fill_image"], [8, 8, 1, "", "enqueue_map_buffer"], [8, 8, 1, "", "enqueue_map_image"], [11, 8, 1, "", "enqueue_marker"], [8, 8, 1, "", "enqueue_migrate_mem_objects"], [10, 8, 1, "", "enqueue_nd_range_kernel"], [7, 8, 1, "", "enqueue_release_gl_objects"], [8, 8, 1, "", "enqueue_svm_memfill"], [8, 8, 1, "", "enqueue_svm_migratemem"], [6, 2, 1, "", "event_info"], [6, 2, 1, "", "filter_mode"], [8, 8, 1, "", "fsvm_empty"], [8, 8, 1, "", "fsvm_empty_like"], [7, 8, 1, "", "get_apple_cgl_share_group"], [5, 8, 1, "", "get_cl_header_version"], [7, 8, 1, "", "get_gl_context_info_khr"], [7, 8, 1, "", "get_gl_sharing_context_properties"], [9, 8, 1, "", "get_platforms"], [8, 8, 1, "", "get_supported_image_formats"], [6, 2, 1, "", "gl_context_info"], [6, 2, 1, "", "gl_object_type"], [6, 2, 1, "", "gl_texture_info"], [7, 8, 1, "", "have_gl"], [8, 8, 1, "", "image_from_array"], [6, 2, 1, "", "image_info"], [6, 2, 1, "", "kernel_arg_access_qualifier"], [6, 2, 1, "", "kernel_arg_address_qualifier"], [6, 2, 1, "", "kernel_arg_info"], [6, 2, 1, "", "kernel_arg_type_qualifier"], [6, 2, 1, "", "kernel_info"], [6, 2, 1, "", "kernel_sub_group_info"], [6, 2, 1, "", "kernel_work_group_info"], [6, 2, 1, "", "khronos_vendor_id"], [10, 8, 1, "", "link_program"], [6, 2, 1, "", "map_flags"], [6, 2, 1, "", "mem_flags"], [6, 2, 1, "", "mem_info"], [6, 2, 1, "", "mem_migration_flags"], [6, 2, 1, "", "mem_object_type"], [6, 2, 1, "", "pipe_info"], [6, 2, 1, "", "pipe_properties"], [6, 2, 1, "", "platform_info"], [6, 2, 1, "", "profiling_info"], [6, 2, 1, "", "program_binary_type"], [6, 2, 1, "", "program_build_info"], [6, 2, 1, "", "program_info"], [6, 2, 1, "", "program_kind"], [6, 2, 1, "", "queue_properties"], [0, 3, 0, "-", "reduction"], [6, 2, 1, "", "sampler_info"], [6, 2, 1, "", "sampler_properties"], [0, 3, 0, "-", "scan"], [6, 2, 1, "", "status_code"], [8, 8, 1, "", "svm_empty"], [8, 8, 1, "", "svm_empty_like"], [6, 2, 1, "", "svm_mem_flags"], [12, 3, 0, "-", "tools"], [10, 8, 1, "", "unload_platform_compiler"], [6, 2, 1, "", "version_bits"], [11, 8, 1, "", "wait_for_events"]], "pyopencl.Buffer": [[8, 4, 1, "", "__getitem__"], [8, 4, 1, "", "get_sub_region"]], "pyopencl.CommandQueue": [[11, 4, 1, "", "finish"], [11, 4, 1, "", "flush"], [11, 4, 1, "", "from_int_ptr"], [11, 4, 1, "", "get_info"], [11, 5, 1, "", "info"], [11, 5, 1, "", "int_ptr"], [11, 4, 1, "", "set_property"]], "pyopencl.Context": [[9, 4, 1, "", "from_int_ptr"], [9, 4, 1, "", "get_info"], [9, 5, 1, "", "info"], [9, 5, 1, "", "int_ptr"], [9, 4, 1, "", "set_default_device_command_queue"]], "pyopencl.Device": [[9, 4, 1, "", "create_sub_devices"], [9, 4, 1, "", "device_and_host_timer"], [9, 4, 1, "", "from_int_ptr"], [9, 4, 1, "", "get_info"], [9, 5, 1, "", "hashable_model_and_version_identifier"], [9, 4, 1, "", "host_timer"], [9, 5, 1, "", "info"], [9, 5, 1, "", "int_ptr"]], "pyopencl.DeviceTopologyAmd": [[6, 4, 1, "", "__init__"], [6, 5, 1, "", "bus"], [6, 5, 1, "", "device"], [6, 5, 1, "", "function"], [6, 5, 1, "", "type"]], "pyopencl.Event": [[11, 4, 1, "", "from_int_ptr"], [11, 4, 1, "", "get_info"], [11, 4, 1, "", "get_profiling_info"], [11, 5, 1, "", "info"], [11, 5, 1, "", "int_ptr"], [11, 5, 1, "", "profile"], [11, 4, 1, "", "set_callback"], [11, 4, 1, "", "wait"]], "pyopencl.GLBuffer": [[7, 5, 1, "", "gl_object"]], "pyopencl.GLRenderBuffer": [[7, 5, 1, "", "gl_object"]], "pyopencl.GLTexture": [[7, 4, 1, "", "get_gl_texture_info"], [7, 5, 1, "", "gl_object"]], "pyopencl.Image": [[8, 4, 1, "", "get_image_info"], [8, 5, 1, "", "info"], [8, 4, 1, "", "release"], [8, 5, 1, "", "shape"]], "pyopencl.ImageFormat": [[8, 4, 1, "", "__repr__"], [8, 5, 1, "", "channel_count"], [8, 5, 1, "", "channel_data_type"], [8, 5, 1, "", "channel_order"], [8, 5, 1, "", "dtype_size"], [8, 5, 1, "", "itemsize"]], "pyopencl.Kernel": [[10, 4, 1, "", "__call__"], [10, 4, 1, "", "capture_call"], [10, 4, 1, "", "clone"], [10, 4, 1, "", "from_int_ptr"], [10, 4, 1, "", "get_arg_info"], [10, 4, 1, "", "get_info"], [10, 4, 1, "", "get_sub_group_info"], [10, 4, 1, "", "get_work_group_info"], [10, 5, 1, "", "info"], [10, 5, 1, "", "int_ptr"], [10, 4, 1, "", "set_arg"], [10, 4, 1, "", "set_args"], [10, 4, 1, "", "set_scalar_arg_dtypes"]], "pyopencl.LocalMemory": [[10, 5, 1, "", "size"]], "pyopencl.MemoryMap": [[8, 4, 1, "", "release"]], "pyopencl.MemoryObject": [[8, 4, 1, "", "from_int_ptr"], [8, 4, 1, "", "get_host_array"], [8, 4, 1, "", "get_info"], [8, 5, 1, "", "hostbuf"], [8, 5, 1, "", "info"], [8, 5, 1, "", "int_ptr"], [8, 4, 1, "", "release"]], "pyopencl.NameVersion": [[6, 4, 1, "", "__init__"], [6, 5, 1, "", "name"], [6, 5, 1, "", "version"]], "pyopencl.NannyEvent": [[11, 4, 1, "", "get_ward"], [11, 4, 1, "", "wait"]], "pyopencl.Pipe": [[8, 4, 1, "", "get_pipe_info"]], "pyopencl.Platform": [[9, 4, 1, "", "from_int_ptr"], [9, 4, 1, "", "get_devices"], [9, 4, 1, "", "get_info"], [9, 5, 1, "", "info"], [9, 5, 1, "", "int_ptr"]], "pyopencl.ProfilingInfoGetter": [[11, 5, 1, "", "info"]], "pyopencl.Program": [[10, 4, 1, "", "all_kernels"], [10, 4, 1, "", "build"], [10, 4, 1, "", "compile"], [10, 4, 1, "", "from_int_ptr"], [10, 4, 1, "", "get_build_info"], [10, 4, 1, "", "get_info"], [10, 5, 1, "", "info"], [10, 5, 1, "", "int_ptr"], [10, 5, 1, "", "kernel_name"], [10, 4, 1, "", "set_specialization_constant"]], "pyopencl.SVM": [[8, 4, 1, "", "__init__"], [8, 4, 1, "", "map"], [8, 4, 1, "", "map_ro"], [8, 4, 1, "", "map_rw"], [8, 5, 1, "", "mem"]], "pyopencl.SVMAllocation": [[8, 4, 1, "", "__init__"], [8, 4, 1, "", "bind_to_queue"], [8, 4, 1, "", "enqueue_release"], [8, 4, 1, "", "unbind_from_queue"]], "pyopencl.SVMMap": [[8, 6, 1, "", "event"], [8, 4, 1, "", "release"]], "pyopencl.SVMPointer": [[8, 4, 1, "", "as_buffer"], [8, 6, 1, "", "buf"], [8, 4, 1, "", "map"], [8, 4, 1, "", "map_ro"], [8, 4, 1, "", "map_rw"], [8, 6, 1, "", "size"], [8, 6, 1, "", "svm_ptr"]], "pyopencl.Sampler": [[8, 4, 1, "", "__init__"], [8, 4, 1, "", "from_int_ptr"], [8, 4, 1, "", "get_info"], [8, 5, 1, "", "info"], [8, 5, 1, "", "int_ptr"]], "pyopencl.UserEvent": [[11, 4, 1, "", "set_status"]], "pyopencl._cl": [[12, 2, 1, "", "AllocatorBase"], [8, 2, 1, "", "Buffer"], [4, 2, 1, "", "CommandQueue"], [4, 2, 1, "", "Context"], [4, 2, 1, "", "Device"], [4, 2, 1, "", "Event"], [4, 2, 1, "", "Kernel"], [4, 2, 1, "", "MemoryMap"], [4, 2, 1, "", "Platform"], [4, 2, 1, "", "Program"], [4, 2, 1, "", "SVMAllocation"], [4, 2, 1, "", "Sampler"], [4, 2, 1, "", "_Program"]], "pyopencl.addressing_mode": [[6, 5, 1, "", "CLAMP"], [6, 5, 1, "", "CLAMP_TO_EDGE"], [6, 5, 1, "", "MIRRORED_REPEAT"], [6, 5, 1, "", "NONE"], [6, 5, 1, "", "REPEAT"], [6, 4, 1, "", "to_string"]], "pyopencl.algorithm": [[0, 2, 1, "", "ListOfListsBuilder"], [0, 2, 1, "", "RadixSort"], [0, 8, 1, "", "copy_if"], [0, 8, 1, "", "partition"], [0, 8, 1, "", "remove_if"], [0, 8, 1, "", "unique"]], "pyopencl.algorithm.ListOfListsBuilder": [[0, 4, 1, "", "__call__"], [0, 4, 1, "", "__init__"]], "pyopencl.algorithm.RadixSort": [[0, 4, 1, "", "__call__"]], "pyopencl.array": [[1, 2, 1, "", "Array"], [1, 9, 1, "", "ArrayHasOffsetError"], [1, 8, 1, "", "all"], [1, 8, 1, "", "any"], [1, 8, 1, "", "arange"], [1, 8, 1, "", "concatenate"], [1, 8, 1, "", "dot"], [1, 8, 1, "", "empty"], [1, 8, 1, "", "empty_like"], [1, 8, 1, "", "if_positive"], [1, 8, 1, "", "logical_and"], [1, 8, 1, "", "logical_not"], [1, 8, 1, "", "logical_or"], [1, 8, 1, "", "max"], [1, 8, 1, "", "maximum"], [1, 8, 1, "", "min"], [1, 8, 1, "", "minimum"], [1, 8, 1, "", "reshape"], [1, 8, 1, "", "stack"], [1, 8, 1, "", "subset_dot"], [1, 8, 1, "", "subset_max"], [1, 8, 1, "", "subset_min"], [1, 8, 1, "", "sum"], [1, 8, 1, "", "take"], [1, 8, 1, "", "to_device"], [1, 8, 1, "", "transpose"], [1, 8, 1, "", "vdot"], [1, 2, 1, "", "vec"], [1, 8, 1, "", "zeros"], [1, 8, 1, "", "zeros_like"]], "pyopencl.array.Array": [[1, 5, 1, "", "T"], [1, 4, 1, "", "__abs__"], [1, 4, 1, "", "__add__"], [1, 4, 1, "", "__and__"], [1, 4, 1, "", "__bool__"], [1, 4, 1, "", "__div__"], [1, 4, 1, "", "__eq__"], [1, 4, 1, "", "__ge__"], [1, 4, 1, "", "__getitem__"], [1, 4, 1, "", "__gt__"], [1, 4, 1, "", "__iadd__"], [1, 4, 1, "", "__iand__"], [1, 4, 1, "", "__invert__"], [1, 4, 1, "", "__ior__"], [1, 4, 1, "", "__isub__"], [1, 4, 1, "", "__ixor__"], [1, 4, 1, "", "__le__"], [1, 4, 1, "", "__len__"], [1, 4, 1, "", "__lt__"], [1, 4, 1, "", "__mul__"], [1, 4, 1, "", "__ne__"], [1, 4, 1, "", "__neg__"], [1, 4, 1, "", "__or__"], [1, 4, 1, "", "__pos__"], [1, 4, 1, "", "__pow__"], [1, 4, 1, "", "__rdiv__"], [1, 4, 1, "", "__repr__"], [1, 4, 1, "", "__setitem__"], [1, 4, 1, "", "__str__"], [1, 4, 1, "", "__sub__"], [1, 4, 1, "", "__xor__"], [1, 4, 1, "", "add_event"], [1, 4, 1, "", "all"], [1, 4, 1, "", "any"], [1, 4, 1, "", "astype"], [1, 5, 1, "", "base_data"], [1, 4, 1, "", "conj"], [1, 4, 1, "", "conjugate"], [1, 4, 1, "", "copy"], [1, 5, 1, "", "data"], [1, 5, 1, "", "dtype"], [1, 5, 1, "", "events"], [1, 4, 1, "", "fill"], [1, 4, 1, "", "finish"], [1, 5, 1, "", "flags"], [1, 4, 1, "", "get"], [1, 4, 1, "", "get_async"], [1, 5, 1, "", "imag"], [1, 4, 1, "", "map_to_host"], [1, 4, 1, "", "mul_add"], [1, 5, 1, "", "nbytes"], [1, 5, 1, "", "ndim"], [1, 5, 1, "", "offset"], [1, 4, 1, "", "ravel"], [1, 5, 1, "", "real"], [1, 4, 1, "", "reshape"], [1, 4, 1, "", "set"], [1, 4, 1, "", "setitem"], [1, 5, 1, "", "shape"], [1, 5, 1, "", "size"], [1, 4, 1, "", "squeeze"], [1, 5, 1, "", "strides"], [1, 4, 1, "", "transpose"], [1, 4, 1, "", "view"], [1, 4, 1, "", "with_queue"]], "pyopencl.bitonic_sort": [[0, 2, 1, "", "BitonicSort"]], "pyopencl.bitonic_sort.BitonicSort": [[0, 4, 1, "", "__call__"]], "pyopencl.channel_order": [[6, 5, 1, "", "A"], [6, 5, 1, "", "ABGR"], [6, 5, 1, "", "BGRA"], [6, 5, 1, "", "INTENSITY"], [6, 5, 1, "", "LUMINANCE"], [6, 5, 1, "", "R"], [6, 5, 1, "", "RA"], [6, 5, 1, "", "RG"], [6, 5, 1, "", "RGB"], [6, 5, 1, "", "RGBA"], [6, 5, 1, "", "RGBx"], [6, 5, 1, "", "RGx"], [6, 5, 1, "", "Rx"], [6, 5, 1, "", "sBGRA"], [6, 5, 1, "", "sRGB"], [6, 5, 1, "", "sRGBA"], [6, 5, 1, "", "sRGBx"], [6, 4, 1, "", "to_string"]], "pyopencl.channel_type": [[6, 5, 1, "", "FLOAT"], [6, 5, 1, "", "HALF_FLOAT"], [6, 5, 1, "", "SIGNED_INT16"], [6, 5, 1, "", "SIGNED_INT32"], [6, 5, 1, "", "SIGNED_INT8"], [6, 5, 1, "", "SNORM_INT16"], [6, 5, 1, "", "SNORM_INT8"], [6, 5, 1, "", "UNORM_INT16"], [6, 5, 1, "", "UNORM_INT24"], [6, 5, 1, "", "UNORM_INT8"], [6, 5, 1, "", "UNORM_INT_101010"], [6, 5, 1, "", "UNORM_INT_101010_2"], [6, 5, 1, "", "UNORM_SHORT_555"], [6, 5, 1, "", "UNORM_SHORT_565"], [6, 5, 1, "", "UNSIGNED_INT16"], [6, 5, 1, "", "UNSIGNED_INT32"], [6, 5, 1, "", "UNSIGNED_INT8"], [6, 4, 1, "", "to_string"]], "pyopencl.characterize": [[12, 9, 1, "", "CLCharacterizationWarning"], [12, 8, 1, "", "get_fast_inaccurate_build_options"], [12, 8, 1, "", "get_simd_group_size"], [12, 8, 1, "", "has_amd_double_support"], [12, 8, 1, "", "has_struct_arg_count_bug"], [12, 8, 1, "", "local_memory_access_granularity"], [12, 8, 1, "", "local_memory_bank_count"], [12, 8, 1, "", "nv_compute_capability"], [12, 8, 1, "", "simultaneous_work_items_on_local_access"], [12, 8, 1, "", "usable_local_mem_size"], [12, 8, 1, "", "why_not_local_access_conflict_free"]], "pyopencl.clmath": [[1, 8, 1, "", "acos"], [1, 8, 1, "", "acosh"], [1, 8, 1, "", "acospi"], [1, 8, 1, "", "asin"], [1, 8, 1, "", "asinh"], [1, 8, 1, "", "asinpi"], [1, 8, 1, "", "atan"], [1, 8, 1, "", "atan2"], [1, 8, 1, "", "atan2pi"], [1, 8, 1, "", "atanh"], [1, 8, 1, "", "atanpi"], [1, 8, 1, "", "cbrt"], [1, 8, 1, "", "ceil"], [1, 8, 1, "", "cos"], [1, 8, 1, "", "cosh"], [1, 8, 1, "", "cospi"], [1, 8, 1, "", "erf"], [1, 8, 1, "", "erfc"], [1, 8, 1, "", "exp"], [1, 8, 1, "", "exp10"], [1, 8, 1, "", "exp2"], [1, 8, 1, "", "expm1"], [1, 8, 1, "", "fabs"], [1, 8, 1, "", "floor"], [1, 8, 1, "", "fmod"], [1, 8, 1, "", "frexp"], [1, 8, 1, "", "ilogb"], [1, 8, 1, "", "ldexp"], [1, 8, 1, "", "lgamma"], [1, 8, 1, "", "log"], [1, 8, 1, "", "log10"], [1, 8, 1, "", "log1p"], [1, 8, 1, "", "log2"], [1, 8, 1, "", "logb"], [1, 8, 1, "", "modf"], [1, 8, 1, "", "nan"], [1, 8, 1, "", "rint"], [1, 8, 1, "", "round"], [1, 8, 1, "", "sin"], [1, 8, 1, "", "sinh"], [1, 8, 1, "", "sinpi"], [1, 8, 1, "", "sqrt"], [1, 8, 1, "", "tan"], [1, 8, 1, "", "tanh"], [1, 8, 1, "", "tanpi"], [1, 8, 1, "", "tgamma"], [1, 8, 1, "", "trunc"]], "pyopencl.clrandom": [[1, 2, 1, "", "PhiloxGenerator"], [1, 2, 1, "", "ThreefryGenerator"], [1, 8, 1, "", "fill_rand"], [1, 8, 1, "", "rand"]], "pyopencl.clrandom.PhiloxGenerator": [[1, 4, 1, "", "fill_normal"], [1, 4, 1, "", "fill_uniform"], [1, 4, 1, "", "normal"], [1, 4, 1, "", "uniform"]], "pyopencl.clrandom.ThreefryGenerator": [[1, 4, 1, "", "fill_normal"], [1, 4, 1, "", "fill_uniform"], [1, 4, 1, "", "normal"], [1, 4, 1, "", "uniform"]], "pyopencl.command_execution_status": [[6, 5, 1, "", "COMPLETE"], [6, 5, 1, "", "QUEUED"], [6, 5, 1, "", "RUNNING"], [6, 5, 1, "", "SUBMITTED"], [6, 4, 1, "", "to_string"]], "pyopencl.command_queue_info": [[6, 5, 1, "", "CONTEXT"], [6, 5, 1, "", "DEVICE"], [6, 5, 1, "", "PROPERTIES"], [6, 5, 1, "", "PROPERTIES_ARRAY"], [6, 5, 1, "", "REFERENCE_COUNT"], [6, 4, 1, "", "to_string"]], "pyopencl.command_queue_properties": [[6, 5, 1, "", "ON_DEVICE"], [6, 5, 1, "", "ON_DEVICE_DEFAULT"], [6, 5, 1, "", "OUT_OF_ORDER_EXEC_MODE_ENABLE"], [6, 5, 1, "", "PROFILING_ENABLE"], [6, 4, 1, "", "to_string"]], "pyopencl.command_type": [[6, 5, 1, "", "ACQUIRE_GL_OBJECTS"], [6, 5, 1, "", "BARRIER"], [6, 5, 1, "", "COPY_BUFFER"], [6, 5, 1, "", "COPY_BUFFER_RECT"], [6, 5, 1, "", "COPY_BUFFER_TO_IMAGE"], [6, 5, 1, "", "COPY_IMAGE"], [6, 5, 1, "", "COPY_IMAGE_TO_BUFFER"], [6, 5, 1, "", "FILL_BUFFER"], [6, 5, 1, "", "FILL_IMAGE"], [6, 5, 1, "", "MAP_BUFFER"], [6, 5, 1, "", "MAP_IMAGE"], [6, 5, 1, "", "MARKER"], [6, 5, 1, "", "MIGRATE_MEM_OBJECTS"], [6, 5, 1, "", "NATIVE_KERNEL"], [6, 5, 1, "", "NDRANGE_KERNEL"], [6, 5, 1, "", "READ_BUFFER"], [6, 5, 1, "", "READ_BUFFER_RECT"], [6, 5, 1, "", "READ_IMAGE"], [6, 5, 1, "", "RELEASE_GL_OBJECTS"], [6, 5, 1, "", "SVM_FREE"], [6, 5, 1, "", "SVM_MAP"], [6, 5, 1, "", "SVM_MEMCPY"], [6, 5, 1, "", "SVM_MEMFILL"], [6, 5, 1, "", "SVM_MIGRATE_MEM"], [6, 5, 1, "", "SVM_UNMAP"], [6, 5, 1, "", "TASK"], [6, 5, 1, "", "UNMAP_MEM_OBJECT"], [6, 5, 1, "", "USER"], [6, 5, 1, "", "WRITE_BUFFER"], [6, 5, 1, "", "WRITE_BUFFER_RECT"], [6, 5, 1, "", "WRITE_IMAGE"], [6, 4, 1, "", "to_string"]], "pyopencl.context_info": [[6, 5, 1, "", "DEVICES"], [6, 5, 1, "", "INTEROP_USER_SYNC"], [6, 5, 1, "", "NUM_DEVICES"], [6, 5, 1, "", "PROPERTIES"], [6, 5, 1, "", "REFERENCE_COUNT"], [6, 4, 1, "", "to_string"]], "pyopencl.context_properties": [[6, 5, 1, "", "CGL_SHAREGROUP_KHR"], [6, 5, 1, "", "EGL_DISPLAY_KHR"], [6, 5, 1, "", "GLX_DISPLAY_KHR"], [6, 5, 1, "", "GL_CONTEXT_KHR"], [6, 5, 1, "", "OFFLINE_DEVICES_AMD"], [6, 5, 1, "", "PLATFORM"], [6, 5, 1, "", "WGL_HDC_KHR"], [6, 4, 1, "", "to_string"]], "pyopencl.device_affinity_domain": [[6, 5, 1, "", "L1_CACHE"], [6, 5, 1, "", "L2_CACHE"], [6, 5, 1, "", "L3_CACHE"], [6, 5, 1, "", "L4_CACHE"], [6, 5, 1, "", "NEXT_PARTITIONABLE"], [6, 5, 1, "", "NUMA"], [6, 4, 1, "", "to_string"]], "pyopencl.device_atomic_capabilities": [[6, 5, 1, "", "ORDER_ACQ_REL"], [6, 5, 1, "", "ORDER_RELAXED"], [6, 5, 1, "", "ORDER_SEQ_CST"], [6, 5, 1, "", "SCOPE_ALL_DEVICES"], [6, 5, 1, "", "SCOPE_DEVICE"], [6, 5, 1, "", "SCOPE_WORK_GROUP"], [6, 5, 1, "", "SCOPE_WORK_ITEM"], [6, 4, 1, "", "to_string"]], "pyopencl.device_device_enqueue_capabilities": [[6, 5, 1, "", "REPLACEABLE_DEFAULT"], [6, 5, 1, "", "SUPPORTED"], [6, 4, 1, "", "to_string"]], "pyopencl.device_exec_capabilities": [[6, 5, 1, "", "KERNEL"], [6, 5, 1, "", "NATIVE_KERNEL"], [6, 4, 1, "", "to_string"]], "pyopencl.device_fp_config": [[6, 5, 1, "", "CORRECTLY_ROUNDED_DIVIDE_SQRT"], [6, 5, 1, "", "DENORM"], [6, 5, 1, "", "FMA"], [6, 5, 1, "", "INF_NAN"], [6, 5, 1, "", "ROUND_TO_INF"], [6, 5, 1, "", "ROUND_TO_NEAREST"], [6, 5, 1, "", "ROUND_TO_ZERO"], [6, 5, 1, "", "SOFT_FLOAT"], [6, 4, 1, "", "to_string"]], "pyopencl.device_info": [[6, 5, 1, "", "ADDRESS_BITS"], [6, 5, 1, "", "ATOMIC_FENCE_CAPABILITIES"], [6, 5, 1, "", "ATOMIC_MEMORY_CAPABILITIES"], [6, 5, 1, "", "ATTRIBUTE_ASYNC_ENGINE_COUNT_NV"], [6, 5, 1, "", "AVAILABLE"], [6, 5, 1, "", "AVAILABLE_ASYNC_QUEUES_AMD"], [6, 5, 1, "", "BOARD_NAME_AMD"], [6, 5, 1, "", "BUILT_IN_KERNELS"], [6, 5, 1, "", "BUILT_IN_KERNELS_WITH_VERSION"], [6, 5, 1, "", "COMPILER_AVAILABLE"], [6, 5, 1, "", "COMPUTE_CAPABILITY_MAJOR_NV"], [6, 5, 1, "", "COMPUTE_CAPABILITY_MINOR_NV"], [6, 5, 1, "", "DEVICE_ENQUEUE_CAPABILITIES"], [6, 5, 1, "", "DOUBLE_FP_CONFIG"], [6, 5, 1, "", "DRIVER_VERSION"], [6, 5, 1, "", "ENDIAN_LITTLE"], [6, 5, 1, "", "ERROR_CORRECTION_SUPPORT"], [6, 5, 1, "", "EXECUTION_CAPABILITIES"], [6, 5, 1, "", "EXTENSIONS"], [6, 5, 1, "", "EXTENSIONS_WITH_VERSION"], [6, 5, 1, "", "EXT_MEM_PADDING_IN_BYTES_QCOM"], [6, 5, 1, "", "GENERIC_ADDRESS_SPACE_SUPPORT"], [6, 5, 1, "", "GFXIP_MAJOR_AMD"], [6, 5, 1, "", "GFXIP_MINOR_AMD"], [6, 5, 1, "", "GLOBAL_FREE_MEMORY_AMD"], [6, 5, 1, "", "GLOBAL_MEM_CACHELINE_SIZE"], [6, 5, 1, "", "GLOBAL_MEM_CACHE_SIZE"], [6, 5, 1, "", "GLOBAL_MEM_CACHE_TYPE"], [6, 5, 1, "", "GLOBAL_MEM_CHANNELS_AMD"], [6, 5, 1, "", "GLOBAL_MEM_CHANNEL_BANKS_AMD"], [6, 5, 1, "", "GLOBAL_MEM_CHANNEL_BANK_WIDTH_AMD"], [6, 5, 1, "", "GLOBAL_MEM_SIZE"], [6, 5, 1, "", "GLOBAL_VARIABLE_PREFERRED_TOTAL_SIZE"], [6, 5, 1, "", "GPU_OVERLAP_NV"], [6, 5, 1, "", "HALF_FP_CONFIG"], [6, 5, 1, "", "HOST_UNIFIED_MEMORY"], [6, 5, 1, "", "ILS_WITH_VERSION"], [6, 5, 1, "", "IL_VERSION"], [6, 5, 1, "", "IMAGE2D_MAX_HEIGHT"], [6, 5, 1, "", "IMAGE2D_MAX_WIDTH"], [6, 5, 1, "", "IMAGE3D_MAX_DEPTH"], [6, 5, 1, "", "IMAGE3D_MAX_HEIGHT"], [6, 5, 1, "", "IMAGE3D_MAX_WIDTH"], [6, 5, 1, "", "IMAGE_BASE_ADDRESS_ALIGNMENT"], [6, 5, 1, "", "IMAGE_MAX_ARRAY_SIZE"], [6, 5, 1, "", "IMAGE_MAX_BUFFER_SIZE"], [6, 5, 1, "", "IMAGE_PITCH_ALIGNMENT"], [6, 5, 1, "", "IMAGE_SUPPORT"], [6, 5, 1, "", "INTEGRATED_MEMORY_NV"], [6, 5, 1, "", "KERNEL_EXEC_TIMEOUT_NV"], [6, 5, 1, "", "LINKER_AVAILABLE"], [6, 5, 1, "", "LOCAL_MEM_BANKS_AMD"], [6, 5, 1, "", "LOCAL_MEM_SIZE"], [6, 5, 1, "", "LOCAL_MEM_SIZE_PER_COMPUTE_UNIT_AMD"], [6, 5, 1, "", "LOCAL_MEM_TYPE"], [6, 5, 1, "", "MAX_ATOMIC_COUNTERS_EXT"], [6, 5, 1, "", "MAX_CLOCK_FREQUENCY"], [6, 5, 1, "", "MAX_COMPUTE_UNITS"], [6, 5, 1, "", "MAX_CONSTANT_ARGS"], [6, 5, 1, "", "MAX_CONSTANT_BUFFER_SIZE"], [6, 5, 1, "", "MAX_GLOBAL_VARIABLE_SIZE"], [6, 5, 1, "", "MAX_MEM_ALLOC_SIZE"], [6, 5, 1, "", "MAX_NUM_SUB_GROUPS"], [6, 5, 1, "", "MAX_ON_DEVICE_EVENTS"], [6, 5, 1, "", "MAX_ON_DEVICE_QUEUES"], [6, 5, 1, "", "MAX_PARAMETER_SIZE"], [6, 5, 1, "", "MAX_PIPE_ARGS"], [6, 5, 1, "", "MAX_READ_IMAGE_ARGS"], [6, 5, 1, "", "MAX_READ_WRITE_IMAGE_ARGS"], [6, 5, 1, "", "MAX_SAMPLERS"], [6, 5, 1, "", "MAX_WORK_GROUP_SIZE"], [6, 5, 1, "", "MAX_WORK_GROUP_SIZE_AMD"], [6, 5, 1, "", "MAX_WORK_ITEM_DIMENSIONS"], [6, 5, 1, "", "MAX_WORK_ITEM_SIZES"], [6, 5, 1, "", "MAX_WRITE_IMAGE_ARGS"], [6, 5, 1, "", "MEM_BASE_ADDR_ALIGN"], [6, 5, 1, "", "ME_VERSION_INTEL"], [6, 5, 1, "", "MIN_DATA_TYPE_ALIGN_SIZE"], [6, 5, 1, "", "NAME"], [6, 5, 1, "", "NATIVE_VECTOR_WIDTH_CHAR"], [6, 5, 1, "", "NATIVE_VECTOR_WIDTH_DOUBLE"], [6, 5, 1, "", "NATIVE_VECTOR_WIDTH_FLOAT"], [6, 5, 1, "", "NATIVE_VECTOR_WIDTH_HALF"], [6, 5, 1, "", "NATIVE_VECTOR_WIDTH_INT"], [6, 5, 1, "", "NATIVE_VECTOR_WIDTH_LONG"], [6, 5, 1, "", "NATIVE_VECTOR_WIDTH_SHORT"], [6, 5, 1, "", "NON_UNIFORM_WORK_GROUP_SUPPORT"], [6, 5, 1, "", "NUMERIC_VERSION"], [6, 5, 1, "", "NUM_SIMULTANEOUS_INTEROPS_INTEL"], [6, 5, 1, "", "OPENCL_C_ALL_VERSIONS"], [6, 5, 1, "", "OPENCL_C_FEATURES"], [6, 5, 1, "", "OPENCL_C_VERSION"], [6, 5, 1, "", "PAGE_SIZE_QCOM"], [6, 5, 1, "", "PARENT_DEVICE"], [6, 5, 1, "", "PARTITION_AFFINITY_DOMAIN"], [6, 5, 1, "", "PARTITION_MAX_SUB_DEVICES"], [6, 5, 1, "", "PARTITION_PROPERTIES"], [6, 5, 1, "", "PARTITION_TYPE"], [6, 5, 1, "", "PCIE_ID_AMD"], [6, 5, 1, "", "PCI_BUS_ID_NV"], [6, 5, 1, "", "PCI_DOMAIN_ID_NV"], [6, 5, 1, "", "PCI_SLOT_ID_NV"], [6, 5, 1, "", "PIPE_MAX_ACTIVE_RESERVATIONS"], [6, 5, 1, "", "PIPE_MAX_PACKET_SIZE"], [6, 5, 1, "", "PIPE_SUPPORT"], [6, 5, 1, "", "PLATFORM"], [6, 5, 1, "", "PREFERRED_CONSTANT_BUFFER_SIZE_AMD"], [6, 5, 1, "", "PREFERRED_GLOBAL_ATOMIC_ALIGNMENT"], [6, 5, 1, "", "PREFERRED_INTEROP_USER_SYNC"], [6, 5, 1, "", "PREFERRED_LOCAL_ATOMIC_ALIGNMENT"], [6, 5, 1, "", "PREFERRED_PLATFORM_ATOMIC_ALIGNMENT"], [6, 5, 1, "", "PREFERRED_VECTOR_WIDTH_CHAR"], [6, 5, 1, "", "PREFERRED_VECTOR_WIDTH_DOUBLE"], [6, 5, 1, "", "PREFERRED_VECTOR_WIDTH_FLOAT"], [6, 5, 1, "", "PREFERRED_VECTOR_WIDTH_HALF"], [6, 5, 1, "", "PREFERRED_VECTOR_WIDTH_INT"], [6, 5, 1, "", "PREFERRED_VECTOR_WIDTH_LONG"], [6, 5, 1, "", "PREFERRED_VECTOR_WIDTH_SHORT"], [6, 5, 1, "", "PREFERRED_WORK_GROUP_SIZE_AMD"], [6, 5, 1, "", "PREFERRED_WORK_GROUP_SIZE_MULTIPLE"], [6, 5, 1, "", "PRINTF_BUFFER_SIZE"], [6, 5, 1, "", "PROFILE"], [6, 5, 1, "", "PROFILING_TIMER_OFFSET_AMD"], [6, 5, 1, "", "PROFILING_TIMER_RESOLUTION"], [6, 5, 1, "", "QUEUE_ON_DEVICE_MAX_SIZE"], [6, 5, 1, "", "QUEUE_ON_DEVICE_PREFERRED_SIZE"], [6, 5, 1, "", "QUEUE_ON_DEVICE_PROPERTIES"], [6, 5, 1, "", "QUEUE_ON_HOST_PROPERTIES"], [6, 5, 1, "", "QUEUE_PROPERTIES"], [6, 5, 1, "", "REFERENCE_COUNT"], [6, 5, 1, "", "REGISTERS_PER_BLOCK_NV"], [6, 5, 1, "", "SIMD_INSTRUCTION_WIDTH_AMD"], [6, 5, 1, "", "SIMD_PER_COMPUTE_UNIT_AMD"], [6, 5, 1, "", "SIMD_WIDTH_AMD"], [6, 5, 1, "", "SIMULTANEOUS_INTEROPS_INTEL"], [6, 5, 1, "", "SINGLE_FP_CONFIG"], [6, 5, 1, "", "SPIR_VERSIONS"], [6, 5, 1, "", "SUB_GROUP_INDEPENDENT_FORWARD_PROGRESS"], [6, 5, 1, "", "SVM_CAPABILITIES"], [6, 5, 1, "", "THREAD_TRACE_SUPPORTED_AMD"], [6, 5, 1, "", "TOPOLOGY_AMD"], [6, 5, 1, "", "TYPE"], [6, 5, 1, "", "VENDOR"], [6, 5, 1, "", "VENDOR_ID"], [6, 5, 1, "", "VERSION"], [6, 5, 1, "", "WARP_SIZE_NV"], [6, 5, 1, "", "WAVEFRONT_WIDTH_AMD"], [6, 5, 1, "", "WORK_GROUP_COLLECTIVE_FUNCTIONS_SUPPORT"], [6, 4, 1, "", "to_string"]], "pyopencl.device_local_mem_type": [[6, 5, 1, "", "GLOBAL"], [6, 5, 1, "", "LOCAL"], [6, 4, 1, "", "to_string"]], "pyopencl.device_mem_cache_type": [[6, 5, 1, "", "NONE"], [6, 5, 1, "", "READ_ONLY_CACHE"], [6, 5, 1, "", "READ_WRITE_CACHE"], [6, 4, 1, "", "to_string"]], "pyopencl.device_partition_property": [[6, 5, 1, "", "BY_AFFINITY_DOMAIN"], [6, 5, 1, "", "BY_COUNTS"], [6, 5, 1, "", "BY_COUNTS_LIST_END"], [6, 5, 1, "", "EQUALLY"], [6, 4, 1, "", "to_string"]], "pyopencl.device_svm_capabilities": [[6, 5, 1, "", "ATOMICS"], [6, 5, 1, "", "COARSE_GRAIN_BUFFER"], [6, 5, 1, "", "FINE_GRAIN_BUFFER"], [6, 5, 1, "", "FINE_GRAIN_SYSTEM"], [6, 4, 1, "", "to_string"]], "pyopencl.device_topology_type_amd": [[6, 5, 1, "", "PCIE"], [6, 4, 1, "", "to_string"]], "pyopencl.device_type": [[6, 5, 1, "", "ACCELERATOR"], [6, 5, 1, "", "ALL"], [6, 5, 1, "", "CPU"], [6, 5, 1, "", "CUSTOM"], [6, 5, 1, "", "DEFAULT"], [6, 5, 1, "", "GPU"], [6, 4, 1, "", "to_string"]], "pyopencl.elementwise": [[0, 2, 1, "", "ElementwiseKernel"]], "pyopencl.elementwise.ElementwiseKernel": [[0, 4, 1, "", "__call__"]], "pyopencl.event_info": [[6, 5, 1, "", "COMMAND_EXECUTION_STATUS"], [6, 5, 1, "", "COMMAND_QUEUE"], [6, 5, 1, "", "COMMAND_TYPE"], [6, 5, 1, "", "CONTEXT"], [6, 5, 1, "", "REFERENCE_COUNT"], [6, 4, 1, "", "to_string"]], "pyopencl.filter_mode": [[6, 5, 1, "", "LINEAR"], [6, 5, 1, "", "NEAREST"], [6, 4, 1, "", "to_string"]], "pyopencl.gl_context_info": [[6, 5, 1, "", "CURRENT_DEVICE_FOR_GL_CONTEXT_KHR"], [6, 5, 1, "", "DEVICES_FOR_GL_CONTEXT_KHR"], [6, 4, 1, "", "to_string"]], "pyopencl.gl_object_type": [[6, 5, 1, "", "BUFFER"], [6, 5, 1, "", "RENDERBUFFER"], [6, 5, 1, "", "TEXTURE2D"], [6, 5, 1, "", "TEXTURE3D"], [6, 4, 1, "", "to_string"]], "pyopencl.gl_texture_info": [[6, 5, 1, "", "MIPMAP_LEVEL"], [6, 5, 1, "", "TEXTURE_TARGET"], [6, 4, 1, "", "to_string"]], "pyopencl.image_info": [[6, 5, 1, "", "ARRAY_SIZE"], [6, 5, 1, "", "BUFFER"], [6, 5, 1, "", "DEPTH"], [6, 5, 1, "", "ELEMENT_SIZE"], [6, 5, 1, "", "FORMAT"], [6, 5, 1, "", "HEIGHT"], [6, 5, 1, "", "NUM_MIP_LEVELS"], [6, 5, 1, "", "NUM_SAMPLES"], [6, 5, 1, "", "ROW_PITCH"], [6, 5, 1, "", "SLICE_PITCH"], [6, 5, 1, "", "WIDTH"], [6, 4, 1, "", "to_string"]], "pyopencl.kernel_arg_access_qualifier": [[6, 5, 1, "", "NONE"], [6, 5, 1, "", "READ_ONLY"], [6, 5, 1, "", "READ_WRITE"], [6, 5, 1, "", "WRITE_ONLY"], [6, 4, 1, "", "to_string"]], "pyopencl.kernel_arg_address_qualifier": [[6, 5, 1, "", "CONSTANT"], [6, 5, 1, "", "GLOBAL"], [6, 5, 1, "", "LOCAL"], [6, 5, 1, "", "PRIVATE"], [6, 4, 1, "", "to_string"]], "pyopencl.kernel_arg_info": [[6, 5, 1, "", "ACCESS_QUALIFIER"], [6, 5, 1, "", "ADDRESS_QUALIFIER"], [6, 5, 1, "", "NAME"], [6, 5, 1, "", "TYPE_NAME"], [6, 5, 1, "", "TYPE_QUALIFIER"], [6, 4, 1, "", "to_string"]], "pyopencl.kernel_arg_type_qualifier": [[6, 5, 1, "", "CONST"], [6, 5, 1, "", "NONE"], [6, 5, 1, "", "PIPE"], [6, 5, 1, "", "RESTRICT"], [6, 5, 1, "", "VOLATILE"], [6, 4, 1, "", "to_string"]], "pyopencl.kernel_info": [[6, 5, 1, "", "ATTRIBUTES"], [6, 5, 1, "", "CONTEXT"], [6, 5, 1, "", "FUNCTION_NAME"], [6, 5, 1, "", "NUM_ARGS"], [6, 5, 1, "", "PROGRAM"], [6, 5, 1, "", "REFERENCE_COUNT"], [6, 4, 1, "", "to_string"]], "pyopencl.kernel_sub_group_info": [[6, 5, 1, "", "COMPILE_NUM_SUB_GROUPS"], [6, 5, 1, "", "LOCAL_SIZE_FOR_SUB_GROUP_COUNT"], [6, 5, 1, "", "MAX_NUM_SUB_GROUPS"], [6, 5, 1, "", "MAX_SUB_GROUP_SIZE_FOR_NDRANGE"], [6, 5, 1, "", "SUB_GROUP_COUNT_FOR_NDRANGE"], [6, 4, 1, "", "to_string"]], "pyopencl.kernel_work_group_info": [[6, 5, 1, "", "COMPILE_WORK_GROUP_SIZE"], [6, 5, 1, "", "GLOBAL_WORK_SIZE"], [6, 5, 1, "", "LOCAL_MEM_SIZE"], [6, 5, 1, "", "PREFERRED_WORK_GROUP_SIZE_MULTIPLE"], [6, 5, 1, "", "PRIVATE_MEM_SIZE"], [6, 5, 1, "", "WORK_GROUP_SIZE"], [6, 4, 1, "", "to_string"]], "pyopencl.khronos_vendor_id": [[6, 5, 1, "", "CODEPLAY"], [6, 4, 1, "", "to_string"]], "pyopencl.map_flags": [[6, 5, 1, "", "READ"], [6, 5, 1, "", "WRITE"], [6, 5, 1, "", "WRITE_INVALIDATE_REGION"], [6, 4, 1, "", "to_string"]], "pyopencl.mem_flags": [[6, 5, 1, "", "ALLOC_HOST_PTR"], [6, 5, 1, "", "COPY_HOST_PTR"], [6, 5, 1, "", "HOST_NO_ACCESS"], [6, 5, 1, "", "HOST_READ_ONLY"], [6, 5, 1, "", "HOST_WRITE_ONLY"], [6, 5, 1, "", "KERNEL_READ_AND_WRITE"], [6, 5, 1, "", "READ_ONLY"], [6, 5, 1, "", "READ_WRITE"], [6, 5, 1, "", "USE_HOST_PTR"], [6, 5, 1, "", "USE_PERSISTENT_MEM_AMD"], [6, 5, 1, "", "WRITE_ONLY"], [6, 4, 1, "", "to_string"]], "pyopencl.mem_info": [[6, 5, 1, "", "ASSOCIATED_MEMOBJECT"], [6, 5, 1, "", "CONTEXT"], [6, 5, 1, "", "FLAGS"], [6, 5, 1, "", "HOST_PTR"], [6, 5, 1, "", "MAP_COUNT"], [6, 5, 1, "", "OFFSET"], [6, 5, 1, "", "PROPERTIES"], [6, 5, 1, "", "REFERENCE_COUNT"], [6, 5, 1, "", "SIZE"], [6, 5, 1, "", "TYPE"], [6, 5, 1, "", "USES_SVM_POINTER"], [6, 4, 1, "", "to_string"]], "pyopencl.mem_migration_flags": [[6, 5, 1, "", "CONTENT_UNDEFINED"], [6, 5, 1, "", "HOST"], [6, 4, 1, "", "to_string"]], "pyopencl.mem_object_type": [[6, 5, 1, "", "BUFFER"], [6, 5, 1, "", "IMAGE1D"], [6, 5, 1, "", "IMAGE1D_ARRAY"], [6, 5, 1, "", "IMAGE1D_BUFFER"], [6, 5, 1, "", "IMAGE2D"], [6, 5, 1, "", "IMAGE2D_ARRAY"], [6, 5, 1, "", "IMAGE3D"], [6, 5, 1, "", "PIPE"], [6, 4, 1, "", "to_string"]], "pyopencl.pipe_info": [[6, 5, 1, "", "MAX_PACKETS"], [6, 5, 1, "", "PACKET_SIZE"], [6, 5, 1, "", "PROPERTIES"], [6, 4, 1, "", "to_string"]], "pyopencl.pipe_properties": [[6, 5, 1, "", "MAX_PACKETS"], [6, 5, 1, "", "PACKET_SIZE"], [6, 4, 1, "", "to_string"]], "pyopencl.platform_info": [[6, 5, 1, "", "EXTENSIONS"], [6, 5, 1, "", "EXTENSIONS_WITH_VERSION"], [6, 5, 1, "", "HOST_TIMER_RESOLUTION"], [6, 5, 1, "", "NAME"], [6, 5, 1, "", "NUMERIC_VERSION"], [6, 5, 1, "", "PROFILE"], [6, 5, 1, "", "VENDOR"], [6, 5, 1, "", "VERSION"], [6, 4, 1, "", "to_string"]], "pyopencl.profiling_info": [[6, 5, 1, "", "COMPLETE"], [6, 5, 1, "", "END"], [6, 5, 1, "", "QUEUED"], [6, 5, 1, "", "START"], [6, 5, 1, "", "SUBMIT"], [6, 4, 1, "", "to_string"]], "pyopencl.program_binary_type": [[6, 5, 1, "", "COMPILED_OBJECT"], [6, 5, 1, "", "EXECUTABLE"], [6, 5, 1, "", "LIBRARY"], [6, 5, 1, "", "NONE"], [6, 4, 1, "", "to_string"]], "pyopencl.program_build_info": [[6, 5, 1, "", "BINARY_TYPE"], [6, 5, 1, "", "GLOBAL_VARIABLE_TOTAL_SIZE"], [6, 5, 1, "", "LOG"], [6, 5, 1, "", "OPTIONS"], [6, 5, 1, "", "STATUS"], [6, 4, 1, "", "to_string"]], "pyopencl.program_info": [[6, 5, 1, "", "BINARIES"], [6, 5, 1, "", "BINARY_SIZES"], [6, 5, 1, "", "CONTEXT"], [6, 5, 1, "", "DEVICES"], [6, 5, 1, "", "IL"], [6, 5, 1, "", "KERNEL_NAMES"], [6, 5, 1, "", "NUM_DEVICES"], [6, 5, 1, "", "NUM_KERNELS"], [6, 5, 1, "", "REFERENCE_COUNT"], [6, 5, 1, "", "SCOPE_GLOBAL_CTORS_PRESENT"], [6, 5, 1, "", "SCOPE_GLOBAL_DTORS_PRESENT"], [6, 5, 1, "", "SOURCE"], [6, 4, 1, "", "to_string"]], "pyopencl.program_kind": [[6, 5, 1, "", "BINARY"], [6, 5, 1, "", "IL"], [6, 5, 1, "", "SOURCE"], [6, 5, 1, "", "UNKNOWN"], [6, 5, 1, "", "name"], [6, 4, 1, "", "to_string"], [6, 5, 1, "", "value"]], "pyopencl.queue_properties": [[6, 5, 1, "", "DEVICE_DEFAULT"], [6, 5, 1, "", "PROPERTIES"], [6, 5, 1, "", "SIZE"], [6, 4, 1, "", "to_string"]], "pyopencl.reduction": [[0, 2, 1, "", "ReductionKernel"]], "pyopencl.reduction.ReductionKernel": [[0, 4, 1, "", "__call__"], [0, 4, 1, "", "__init__"]], "pyopencl.sampler_info": [[6, 5, 1, "", "ADDRESSING_MODE"], [6, 5, 1, "", "CONTEXT"], [6, 5, 1, "", "FILTER_MODE"], [6, 5, 1, "", "LOD_MAX"], [6, 5, 1, "", "LOD_MAX_KHR"], [6, 5, 1, "", "LOD_MIN"], [6, 5, 1, "", "LOD_MIN_KHR"], [6, 5, 1, "", "MIP_FILTER_MODE"], [6, 5, 1, "", "MIP_FILTER_MODE_KHR"], [6, 5, 1, "", "NORMALIZED_COORDS"], [6, 5, 1, "", "PROPERTIES"], [6, 5, 1, "", "REFERENCE_COUNT"], [6, 4, 1, "", "to_string"]], "pyopencl.sampler_properties": [[6, 5, 1, "", "ADDRESSING_MODE"], [6, 5, 1, "", "FILTER_MODE"], [6, 5, 1, "", "NORMALIZED_COORDS"], [6, 4, 1, "", "to_string"]], "pyopencl.scan": [[0, 2, 1, "", "ExclusiveScanKernel"], [0, 2, 1, "", "GenericDebugScanKernel"], [0, 2, 1, "", "GenericScanKernel"], [0, 2, 1, "", "InclusiveScanKernel"]], "pyopencl.scan.ExclusiveScanKernel": [[0, 4, 1, "", "__call__"]], "pyopencl.scan.GenericDebugScanKernel": [[0, 4, 1, "", "__call__"]], "pyopencl.scan.GenericScanKernel": [[0, 4, 1, "", "__call__"], [0, 4, 1, "", "__init__"]], "pyopencl.status_code": [[6, 5, 1, "", "BUILD_PROGRAM_FAILURE"], [6, 5, 1, "", "COMPILER_NOT_AVAILABLE"], [6, 5, 1, "", "COMPILE_PROGRAM_FAILURE"], [6, 5, 1, "", "DEVICE_NOT_AVAILABLE"], [6, 5, 1, "", "DEVICE_NOT_FOUND"], [6, 5, 1, "", "DEVICE_PARTITION_FAILED"], [6, 5, 1, "", "EXEC_STATUS_ERROR_FOR_EVENTS_IN_WAIT_LIST"], [6, 5, 1, "", "IMAGE_FORMAT_MISMATCH"], [6, 5, 1, "", "IMAGE_FORMAT_NOT_SUPPORTED"], [6, 5, 1, "", "INVALID_ARG_INDEX"], [6, 5, 1, "", "INVALID_ARG_SIZE"], [6, 5, 1, "", "INVALID_ARG_VALUE"], [6, 5, 1, "", "INVALID_BINARY"], [6, 5, 1, "", "INVALID_BUFFER_SIZE"], [6, 5, 1, "", "INVALID_BUILD_OPTIONS"], [6, 5, 1, "", "INVALID_COMMAND_QUEUE"], [6, 5, 1, "", "INVALID_COMPILER_OPTIONS"], [6, 5, 1, "", "INVALID_CONTEXT"], [6, 5, 1, "", "INVALID_DEVICE"], [6, 5, 1, "", "INVALID_DEVICE_PARTITION_COUNT"], [6, 5, 1, "", "INVALID_DEVICE_QUEUE"], [6, 5, 1, "", "INVALID_DEVICE_TYPE"], [6, 5, 1, "", "INVALID_EVENT"], [6, 5, 1, "", "INVALID_EVENT_WAIT_LIST"], [6, 5, 1, "", "INVALID_GLOBAL_OFFSET"], [6, 5, 1, "", "INVALID_GLOBAL_WORK_SIZE"], [6, 5, 1, "", "INVALID_GL_OBJECT"], [6, 5, 1, "", "INVALID_GL_SHAREGROUP_REFERENCE_KHR"], [6, 5, 1, "", "INVALID_HOST_PTR"], [6, 5, 1, "", "INVALID_IMAGE_DESCRIPTOR"], [6, 5, 1, "", "INVALID_IMAGE_FORMAT_DESCRIPTOR"], [6, 5, 1, "", "INVALID_IMAGE_SIZE"], [6, 5, 1, "", "INVALID_KERNEL"], [6, 5, 1, "", "INVALID_KERNEL_ARGS"], [6, 5, 1, "", "INVALID_KERNEL_DEFINITION"], [6, 5, 1, "", "INVALID_KERNEL_NAME"], [6, 5, 1, "", "INVALID_LINKER_OPTIONS"], [6, 5, 1, "", "INVALID_MEM_OBJECT"], [6, 5, 1, "", "INVALID_MIP_LEVEL"], [6, 5, 1, "", "INVALID_OPERATION"], [6, 5, 1, "", "INVALID_PIPE_SIZE"], [6, 5, 1, "", "INVALID_PLATFORM"], [6, 5, 1, "", "INVALID_PROGRAM"], [6, 5, 1, "", "INVALID_PROGRAM_EXECUTABLE"], [6, 5, 1, "", "INVALID_QUEUE_PROPERTIES"], [6, 5, 1, "", "INVALID_SAMPLER"], [6, 5, 1, "", "INVALID_SPEC_ID"], [6, 5, 1, "", "INVALID_VALUE"], [6, 5, 1, "", "INVALID_WORK_DIMENSION"], [6, 5, 1, "", "INVALID_WORK_GROUP_SIZE"], [6, 5, 1, "", "INVALID_WORK_ITEM_SIZE"], [6, 5, 1, "", "KERNEL_ARG_INFO_NOT_AVAILABLE"], [6, 5, 1, "", "LINKER_NOT_AVAILABLE"], [6, 5, 1, "", "LINK_PROGRAM_FAILURE"], [6, 5, 1, "", "MAP_FAILURE"], [6, 5, 1, "", "MAX_SIZE_RESTRICTION_EXCEEDED"], [6, 5, 1, "", "MEM_COPY_OVERLAP"], [6, 5, 1, "", "MEM_OBJECT_ALLOCATION_FAILURE"], [6, 5, 1, "", "MISALIGNED_SUB_BUFFER_OFFSET"], [6, 5, 1, "", "OUT_OF_HOST_MEMORY"], [6, 5, 1, "", "OUT_OF_RESOURCES"], [6, 5, 1, "", "PLATFORM_NOT_FOUND_KHR"], [6, 5, 1, "", "PROFILING_INFO_NOT_AVAILABLE"], [6, 5, 1, "", "SUCCESS"], [6, 4, 1, "", "to_string"]], "pyopencl.svm_mem_flags": [[6, 5, 1, "", "READ_ONLY"], [6, 5, 1, "", "READ_WRITE"], [6, 5, 1, "", "SVM_ATOMICS"], [6, 5, 1, "", "SVM_FINE_GRAIN_BUFFER"], [6, 5, 1, "", "WRITE_ONLY"], [6, 4, 1, "", "to_string"]], "pyopencl.tools": [[12, 2, 1, "", "AllocatorBase"], [12, 2, 1, "", "Argument"], [12, 2, 1, "", "DeferredAllocator"], [12, 2, 1, "", "DtypedArgument"], [12, 2, 1, "", "ImmediateAllocator"], [12, 2, 1, "", "MemoryPool"], [12, 2, 1, "", "OtherArg"], [12, 2, 1, "", "PooledBuffer"], [12, 2, 1, "", "PooledSVM"], [12, 2, 1, "", "SVMAllocator"], [12, 2, 1, "", "SVMPool"], [12, 2, 1, "", "ScalarArg"], [1, 9, 1, "", "TypeNameNotKnown"], [12, 2, 1, "", "VectorArg"], [12, 8, 1, "", "clear_first_arg_caches"], [1, 8, 1, "", "dtype_to_ctype"], [12, 8, 1, "", "first_arg_dependent_memoize"], [1, 8, 1, "", "get_or_register_dtype"], [1, 8, 1, "", "match_dtype_to_c_struct"], [12, 8, 1, "", "parse_arg_list"], [12, 8, 1, "", "pytest_generate_tests_for_pyopencl"], [1, 8, 1, "", "register_dtype"]], "pyopencl.tools.AllocatorBase": [[12, 4, 1, "", "__call__"]], "pyopencl.tools.Argument": [[12, 4, 1, "", "declarator"]], "pyopencl.tools.DeferredAllocator": [[12, 4, 1, "", "__call__"], [12, 4, 1, "", "__init__"]], "pyopencl.tools.DtypedArgument": [[12, 5, 1, "", "dtype"], [12, 5, 1, "", "name"]], "pyopencl.tools.ImmediateAllocator": [[12, 4, 1, "", "__call__"], [12, 4, 1, "", "__init__"]], "pyopencl.tools.MemoryPool": [[12, 4, 1, "", "__call__"], [12, 4, 1, "", "__init__"], [12, 5, 1, "", "active_blocks"], [12, 5, 1, "", "active_bytes"], [12, 4, 1, "", "allocate"], [12, 4, 1, "", "free_held"], [12, 5, 1, "", "held_blocks"], [12, 5, 1, "", "managed_bytes"], [12, 4, 1, "", "stop_holding"]], "pyopencl.tools.PooledSVM": [[12, 4, 1, "", "bind_to_queue"], [12, 4, 1, "", "enqueue_release"], [12, 4, 1, "", "release"], [12, 4, 1, "", "unbind_from_queue"]], "pyopencl.tools.SVMAllocator": [[12, 4, 1, "", "__call__"], [12, 4, 1, "", "__init__"]], "pyopencl.tools.SVMPool": [[12, 4, 1, "", "__call__"], [12, 4, 1, "", "__init__"], [12, 5, 1, "", "active_blocks"], [12, 5, 1, "", "active_bytes"], [12, 4, 1, "", "free_held"], [12, 5, 1, "", "held_blocks"], [12, 5, 1, "", "managed_bytes"], [12, 4, 1, "", "stop_holding"]], "pyopencl.tools.VectorArg": [[12, 4, 1, "", "__init__"]], "pyopencl.version_bits": [[6, 5, 1, "", "MAJOR_BITS"], [6, 5, 1, "", "MAJOR_MASK"], [6, 5, 1, "", "MINOR_BITS"], [6, 5, 1, "", "MINOR_MASK"], [6, 5, 1, "", "PATCH_BITS"], [6, 5, 1, "", "PATCH_MASK"], [6, 4, 1, "", "to_string"]]}, "objtypes": {"0": "c:function", "1": "c:type", "2": "py:class", "3": "py:module", "4": "py:method", "5": "py:attribute", "6": "py:property", "7": "py:data", "8": "py:function", "9": "py:exception", "10": "std:envvar"}, "objnames": {"0": ["c", "function", "C function"], "1": ["c", "type", "C type"], "2": ["py", "class", "Python class"], "3": ["py", "module", "Python module"], "4": ["py", "method", "Python method"], "5": ["py", "attribute", "Python attribute"], "6": ["py", "property", "Python property"], "7": ["py", "data", "Python data"], "8": ["py", "function", "Python function"], "9": ["py", "exception", "Python exception"], "10": ["std", "envvar", "environment variable"]}, "titleterms": {"parallel": 0, "algorithm": 0, "element": 0, "wise": 0, "express": 0, "evalu": 0, "map": [0, 8, 13], "sum": 0, "count": 0, "reduc": 0, "prefix": 0, "scan": 0, "usag": 0, "exampl": 0, "make": 0, "custom": [0, 1], "kernel": [0, 10], "debug": 0, "aid": 0, "simpl": 0, "legaci": 0, "interfac": 0, "predic": 0, "copi": 0, "partit": 0, "uniqu": 0, "sort": 0, "radix": 0, "build": 0, "mani": 0, "variabl": 0, "size": 0, "list": 0, "biton": 0, "multi": 1, "dimension": 1, "arrai": [1, 8], "data": 1, "type": [1, 2, 4, 8, 12, 13], "vector": [1, 13], "complex": 1, "number": 1, "The": 1, "class": 1, "construct": 1, "instanc": 1, "manipul": 1, "condit": 1, "logic": 1, "oper": [1, 8], "reduct": 1, "elementwis": 1, "function": [1, 8, 11], "gener": 1, "random": 1, "how": 2, "tos": 2, "us": [2, 4, 8], "struct": 2, "pyopencl": [2, 3, 4], "welcom": 3, "": [3, 4], "document": [3, 4], "tutori": 3, "softwar": [3, 4], "work": 3, "enhanc": 3, "content": 3, "indic": 3, "tabl": 3, "instal": 4, "from": 4, "conda": 4, "forg": 4, "enabl": 4, "access": 4, "cpu": 4, "gpu": 4, "via": 4, "py": 4, "opencl": [4, 5, 6, 7, 8, 9, 10, 11, 13], "vendor": 4, "suppli": 4, "driver": 4, "mainli": 4, "linux": 4, "pypi": 4, "wheel": 4, "christoph": 4, "gohlk": 4, "binari": 4, "window": 4, "sourc": 4, "tip": 4, "syntax": 4, "highlight": 4, "ipython": 4, "integr": 4, "guidelin": 4, "api": 4, "stabil": 4, "relat": 4, "c": 4, "bind": 4, "interoper": [4, 7], "other": 4, "user": 4, "visibl": 4, "chang": 4, "unreleas": 4, "version": [4, 5], "2022": 4, "2": 4, "2020": 4, "2018": 4, "1": 4, "2017": 4, "2016": 4, "2015": 4, "4": 4, "3": 4, "2014": 4, "2013": 4, "2012": 4, "2011": 4, "0": 4, "92": 4, "91": 4, "5": 4, "90": 4, "licens": 4, "frequent": 4, "ask": 4, "question": 4, "cite": 4, "acknowledg": 4, "contributor": 4, "fund": 4, "cross": 4, "refer": 4, "numpi": [4, 8], "specif": 4, "intern": 4, "runtim": [5, 6, 7, 8, 9, 10, 11], "basic": 5, "queri": 5, "error": 5, "report": 5, "constant": 6, "opengl": 7, "memori": [8, 12], "migrat": 8, "buffer": [8, 12], "share": 8, "virtual": 8, "svm": [8, 12], "opaqu": 8, "wrap": 8, "style": 8, "referenc": 8, "pointer": 8, "alloc": [8, 12], "helper": 8, "base": [8, 12], "imag": 8, "transfer": 8, "host": 8, "address": 8, "space": 8, "sampler": 8, "pipe": 8, "alias": [8, 12], "platform": 9, "devic": [9, 12], "context": 9, "program": 10, "command": 11, "queue": 11, "event": 11, "subclass": 11, "synchron": 11, "built": 12, "util": 12, "pool": 12, "cl": 12, "object": 12, "depend": 12, "cach": 12, "test": 12, "argument": 12, "character": 12, "scalar": 13}, "envversion": {"sphinx.domains.c": 2, "sphinx.domains.changeset": 1, "sphinx.domains.citation": 1, "sphinx.domains.cpp": 8, "sphinx.domains.index": 1, "sphinx.domains.javascript": 2, "sphinx.domains.math": 2, "sphinx.domains.python": 3, "sphinx.domains.rst": 2, "sphinx.domains.std": 2, "sphinx.ext.intersphinx": 1, "sphinx": 57}, "alltitles": {"Parallel Algorithms": [[0, "parallel-algorithms"]], "Element-wise expression evaluation (\u201cmap\u201d)": [[0, "module-pyopencl.elementwise"]], "Sums and counts (\u201creduce\u201d)": [[0, "module-pyopencl.reduction"]], "Prefix Sums (\u201cscan\u201d)": [[0, "module-pyopencl.scan"]], "Usage Example": [[0, "usage-example"]], "Making Custom Scan Kernels": [[0, "making-custom-scan-kernels"]], "Debugging aids": [[0, "debugging-aids"]], "Simple / Legacy Interface": [[0, "simple-legacy-interface"]], "Predicated copies (\u201cpartition\u201d, \u201cunique\u201d, \u2026)": [[0, "module-pyopencl.algorithm"]], "Sorting (radix sort)": [[0, "sorting-radix-sort"]], "Building many variable-size lists": [[0, "building-many-variable-size-lists"]], "Bitonic Sort": [[0, "module-pyopencl.bitonic_sort"]], "Multi-dimensional arrays": [[1, "module-pyopencl.array"]], "Data Types": [[1, "data-types"]], "Vector Types": [[1, "vector-types"], [13, "vector-types"]], "Custom data types": [[1, "custom-data-types"]], "Complex Numbers": [[1, "complex-numbers"]], "The Array Class": [[1, "the-array-class"]], "Constructing Array Instances": [[1, "constructing-array-instances"]], "Manipulating Array instances": [[1, "manipulating-array-instances"]], "Conditionals": [[1, "conditionals"]], "Logical Operations": [[1, "logical-operations"]], "Reductions": [[1, "reductions"]], "Elementwise Functions on Array Instances": [[1, "module-pyopencl.clmath"]], "Generating Arrays of Random Numbers": [[1, "module-pyopencl.clrandom"]], "How-tos": [[2, "how-tos"]], "How to use struct types with PyOpenCL": [[2, "how-to-use-struct-types-with-pyopencl"]], "Welcome to PyOpenCL\u2019s documentation!": [[3, "welcome-to-pyopencl-s-documentation"]], "Tutorials": [[3, "tutorials"]], "Software that works with or enhances PyOpenCL": [[3, "software-that-works-with-or-enhances-pyopencl"]], "Contents": [[3, "contents"]], "Indices and tables": [[3, "indices-and-tables"]], "Installation": [[4, "installation"]], "Installing from Conda Forge": [[4, "installing-from-conda-forge"]], "Installing PyOpenCL": [[4, "installing-pyopencl"]], "Enabling access to CPUs and GPUs via (Py)OpenCL": [[4, "enabling-access-to-cpus-and-gpus-via-py-opencl"]], "Using vendor-supplied OpenCL drivers (mainly on Linux)": [[4, "using-vendor-supplied-opencl-drivers-mainly-on-linux"]], "Installing from PyPI wheels": [[4, "installing-from-pypi-wheels"]], "Installing via Christoph Gohlke\u2019s binary wheels (Windows)": [[4, "installing-via-christoph-gohlke-s-binary-wheels-windows"]], "Installing from source": [[4, "installing-from-source"]], "Tips": [[4, "tips"]], "Syntax highlighting": [[4, "syntax-highlighting"]], "IPython integration": [[4, "ipython-integration"]], "Guidelines": [[4, "guidelines"]], "API Stability": [[4, "api-stability"]], "Relation with OpenCL\u2019s C Bindings": [[4, "relation-with-opencl-s-c-bindings"]], "Interoperability with other OpenCL software": [[4, "interoperability-with-other-opencl-software"]], "User-visible Changes": [[4, "user-visible-changes"]], "Unreleased": [[4, "unreleased"]], "Version 2022.2": [[4, "version-2022-2"]], "Version 2020.2": [[4, "version-2020-2"]], "Version 2018.2": [[4, "version-2018-2"]], "Version 2018.1": [[4, "version-2018-1"]], "Version 2017.2": [[4, "version-2017-2"]], "Version 2017.1": [[4, "version-2017-1"]], "Version 2016.2": [[4, "version-2016-2"]], "Version 2016.1": [[4, "version-2016-1"]], "Version 2015.2.4": [[4, "version-2015-2-4"]], "Version 2015.2.3": [[4, "version-2015-2-3"]], "Version 2015.2.2": [[4, "version-2015-2-2"]], "Version 2015.2.1": [[4, "version-2015-2-1"]], "Version 2015.2": [[4, "version-2015-2"]], "Version 2015.1": [[4, "version-2015-1"]], "Version 2014.1": [[4, "version-2014-1"]], "Version 2013.2": [[4, "version-2013-2"]], "Version 2013.1": [[4, "version-2013-1"]], "Version 2012.1": [[4, "version-2012-1"]], "Version 2011.2": [[4, "version-2011-2"]], "Version 2011.1.2": [[4, "version-2011-1-2"]], "Version 2011.1.1": [[4, "version-2011-1-1"]], "Version 2011.1": [[4, "version-2011-1"]], "Version 0.92": [[4, "version-0-92"]], "Version 0.91.5": [[4, "version-0-91-5"]], "Version 0.91.4": [[4, "version-0-91-4"]], "Version 0.91.3": [[4, "version-0-91-3"]], "Version 0.91.2": [[4, "version-0-91-2"]], "Version 0.91.1": [[4, "version-0-91-1"]], "Version 0.91": [[4, "version-0-91"]], "Version 0.90.4": [[4, "version-0-90-4"]], "Version 0.90.3": [[4, "version-0-90-3"]], "Version 0.90.2": [[4, "version-0-90-2"]], "Version 0.90.1": [[4, "version-0-90-1"]], "Version 0.90": [[4, "version-0-90"]], "License": [[4, "license"]], "Frequently Asked Questions": [[4, "frequently-asked-questions"]], "Citing PyOpenCL": [[4, "citing-pyopencl"]], "Acknowledgments": [[4, "acknowledgments"]], "Contributors": [[4, "contributors"]], "Funding": [[4, "funding"]], "Documentation Cross-References": [[4, "documentation-cross-references"]], "Numpy": [[4, "numpy"]], "OpenCL Specification": [[4, "opencl-specification"]], "Internal Types": [[4, "internal-types"]], "OpenCL Runtime: Basics": [[5, "opencl-runtime-basics"]], "Version Queries": [[5, "module-pyopencl"]], "Error Reporting": [[5, "error-reporting"]], "OpenCL Runtime: Constants": [[6, "opencl-runtime-constants"]], "OpenCL Runtime: OpenGL Interoperability": [[7, "opencl-runtime-opengl-interoperability"]], "OpenCL Runtime: Memory": [[8, "opencl-runtime-memory"]], "Memory Migration": [[8, "memory-migration"]], "Buffer": [[8, "buffer"]], "Shared Virtual Memory (SVM)": [[8, "shared-virtual-memory-svm"]], "Opaque and \u201cWrapped-numpy\u201d Styles of Referencing SVM": [[8, "opaque-and-wrapped-numpy-styles-of-referencing-svm"]], "Using SVM with Arrays": [[8, "using-svm-with-arrays"]], "SVM Pointers, Allocations, and Maps": [[8, "svm-pointers-allocations-and-maps"]], "Helper functions for numpy-based SVM allocation": [[8, "helper-functions-for-numpy-based-svm-allocation"]], "Operations on SVM": [[8, "operations-on-svm"]], "Image": [[8, "image"]], "Transfers": [[8, "transfers"]], "Mapping Memory into Host Address Space": [[8, "mapping-memory-into-host-address-space"]], "Samplers": [[8, "samplers"]], "Pipes": [[8, "pipes"]], "Type aliases": [[8, "type-aliases"], [12, "type-aliases"]], "OpenCL Runtime: Platforms, Devices and Contexts": [[9, "opencl-runtime-platforms-devices-and-contexts"]], "Platform": [[9, "platform"]], "Device": [[9, "device"]], "Context": [[9, "context"]], "OpenCL Runtime: Programs and Kernels": [[10, "opencl-runtime-programs-and-kernels"]], "Program": [[10, "program"]], "Kernel": [[10, "kernel"]], "OpenCL Runtime: Command Queues and Events": [[11, "opencl-runtime-command-queues-and-events"]], "Command Queue": [[11, "command-queue"]], "Event": [[11, "event"]], "Event Subclasses": [[11, "event-subclasses"]], "Synchronization Functions": [[11, "synchronization-functions"]], "Built-in Utilities": [[12, "module-pyopencl.tools"]], "Memory Pools": [[12, "memory-pools"]], "Buffer-based Allocators and Memory Pools": [[12, "buffer-based-allocators-and-memory-pools"]], "SVM-Based Allocators and Memory Pools": [[12, "svm-based-allocators-and-memory-pools"]], "CL-Object-dependent Caching": [[12, "cl-object-dependent-caching"]], "Testing": [[12, "testing"]], "Argument Types": [[12, "argument-types"]], "Device Characterization": [[12, "module-pyopencl.characterize"]], "OpenCL Type Mapping": [[13, "module-pyopencl.cltypes"]], "Scalar Types": [[13, "scalar-types"]]}, "indexentries": {"bitonicsort (class in pyopencl.bitonic_sort)": [[0, "pyopencl.bitonic_sort.BitonicSort"]], "elementwisekernel (class in pyopencl.elementwise)": [[0, "pyopencl.elementwise.ElementwiseKernel"]], "exclusivescankernel (class in pyopencl.scan)": [[0, "pyopencl.scan.ExclusiveScanKernel"]], "genericdebugscankernel (class in pyopencl.scan)": [[0, "pyopencl.scan.GenericDebugScanKernel"]], "genericscankernel (class in pyopencl.scan)": [[0, "pyopencl.scan.GenericScanKernel"]], "inclusivescankernel (class in pyopencl.scan)": [[0, "pyopencl.scan.InclusiveScanKernel"]], "listoflistsbuilder (class in pyopencl.algorithm)": [[0, "pyopencl.algorithm.ListOfListsBuilder"]], "radixsort (class in pyopencl.algorithm)": [[0, "pyopencl.algorithm.RadixSort"]], "reductionkernel (class in pyopencl.reduction)": [[0, "pyopencl.reduction.ReductionKernel"]], "__call__() (pyopencl.algorithm.listoflistsbuilder method)": [[0, "pyopencl.algorithm.ListOfListsBuilder.__call__"]], "__call__() (pyopencl.algorithm.radixsort method)": [[0, "pyopencl.algorithm.RadixSort.__call__"]], "__call__() (pyopencl.bitonic_sort.bitonicsort method)": [[0, "pyopencl.bitonic_sort.BitonicSort.__call__"]], "__call__() (pyopencl.elementwise.elementwisekernel method)": [[0, "pyopencl.elementwise.ElementwiseKernel.__call__"]], "__call__() (pyopencl.reduction.reductionkernel method)": [[0, "pyopencl.reduction.ReductionKernel.__call__"]], "__call__() (pyopencl.scan.exclusivescankernel method)": [[0, "pyopencl.scan.ExclusiveScanKernel.__call__"]], "__call__() (pyopencl.scan.genericdebugscankernel method)": [[0, "pyopencl.scan.GenericDebugScanKernel.__call__"]], "__call__() (pyopencl.scan.genericscankernel method)": [[0, "pyopencl.scan.GenericScanKernel.__call__"]], "__init__() (pyopencl.algorithm.listoflistsbuilder method)": [[0, "pyopencl.algorithm.ListOfListsBuilder.__init__"]], "__init__() (pyopencl.reduction.reductionkernel method)": [[0, "pyopencl.reduction.ReductionKernel.__init__"]], "__init__() (pyopencl.scan.genericscankernel method)": [[0, "pyopencl.scan.GenericScanKernel.__init__"]], "copy_if() (in module pyopencl.algorithm)": [[0, "pyopencl.algorithm.copy_if"]], "module": [[0, "module-pyopencl.algorithm"], [0, "module-pyopencl.bitonic_sort"], [0, "module-pyopencl.elementwise"], [0, "module-pyopencl.reduction"], [0, "module-pyopencl.scan"], [1, "module-pyopencl.array"], [1, "module-pyopencl.clmath"], [1, "module-pyopencl.clrandom"], [5, "module-pyopencl"], [12, "module-pyopencl.characterize"], [12, "module-pyopencl.tools"], [13, "module-pyopencl.cltypes"]], "partition() (in module pyopencl.algorithm)": [[0, "pyopencl.algorithm.partition"]], "pyopencl.algorithm": [[0, "module-pyopencl.algorithm"]], "pyopencl.bitonic_sort": [[0, "module-pyopencl.bitonic_sort"]], "pyopencl.elementwise": [[0, "module-pyopencl.elementwise"]], "pyopencl.reduction": [[0, "module-pyopencl.reduction"]], "pyopencl.scan": [[0, "module-pyopencl.scan"]], "remove_if() (in module pyopencl.algorithm)": [[0, "pyopencl.algorithm.remove_if"]], "unique() (in module pyopencl.algorithm)": [[0, "pyopencl.algorithm.unique"]], "array (class in pyopencl.array)": [[1, "pyopencl.array.Array"]], "arrayhasoffseterror": [[1, "pyopencl.array.ArrayHasOffsetError"]], "philoxgenerator (class in pyopencl.clrandom)": [[1, "pyopencl.clrandom.PhiloxGenerator"]], "t (pyopencl.array.array attribute)": [[1, "pyopencl.array.Array.T"]], "threefrygenerator (class in pyopencl.clrandom)": [[1, "pyopencl.clrandom.ThreefryGenerator"]], "typenamenotknown": [[1, "pyopencl.tools.TypeNameNotKnown"]], "__abs__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__abs__"]], "__add__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__add__"]], "__and__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__and__"]], "__bool__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__bool__"]], "__div__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__div__"]], "__eq__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__eq__"]], "__ge__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__ge__"]], "__getitem__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__getitem__"]], "__gt__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__gt__"]], "__iadd__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__iadd__"]], "__iand__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__iand__"]], "__invert__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__invert__"]], "__ior__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__ior__"]], "__isub__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__isub__"]], "__ixor__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__ixor__"]], "__le__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__le__"]], "__len__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__len__"]], "__lt__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__lt__"]], "__mul__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__mul__"]], "__ne__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__ne__"]], "__neg__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__neg__"]], "__or__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__or__"]], "__pos__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__pos__"]], "__pow__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__pow__"]], "__rdiv__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__rdiv__"]], "__repr__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__repr__"]], "__setitem__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__setitem__"]], "__str__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__str__"]], "__sub__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__sub__"]], "__xor__() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.__xor__"]], "acos() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.acos"]], "acosh() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.acosh"]], "acospi() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.acospi"]], "add_event() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.add_event"]], "all() (in module pyopencl.array)": [[1, "pyopencl.array.all"]], "all() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.all"]], "any() (in module pyopencl.array)": [[1, "pyopencl.array.any"]], "any() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.any"]], "arange() (in module pyopencl.array)": [[1, "pyopencl.array.arange"]], "asin() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.asin"]], "asinh() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.asinh"]], "asinpi() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.asinpi"]], "astype() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.astype"]], "atan() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.atan"]], "atan2() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.atan2"]], "atan2pi() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.atan2pi"]], "atanh() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.atanh"]], "atanpi() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.atanpi"]], "base_data (pyopencl.array.array attribute)": [[1, "pyopencl.array.Array.base_data"]], "cbrt() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.cbrt"]], "ceil() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.ceil"]], "concatenate() (in module pyopencl.array)": [[1, "pyopencl.array.concatenate"]], "conj() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.conj"]], "conjugate() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.conjugate"]], "copy() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.copy"]], "cos() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.cos"]], "cosh() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.cosh"]], "cospi() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.cospi"]], "data (pyopencl.array.array attribute)": [[1, "pyopencl.array.Array.data"]], "dot() (in module pyopencl.array)": [[1, "pyopencl.array.dot"]], "dtype (pyopencl.array.array attribute)": [[1, "pyopencl.array.Array.dtype"]], "dtype_to_ctype() (in module pyopencl.tools)": [[1, "pyopencl.tools.dtype_to_ctype"]], "empty() (in module pyopencl.array)": [[1, "pyopencl.array.empty"]], "empty_like() (in module pyopencl.array)": [[1, "pyopencl.array.empty_like"]], "erf() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.erf"]], "erfc() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.erfc"]], "events (pyopencl.array.array attribute)": [[1, "pyopencl.array.Array.events"]], "exp() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.exp"]], "exp10() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.exp10"]], "exp2() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.exp2"]], "expm1() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.expm1"]], "fabs() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.fabs"]], "fill() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.fill"]], "fill_normal() (pyopencl.clrandom.philoxgenerator method)": [[1, "pyopencl.clrandom.PhiloxGenerator.fill_normal"]], "fill_normal() (pyopencl.clrandom.threefrygenerator method)": [[1, "pyopencl.clrandom.ThreefryGenerator.fill_normal"]], "fill_rand() (in module pyopencl.clrandom)": [[1, "pyopencl.clrandom.fill_rand"]], "fill_uniform() (pyopencl.clrandom.philoxgenerator method)": [[1, "pyopencl.clrandom.PhiloxGenerator.fill_uniform"]], "fill_uniform() (pyopencl.clrandom.threefrygenerator method)": [[1, "pyopencl.clrandom.ThreefryGenerator.fill_uniform"]], "finish() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.finish"]], "flags (pyopencl.array.array attribute)": [[1, "pyopencl.array.Array.flags"]], "floor() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.floor"]], "fmod() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.fmod"]], "frexp() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.frexp"]], "get() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.get"]], "get_async() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.get_async"]], "get_or_register_dtype() (in module pyopencl.tools)": [[1, "pyopencl.tools.get_or_register_dtype"]], "if_positive() (in module pyopencl.array)": [[1, "pyopencl.array.if_positive"]], "ilogb() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.ilogb"]], "imag (pyopencl.array.array attribute)": [[1, "pyopencl.array.Array.imag"]], "ldexp() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.ldexp"]], "lgamma() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.lgamma"]], "log() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.log"]], "log10() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.log10"]], "log1p() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.log1p"]], "log2() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.log2"]], "logb() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.logb"]], "logical_and() (in module pyopencl.array)": [[1, "pyopencl.array.logical_and"]], "logical_not() (in module pyopencl.array)": [[1, "pyopencl.array.logical_not"]], "logical_or() (in module pyopencl.array)": [[1, "pyopencl.array.logical_or"]], "map_to_host() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.map_to_host"]], "match_dtype_to_c_struct() (in module pyopencl.tools)": [[1, "pyopencl.tools.match_dtype_to_c_struct"]], "max() (in module pyopencl.array)": [[1, "pyopencl.array.max"]], "maximum() (in module pyopencl.array)": [[1, "pyopencl.array.maximum"]], "min() (in module pyopencl.array)": [[1, "pyopencl.array.min"]], "minimum() (in module pyopencl.array)": [[1, "pyopencl.array.minimum"]], "modf() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.modf"]], "mul_add() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.mul_add"]], "nan() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.nan"]], "nbytes (pyopencl.array.array attribute)": [[1, "pyopencl.array.Array.nbytes"]], "ndim (pyopencl.array.array attribute)": [[1, "pyopencl.array.Array.ndim"]], "normal() (pyopencl.clrandom.philoxgenerator method)": [[1, "pyopencl.clrandom.PhiloxGenerator.normal"]], "normal() (pyopencl.clrandom.threefrygenerator method)": [[1, "pyopencl.clrandom.ThreefryGenerator.normal"]], "offset (pyopencl.array.array attribute)": [[1, "pyopencl.array.Array.offset"]], "pyopencl.array": [[1, "module-pyopencl.array"]], "pyopencl.clmath": [[1, "module-pyopencl.clmath"]], "pyopencl.clrandom": [[1, "module-pyopencl.clrandom"]], "rand() (in module pyopencl.clrandom)": [[1, "pyopencl.clrandom.rand"]], "ravel() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.ravel"]], "real (pyopencl.array.array attribute)": [[1, "pyopencl.array.Array.real"]], "register_dtype() (in module pyopencl.tools)": [[1, "pyopencl.tools.register_dtype"]], "reshape() (in module pyopencl.array)": [[1, "pyopencl.array.reshape"]], "reshape() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.reshape"]], "rint() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.rint"]], "round() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.round"]], "set() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.set"]], "setitem() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.setitem"]], "shape (pyopencl.array.array attribute)": [[1, "pyopencl.array.Array.shape"]], "sin() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.sin"]], "sinh() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.sinh"]], "sinpi() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.sinpi"]], "size (pyopencl.array.array attribute)": [[1, "pyopencl.array.Array.size"]], "sqrt() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.sqrt"]], "squeeze() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.squeeze"]], "stack() (in module pyopencl.array)": [[1, "pyopencl.array.stack"]], "strides (pyopencl.array.array attribute)": [[1, "pyopencl.array.Array.strides"]], "subset_dot() (in module pyopencl.array)": [[1, "pyopencl.array.subset_dot"]], "subset_max() (in module pyopencl.array)": [[1, "pyopencl.array.subset_max"]], "subset_min() (in module pyopencl.array)": [[1, "pyopencl.array.subset_min"]], "sum() (in module pyopencl.array)": [[1, "pyopencl.array.sum"]], "take() (in module pyopencl.array)": [[1, "pyopencl.array.take"]], "tan() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.tan"]], "tanh() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.tanh"]], "tanpi() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.tanpi"]], "tgamma() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.tgamma"]], "to_device() (in module pyopencl.array)": [[1, "pyopencl.array.to_device"]], "transpose() (in module pyopencl.array)": [[1, "pyopencl.array.transpose"]], "transpose() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.transpose"]], "trunc() (in module pyopencl.clmath)": [[1, "pyopencl.clmath.trunc"]], "uniform() (pyopencl.clrandom.philoxgenerator method)": [[1, "pyopencl.clrandom.PhiloxGenerator.uniform"]], "uniform() (pyopencl.clrandom.threefrygenerator method)": [[1, "pyopencl.clrandom.ThreefryGenerator.uniform"]], "vdot() (in module pyopencl.array)": [[1, "pyopencl.array.vdot"]], "vec (class in pyopencl.array)": [[1, "pyopencl.array.vec"]], "view() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.view"]], "with_queue() (pyopencl.array.array method)": [[1, "pyopencl.array.Array.with_queue"]], "zeros() (in module pyopencl.array)": [[1, "pyopencl.array.zeros"]], "zeros_like() (in module pyopencl.array)": [[1, "pyopencl.array.zeros_like"]], "commandqueue (class in pyopencl._cl)": [[4, "pyopencl._cl.CommandQueue"]], "context (class in pyopencl._cl)": [[4, "pyopencl._cl.Context"]], "device (class in pyopencl._cl)": [[4, "pyopencl._cl.Device"]], "event (class in pyopencl._cl)": [[4, "pyopencl._cl.Event"]], "kernel (class in pyopencl._cl)": [[4, "pyopencl._cl.Kernel"]], "memorymap (class in pyopencl._cl)": [[4, "pyopencl._cl.MemoryMap"]], "pep 8": [[4, "index-0"]], "pyopencl_no_cache": [[4, "index-1"], [10, "envvar-PYOPENCL_NO_CACHE"], [10, "index-0"], [10, "index-2"]], "platform (class in pyopencl._cl)": [[4, "pyopencl._cl.Platform"]], "program (class in pyopencl._cl)": [[4, "pyopencl._cl.Program"]], "python enhancement proposals": [[4, "index-0"]], "svmallocation (class in pyopencl._cl)": [[4, "pyopencl._cl.SVMAllocation"]], "sampler (class in pyopencl._cl)": [[4, "pyopencl._cl.Sampler"]], "_program (class in pyopencl._cl)": [[4, "pyopencl._cl._Program"]], "clcreatecommandqueuewithproperties (c function)": [[4, "c.clCreateCommandQueueWithProperties"]], "clcreatepipe (c function)": [[4, "c.clCreatePipe"]], "clcreatesamplerwithproperties (c function)": [[4, "c.clCreateSamplerWithProperties"]], "cl_command_queue (c type)": [[4, "c.cl_command_queue"]], "cl_context (c type)": [[4, "c.cl_context"]], "cl_device_id (c type)": [[4, "c.cl_device_id"]], "cl_event (c type)": [[4, "c.cl_event"]], "cl_kernel (c type)": [[4, "c.cl_kernel"]], "cl_mem (c type)": [[4, "c.cl_mem"]], "cl_platform_id (c type)": [[4, "c.cl_platform_id"]], "cl_program (c type)": [[4, "c.cl_program"]], "cl_sampler (c type)": [[4, "c.cl_sampler"]], "environment variable": [[4, "index-1"], [10, "envvar-PYOPENCL_BUILD_OPTIONS"], [10, "envvar-PYOPENCL_NO_CACHE"], [10, "index-0"], [10, "index-1"], [10, "index-2"], [10, "index-3"]], "float64 (class in numpy)": [[4, "numpy.float64"]], "int32 (class in numpy)": [[4, "numpy.int32"]], "int8 (class in numpy)": [[4, "numpy.int8"]], "error (class in pyopencl)": [[5, "pyopencl.Error"]], "logicerror (class in pyopencl)": [[5, "pyopencl.LogicError"]], "memoryerror (class in pyopencl)": [[5, "pyopencl.MemoryError"]], "runtimeerror (class in pyopencl)": [[5, "pyopencl.RuntimeError"]], "version (in module pyopencl)": [[5, "pyopencl.VERSION"]], "version_status (in module pyopencl)": [[5, "pyopencl.VERSION_STATUS"]], "version_text (in module pyopencl)": [[5, "pyopencl.VERSION_TEXT"]], "get_cl_header_version() (in module pyopencl)": [[5, "pyopencl.get_cl_header_version"]], "pyopencl": [[5, "module-pyopencl"]], "a (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.A"]], "abgr (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.ABGR"]], "accelerator (pyopencl.device_type attribute)": [[6, "pyopencl.device_type.ACCELERATOR"]], "access_qualifier (pyopencl.kernel_arg_info attribute)": [[6, "pyopencl.kernel_arg_info.ACCESS_QUALIFIER"]], "acquire_gl_objects (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.ACQUIRE_GL_OBJECTS"]], "addressing_mode (pyopencl.sampler_info attribute)": [[6, "pyopencl.sampler_info.ADDRESSING_MODE"]], "addressing_mode (pyopencl.sampler_properties attribute)": [[6, "pyopencl.sampler_properties.ADDRESSING_MODE"]], "address_bits (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.ADDRESS_BITS"]], "address_qualifier (pyopencl.kernel_arg_info attribute)": [[6, "pyopencl.kernel_arg_info.ADDRESS_QUALIFIER"]], "all (pyopencl.device_type attribute)": [[6, "pyopencl.device_type.ALL"]], "alloc_host_ptr (pyopencl.mem_flags attribute)": [[6, "pyopencl.mem_flags.ALLOC_HOST_PTR"]], "array_size (pyopencl.image_info attribute)": [[6, "pyopencl.image_info.ARRAY_SIZE"]], "associated_memobject (pyopencl.mem_info attribute)": [[6, "pyopencl.mem_info.ASSOCIATED_MEMOBJECT"]], "atomics (pyopencl.device_svm_capabilities attribute)": [[6, "pyopencl.device_svm_capabilities.ATOMICS"]], "atomic_fence_capabilities (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.ATOMIC_FENCE_CAPABILITIES"]], "atomic_memory_capabilities (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.ATOMIC_MEMORY_CAPABILITIES"]], "attributes (pyopencl.kernel_info attribute)": [[6, "pyopencl.kernel_info.ATTRIBUTES"]], "attribute_async_engine_count_nv (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.ATTRIBUTE_ASYNC_ENGINE_COUNT_NV"]], "available (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.AVAILABLE"]], "available_async_queues_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.AVAILABLE_ASYNC_QUEUES_AMD"]], "barrier (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.BARRIER"]], "bgra (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.BGRA"]], "binaries (pyopencl.program_info attribute)": [[6, "pyopencl.program_info.BINARIES"]], "binary (pyopencl.program_kind attribute)": [[6, "pyopencl.program_kind.BINARY"]], "binary_sizes (pyopencl.program_info attribute)": [[6, "pyopencl.program_info.BINARY_SIZES"]], "binary_type (pyopencl.program_build_info attribute)": [[6, "pyopencl.program_build_info.BINARY_TYPE"]], "board_name_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.BOARD_NAME_AMD"]], "buffer (pyopencl.gl_object_type attribute)": [[6, "pyopencl.gl_object_type.BUFFER"]], "buffer (pyopencl.image_info attribute)": [[6, "pyopencl.image_info.BUFFER"]], "buffer (pyopencl.mem_object_type attribute)": [[6, "pyopencl.mem_object_type.BUFFER"]], "build_program_failure (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.BUILD_PROGRAM_FAILURE"]], "built_in_kernels (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.BUILT_IN_KERNELS"]], "built_in_kernels_with_version (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.BUILT_IN_KERNELS_WITH_VERSION"]], "by_affinity_domain (pyopencl.device_partition_property attribute)": [[6, "pyopencl.device_partition_property.BY_AFFINITY_DOMAIN"]], "by_counts (pyopencl.device_partition_property attribute)": [[6, "pyopencl.device_partition_property.BY_COUNTS"]], "by_counts_list_end (pyopencl.device_partition_property attribute)": [[6, "pyopencl.device_partition_property.BY_COUNTS_LIST_END"]], "cgl_sharegroup_khr (pyopencl.context_properties attribute)": [[6, "pyopencl.context_properties.CGL_SHAREGROUP_KHR"]], "clamp (pyopencl.addressing_mode attribute)": [[6, "pyopencl.addressing_mode.CLAMP"]], "clamp_to_edge (pyopencl.addressing_mode attribute)": [[6, "pyopencl.addressing_mode.CLAMP_TO_EDGE"]], "coarse_grain_buffer (pyopencl.device_svm_capabilities attribute)": [[6, "pyopencl.device_svm_capabilities.COARSE_GRAIN_BUFFER"]], "codeplay (pyopencl.khronos_vendor_id attribute)": [[6, "pyopencl.khronos_vendor_id.CODEPLAY"]], "command_execution_status (pyopencl.event_info attribute)": [[6, "pyopencl.event_info.COMMAND_EXECUTION_STATUS"]], "command_queue (pyopencl.event_info attribute)": [[6, "pyopencl.event_info.COMMAND_QUEUE"]], "command_type (pyopencl.event_info attribute)": [[6, "pyopencl.event_info.COMMAND_TYPE"]], "compiled_object (pyopencl.program_binary_type attribute)": [[6, "pyopencl.program_binary_type.COMPILED_OBJECT"]], "compiler_available (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.COMPILER_AVAILABLE"]], "compiler_not_available (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.COMPILER_NOT_AVAILABLE"]], "compile_num_sub_groups (pyopencl.kernel_sub_group_info attribute)": [[6, "pyopencl.kernel_sub_group_info.COMPILE_NUM_SUB_GROUPS"]], "compile_program_failure (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.COMPILE_PROGRAM_FAILURE"]], "compile_work_group_size (pyopencl.kernel_work_group_info attribute)": [[6, "pyopencl.kernel_work_group_info.COMPILE_WORK_GROUP_SIZE"]], "complete (pyopencl.command_execution_status attribute)": [[6, "pyopencl.command_execution_status.COMPLETE"]], "complete (pyopencl.profiling_info attribute)": [[6, "pyopencl.profiling_info.COMPLETE"]], "compute_capability_major_nv (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.COMPUTE_CAPABILITY_MAJOR_NV"]], "compute_capability_minor_nv (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.COMPUTE_CAPABILITY_MINOR_NV"]], "const (pyopencl.kernel_arg_type_qualifier attribute)": [[6, "pyopencl.kernel_arg_type_qualifier.CONST"]], "constant (pyopencl.kernel_arg_address_qualifier attribute)": [[6, "pyopencl.kernel_arg_address_qualifier.CONSTANT"]], "content_undefined (pyopencl.mem_migration_flags attribute)": [[6, "pyopencl.mem_migration_flags.CONTENT_UNDEFINED"]], "context (pyopencl.command_queue_info attribute)": [[6, "pyopencl.command_queue_info.CONTEXT"]], "context (pyopencl.event_info attribute)": [[6, "pyopencl.event_info.CONTEXT"]], "context (pyopencl.kernel_info attribute)": [[6, "pyopencl.kernel_info.CONTEXT"]], "context (pyopencl.mem_info attribute)": [[6, "pyopencl.mem_info.CONTEXT"]], "context (pyopencl.program_info attribute)": [[6, "pyopencl.program_info.CONTEXT"]], "context (pyopencl.sampler_info attribute)": [[6, "pyopencl.sampler_info.CONTEXT"]], "copy_buffer (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.COPY_BUFFER"]], "copy_buffer_rect (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.COPY_BUFFER_RECT"]], "copy_buffer_to_image (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.COPY_BUFFER_TO_IMAGE"]], "copy_host_ptr (pyopencl.mem_flags attribute)": [[6, "pyopencl.mem_flags.COPY_HOST_PTR"]], "copy_image (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.COPY_IMAGE"]], "copy_image_to_buffer (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.COPY_IMAGE_TO_BUFFER"]], "correctly_rounded_divide_sqrt (pyopencl.device_fp_config attribute)": [[6, "pyopencl.device_fp_config.CORRECTLY_ROUNDED_DIVIDE_SQRT"]], "cpu (pyopencl.device_type attribute)": [[6, "pyopencl.device_type.CPU"]], "current_device_for_gl_context_khr (pyopencl.gl_context_info attribute)": [[6, "pyopencl.gl_context_info.CURRENT_DEVICE_FOR_GL_CONTEXT_KHR"]], "custom (pyopencl.device_type attribute)": [[6, "pyopencl.device_type.CUSTOM"]], "default (pyopencl.device_type attribute)": [[6, "pyopencl.device_type.DEFAULT"]], "denorm (pyopencl.device_fp_config attribute)": [[6, "pyopencl.device_fp_config.DENORM"]], "depth (pyopencl.image_info attribute)": [[6, "pyopencl.image_info.DEPTH"]], "device (pyopencl.command_queue_info attribute)": [[6, "pyopencl.command_queue_info.DEVICE"]], "devices (pyopencl.context_info attribute)": [[6, "pyopencl.context_info.DEVICES"]], "devices (pyopencl.program_info attribute)": [[6, "pyopencl.program_info.DEVICES"]], "devices_for_gl_context_khr (pyopencl.gl_context_info attribute)": [[6, "pyopencl.gl_context_info.DEVICES_FOR_GL_CONTEXT_KHR"]], "device_default (pyopencl.queue_properties attribute)": [[6, "pyopencl.queue_properties.DEVICE_DEFAULT"]], "device_enqueue_capabilities (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.DEVICE_ENQUEUE_CAPABILITIES"]], "device_not_available (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.DEVICE_NOT_AVAILABLE"]], "device_not_found (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.DEVICE_NOT_FOUND"]], "device_partition_failed (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.DEVICE_PARTITION_FAILED"]], "double_fp_config (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.DOUBLE_FP_CONFIG"]], "driver_version (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.DRIVER_VERSION"]], "devicetopologyamd (class in pyopencl)": [[6, "pyopencl.DeviceTopologyAmd"]], "egl_display_khr (pyopencl.context_properties attribute)": [[6, "pyopencl.context_properties.EGL_DISPLAY_KHR"]], "element_size (pyopencl.image_info attribute)": [[6, "pyopencl.image_info.ELEMENT_SIZE"]], "end (pyopencl.profiling_info attribute)": [[6, "pyopencl.profiling_info.END"]], "endian_little (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.ENDIAN_LITTLE"]], "equally (pyopencl.device_partition_property attribute)": [[6, "pyopencl.device_partition_property.EQUALLY"]], "error_correction_support (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.ERROR_CORRECTION_SUPPORT"]], "executable (pyopencl.program_binary_type attribute)": [[6, "pyopencl.program_binary_type.EXECUTABLE"]], "execution_capabilities (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.EXECUTION_CAPABILITIES"]], "exec_status_error_for_events_in_wait_list (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.EXEC_STATUS_ERROR_FOR_EVENTS_IN_WAIT_LIST"]], "extensions (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.EXTENSIONS"]], "extensions (pyopencl.platform_info attribute)": [[6, "pyopencl.platform_info.EXTENSIONS"]], "extensions_with_version (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.EXTENSIONS_WITH_VERSION"]], "extensions_with_version (pyopencl.platform_info attribute)": [[6, "pyopencl.platform_info.EXTENSIONS_WITH_VERSION"]], "ext_mem_padding_in_bytes_qcom (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.EXT_MEM_PADDING_IN_BYTES_QCOM"]], "fill_buffer (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.FILL_BUFFER"]], "fill_image (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.FILL_IMAGE"]], "filter_mode (pyopencl.sampler_info attribute)": [[6, "pyopencl.sampler_info.FILTER_MODE"]], "filter_mode (pyopencl.sampler_properties attribute)": [[6, "pyopencl.sampler_properties.FILTER_MODE"]], "fine_grain_buffer (pyopencl.device_svm_capabilities attribute)": [[6, "pyopencl.device_svm_capabilities.FINE_GRAIN_BUFFER"]], "fine_grain_system (pyopencl.device_svm_capabilities attribute)": [[6, "pyopencl.device_svm_capabilities.FINE_GRAIN_SYSTEM"]], "flags (pyopencl.mem_info attribute)": [[6, "pyopencl.mem_info.FLAGS"]], "float (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.FLOAT"]], "fma (pyopencl.device_fp_config attribute)": [[6, "pyopencl.device_fp_config.FMA"]], "format (pyopencl.image_info attribute)": [[6, "pyopencl.image_info.FORMAT"]], "function_name (pyopencl.kernel_info attribute)": [[6, "pyopencl.kernel_info.FUNCTION_NAME"]], "generic_address_space_support (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.GENERIC_ADDRESS_SPACE_SUPPORT"]], "gfxip_major_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.GFXIP_MAJOR_AMD"]], "gfxip_minor_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.GFXIP_MINOR_AMD"]], "global (pyopencl.device_local_mem_type attribute)": [[6, "pyopencl.device_local_mem_type.GLOBAL"]], "global (pyopencl.kernel_arg_address_qualifier attribute)": [[6, "pyopencl.kernel_arg_address_qualifier.GLOBAL"]], "global_free_memory_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.GLOBAL_FREE_MEMORY_AMD"]], "global_mem_cacheline_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.GLOBAL_MEM_CACHELINE_SIZE"]], "global_mem_cache_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.GLOBAL_MEM_CACHE_SIZE"]], "global_mem_cache_type (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.GLOBAL_MEM_CACHE_TYPE"]], "global_mem_channels_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.GLOBAL_MEM_CHANNELS_AMD"]], "global_mem_channel_banks_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.GLOBAL_MEM_CHANNEL_BANKS_AMD"]], "global_mem_channel_bank_width_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.GLOBAL_MEM_CHANNEL_BANK_WIDTH_AMD"]], "global_mem_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.GLOBAL_MEM_SIZE"]], "global_variable_preferred_total_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.GLOBAL_VARIABLE_PREFERRED_TOTAL_SIZE"]], "global_variable_total_size (pyopencl.program_build_info attribute)": [[6, "pyopencl.program_build_info.GLOBAL_VARIABLE_TOTAL_SIZE"]], "global_work_size (pyopencl.kernel_work_group_info attribute)": [[6, "pyopencl.kernel_work_group_info.GLOBAL_WORK_SIZE"]], "glx_display_khr (pyopencl.context_properties attribute)": [[6, "pyopencl.context_properties.GLX_DISPLAY_KHR"]], "gl_context_khr (pyopencl.context_properties attribute)": [[6, "pyopencl.context_properties.GL_CONTEXT_KHR"]], "gpu (pyopencl.device_type attribute)": [[6, "pyopencl.device_type.GPU"]], "gpu_overlap_nv (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.GPU_OVERLAP_NV"]], "half_float (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.HALF_FLOAT"]], "half_fp_config (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.HALF_FP_CONFIG"]], "height (pyopencl.image_info attribute)": [[6, "pyopencl.image_info.HEIGHT"]], "host (pyopencl.mem_migration_flags attribute)": [[6, "pyopencl.mem_migration_flags.HOST"]], "host_no_access (pyopencl.mem_flags attribute)": [[6, "pyopencl.mem_flags.HOST_NO_ACCESS"]], "host_ptr (pyopencl.mem_info attribute)": [[6, "pyopencl.mem_info.HOST_PTR"]], "host_read_only (pyopencl.mem_flags attribute)": [[6, "pyopencl.mem_flags.HOST_READ_ONLY"]], "host_timer_resolution (pyopencl.platform_info attribute)": [[6, "pyopencl.platform_info.HOST_TIMER_RESOLUTION"]], "host_unified_memory (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.HOST_UNIFIED_MEMORY"]], "host_write_only (pyopencl.mem_flags attribute)": [[6, "pyopencl.mem_flags.HOST_WRITE_ONLY"]], "il (pyopencl.program_info attribute)": [[6, "pyopencl.program_info.IL"]], "il (pyopencl.program_kind attribute)": [[6, "pyopencl.program_kind.IL"]], "ils_with_version (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.ILS_WITH_VERSION"]], "il_version (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.IL_VERSION"]], "image1d (pyopencl.mem_object_type attribute)": [[6, "pyopencl.mem_object_type.IMAGE1D"]], "image1d_array (pyopencl.mem_object_type attribute)": [[6, "pyopencl.mem_object_type.IMAGE1D_ARRAY"]], "image1d_buffer (pyopencl.mem_object_type attribute)": [[6, "pyopencl.mem_object_type.IMAGE1D_BUFFER"]], "image2d (pyopencl.mem_object_type attribute)": [[6, "pyopencl.mem_object_type.IMAGE2D"]], "image2d_array (pyopencl.mem_object_type attribute)": [[6, "pyopencl.mem_object_type.IMAGE2D_ARRAY"]], "image2d_max_height (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.IMAGE2D_MAX_HEIGHT"]], "image2d_max_width (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.IMAGE2D_MAX_WIDTH"]], "image3d (pyopencl.mem_object_type attribute)": [[6, "pyopencl.mem_object_type.IMAGE3D"]], "image3d_max_depth (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.IMAGE3D_MAX_DEPTH"]], "image3d_max_height (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.IMAGE3D_MAX_HEIGHT"]], "image3d_max_width (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.IMAGE3D_MAX_WIDTH"]], "image_base_address_alignment (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.IMAGE_BASE_ADDRESS_ALIGNMENT"]], "image_format_mismatch (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.IMAGE_FORMAT_MISMATCH"]], "image_format_not_supported (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.IMAGE_FORMAT_NOT_SUPPORTED"]], "image_max_array_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.IMAGE_MAX_ARRAY_SIZE"]], "image_max_buffer_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.IMAGE_MAX_BUFFER_SIZE"]], "image_pitch_alignment (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.IMAGE_PITCH_ALIGNMENT"]], "image_support (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.IMAGE_SUPPORT"]], "inf_nan (pyopencl.device_fp_config attribute)": [[6, "pyopencl.device_fp_config.INF_NAN"]], "integrated_memory_nv (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.INTEGRATED_MEMORY_NV"]], "intensity (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.INTENSITY"]], "interop_user_sync (pyopencl.context_info attribute)": [[6, "pyopencl.context_info.INTEROP_USER_SYNC"]], "invalid_arg_index (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_ARG_INDEX"]], "invalid_arg_size (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_ARG_SIZE"]], "invalid_arg_value (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_ARG_VALUE"]], "invalid_binary (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_BINARY"]], "invalid_buffer_size (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_BUFFER_SIZE"]], "invalid_build_options (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_BUILD_OPTIONS"]], "invalid_command_queue (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_COMMAND_QUEUE"]], "invalid_compiler_options (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_COMPILER_OPTIONS"]], "invalid_context (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_CONTEXT"]], "invalid_device (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_DEVICE"]], "invalid_device_partition_count (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_DEVICE_PARTITION_COUNT"]], "invalid_device_queue (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_DEVICE_QUEUE"]], "invalid_device_type (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_DEVICE_TYPE"]], "invalid_event (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_EVENT"]], "invalid_event_wait_list (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_EVENT_WAIT_LIST"]], "invalid_global_offset (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_GLOBAL_OFFSET"]], "invalid_global_work_size (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_GLOBAL_WORK_SIZE"]], "invalid_gl_object (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_GL_OBJECT"]], "invalid_gl_sharegroup_reference_khr (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_GL_SHAREGROUP_REFERENCE_KHR"]], "invalid_host_ptr (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_HOST_PTR"]], "invalid_image_descriptor (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_IMAGE_DESCRIPTOR"]], "invalid_image_format_descriptor (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_IMAGE_FORMAT_DESCRIPTOR"]], "invalid_image_size (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_IMAGE_SIZE"]], "invalid_kernel (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_KERNEL"]], "invalid_kernel_args (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_KERNEL_ARGS"]], "invalid_kernel_definition (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_KERNEL_DEFINITION"]], "invalid_kernel_name (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_KERNEL_NAME"]], "invalid_linker_options (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_LINKER_OPTIONS"]], "invalid_mem_object (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_MEM_OBJECT"]], "invalid_mip_level (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_MIP_LEVEL"]], "invalid_operation (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_OPERATION"]], "invalid_pipe_size (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_PIPE_SIZE"]], "invalid_platform (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_PLATFORM"]], "invalid_program (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_PROGRAM"]], "invalid_program_executable (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_PROGRAM_EXECUTABLE"]], "invalid_queue_properties (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_QUEUE_PROPERTIES"]], "invalid_sampler (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_SAMPLER"]], "invalid_spec_id (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_SPEC_ID"]], "invalid_value (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_VALUE"]], "invalid_work_dimension (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_WORK_DIMENSION"]], "invalid_work_group_size (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_WORK_GROUP_SIZE"]], "invalid_work_item_size (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.INVALID_WORK_ITEM_SIZE"]], "kernel (pyopencl.device_exec_capabilities attribute)": [[6, "pyopencl.device_exec_capabilities.KERNEL"]], "kernel_arg_info_not_available (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.KERNEL_ARG_INFO_NOT_AVAILABLE"]], "kernel_exec_timeout_nv (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.KERNEL_EXEC_TIMEOUT_NV"]], "kernel_names (pyopencl.program_info attribute)": [[6, "pyopencl.program_info.KERNEL_NAMES"]], "kernel_read_and_write (pyopencl.mem_flags attribute)": [[6, "pyopencl.mem_flags.KERNEL_READ_AND_WRITE"]], "l1_cache (pyopencl.device_affinity_domain attribute)": [[6, "pyopencl.device_affinity_domain.L1_CACHE"]], "l2_cache (pyopencl.device_affinity_domain attribute)": [[6, "pyopencl.device_affinity_domain.L2_CACHE"]], "l3_cache (pyopencl.device_affinity_domain attribute)": [[6, "pyopencl.device_affinity_domain.L3_CACHE"]], "l4_cache (pyopencl.device_affinity_domain attribute)": [[6, "pyopencl.device_affinity_domain.L4_CACHE"]], "library (pyopencl.program_binary_type attribute)": [[6, "pyopencl.program_binary_type.LIBRARY"]], "linear (pyopencl.filter_mode attribute)": [[6, "pyopencl.filter_mode.LINEAR"]], "linker_available (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.LINKER_AVAILABLE"]], "linker_not_available (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.LINKER_NOT_AVAILABLE"]], "link_program_failure (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.LINK_PROGRAM_FAILURE"]], "local (pyopencl.device_local_mem_type attribute)": [[6, "pyopencl.device_local_mem_type.LOCAL"]], "local (pyopencl.kernel_arg_address_qualifier attribute)": [[6, "pyopencl.kernel_arg_address_qualifier.LOCAL"]], "local_mem_banks_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.LOCAL_MEM_BANKS_AMD"]], "local_mem_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.LOCAL_MEM_SIZE"]], "local_mem_size (pyopencl.kernel_work_group_info attribute)": [[6, "pyopencl.kernel_work_group_info.LOCAL_MEM_SIZE"]], "local_mem_size_per_compute_unit_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.LOCAL_MEM_SIZE_PER_COMPUTE_UNIT_AMD"]], "local_mem_type (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.LOCAL_MEM_TYPE"]], "local_size_for_sub_group_count (pyopencl.kernel_sub_group_info attribute)": [[6, "pyopencl.kernel_sub_group_info.LOCAL_SIZE_FOR_SUB_GROUP_COUNT"]], "lod_max (pyopencl.sampler_info attribute)": [[6, "pyopencl.sampler_info.LOD_MAX"]], "lod_max_khr (pyopencl.sampler_info attribute)": [[6, "pyopencl.sampler_info.LOD_MAX_KHR"]], "lod_min (pyopencl.sampler_info attribute)": [[6, "pyopencl.sampler_info.LOD_MIN"]], "lod_min_khr (pyopencl.sampler_info attribute)": [[6, "pyopencl.sampler_info.LOD_MIN_KHR"]], "log (pyopencl.program_build_info attribute)": [[6, "pyopencl.program_build_info.LOG"]], "luminance (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.LUMINANCE"]], "major_bits (pyopencl.version_bits attribute)": [[6, "pyopencl.version_bits.MAJOR_BITS"]], "major_mask (pyopencl.version_bits attribute)": [[6, "pyopencl.version_bits.MAJOR_MASK"]], "map_buffer (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.MAP_BUFFER"]], "map_count (pyopencl.mem_info attribute)": [[6, "pyopencl.mem_info.MAP_COUNT"]], "map_failure (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.MAP_FAILURE"]], "map_image (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.MAP_IMAGE"]], "marker (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.MARKER"]], "max_atomic_counters_ext (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_ATOMIC_COUNTERS_EXT"]], "max_clock_frequency (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_CLOCK_FREQUENCY"]], "max_compute_units (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_COMPUTE_UNITS"]], "max_constant_args (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_CONSTANT_ARGS"]], "max_constant_buffer_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_CONSTANT_BUFFER_SIZE"]], "max_global_variable_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_GLOBAL_VARIABLE_SIZE"]], "max_mem_alloc_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_MEM_ALLOC_SIZE"]], "max_num_sub_groups (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_NUM_SUB_GROUPS"]], "max_num_sub_groups (pyopencl.kernel_sub_group_info attribute)": [[6, "pyopencl.kernel_sub_group_info.MAX_NUM_SUB_GROUPS"]], "max_on_device_events (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_ON_DEVICE_EVENTS"]], "max_on_device_queues (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_ON_DEVICE_QUEUES"]], "max_packets (pyopencl.pipe_info attribute)": [[6, "pyopencl.pipe_info.MAX_PACKETS"]], "max_packets (pyopencl.pipe_properties attribute)": [[6, "pyopencl.pipe_properties.MAX_PACKETS"]], "max_parameter_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_PARAMETER_SIZE"]], "max_pipe_args (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_PIPE_ARGS"]], "max_read_image_args (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_READ_IMAGE_ARGS"]], "max_read_write_image_args (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_READ_WRITE_IMAGE_ARGS"]], "max_samplers (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_SAMPLERS"]], "max_size_restriction_exceeded (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.MAX_SIZE_RESTRICTION_EXCEEDED"]], "max_sub_group_size_for_ndrange (pyopencl.kernel_sub_group_info attribute)": [[6, "pyopencl.kernel_sub_group_info.MAX_SUB_GROUP_SIZE_FOR_NDRANGE"]], "max_work_group_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_WORK_GROUP_SIZE"]], "max_work_group_size_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_WORK_GROUP_SIZE_AMD"]], "max_work_item_dimensions (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_WORK_ITEM_DIMENSIONS"]], "max_work_item_sizes (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_WORK_ITEM_SIZES"]], "max_write_image_args (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MAX_WRITE_IMAGE_ARGS"]], "mem_base_addr_align (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MEM_BASE_ADDR_ALIGN"]], "mem_copy_overlap (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.MEM_COPY_OVERLAP"]], "mem_object_allocation_failure (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.MEM_OBJECT_ALLOCATION_FAILURE"]], "me_version_intel (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.ME_VERSION_INTEL"]], "migrate_mem_objects (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.MIGRATE_MEM_OBJECTS"]], "minor_bits (pyopencl.version_bits attribute)": [[6, "pyopencl.version_bits.MINOR_BITS"]], "minor_mask (pyopencl.version_bits attribute)": [[6, "pyopencl.version_bits.MINOR_MASK"]], "min_data_type_align_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.MIN_DATA_TYPE_ALIGN_SIZE"]], "mipmap_level (pyopencl.gl_texture_info attribute)": [[6, "pyopencl.gl_texture_info.MIPMAP_LEVEL"]], "mip_filter_mode (pyopencl.sampler_info attribute)": [[6, "pyopencl.sampler_info.MIP_FILTER_MODE"]], "mip_filter_mode_khr (pyopencl.sampler_info attribute)": [[6, "pyopencl.sampler_info.MIP_FILTER_MODE_KHR"]], "mirrored_repeat (pyopencl.addressing_mode attribute)": [[6, "pyopencl.addressing_mode.MIRRORED_REPEAT"]], "misaligned_sub_buffer_offset (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.MISALIGNED_SUB_BUFFER_OFFSET"]], "name (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.NAME"]], "name (pyopencl.kernel_arg_info attribute)": [[6, "pyopencl.kernel_arg_info.NAME"]], "name (pyopencl.platform_info attribute)": [[6, "pyopencl.platform_info.NAME"]], "native_kernel (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.NATIVE_KERNEL"]], "native_kernel (pyopencl.device_exec_capabilities attribute)": [[6, "pyopencl.device_exec_capabilities.NATIVE_KERNEL"]], "native_vector_width_char (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.NATIVE_VECTOR_WIDTH_CHAR"]], "native_vector_width_double (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.NATIVE_VECTOR_WIDTH_DOUBLE"]], "native_vector_width_float (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.NATIVE_VECTOR_WIDTH_FLOAT"]], "native_vector_width_half (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.NATIVE_VECTOR_WIDTH_HALF"]], "native_vector_width_int (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.NATIVE_VECTOR_WIDTH_INT"]], "native_vector_width_long (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.NATIVE_VECTOR_WIDTH_LONG"]], "native_vector_width_short (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.NATIVE_VECTOR_WIDTH_SHORT"]], "ndrange_kernel (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.NDRANGE_KERNEL"]], "nearest (pyopencl.filter_mode attribute)": [[6, "pyopencl.filter_mode.NEAREST"]], "next_partitionable (pyopencl.device_affinity_domain attribute)": [[6, "pyopencl.device_affinity_domain.NEXT_PARTITIONABLE"]], "none (pyopencl.addressing_mode attribute)": [[6, "pyopencl.addressing_mode.NONE"]], "none (pyopencl.device_mem_cache_type attribute)": [[6, "pyopencl.device_mem_cache_type.NONE"]], "none (pyopencl.kernel_arg_access_qualifier attribute)": [[6, "pyopencl.kernel_arg_access_qualifier.NONE"]], "none (pyopencl.kernel_arg_type_qualifier attribute)": [[6, "pyopencl.kernel_arg_type_qualifier.NONE"]], "none (pyopencl.program_binary_type attribute)": [[6, "pyopencl.program_binary_type.NONE"]], "non_uniform_work_group_support (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.NON_UNIFORM_WORK_GROUP_SUPPORT"]], "normalized_coords (pyopencl.sampler_info attribute)": [[6, "pyopencl.sampler_info.NORMALIZED_COORDS"]], "normalized_coords (pyopencl.sampler_properties attribute)": [[6, "pyopencl.sampler_properties.NORMALIZED_COORDS"]], "numa (pyopencl.device_affinity_domain attribute)": [[6, "pyopencl.device_affinity_domain.NUMA"]], "numeric_version (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.NUMERIC_VERSION"]], "numeric_version (pyopencl.platform_info attribute)": [[6, "pyopencl.platform_info.NUMERIC_VERSION"]], "num_args (pyopencl.kernel_info attribute)": [[6, "pyopencl.kernel_info.NUM_ARGS"]], "num_devices (pyopencl.context_info attribute)": [[6, "pyopencl.context_info.NUM_DEVICES"]], "num_devices (pyopencl.program_info attribute)": [[6, "pyopencl.program_info.NUM_DEVICES"]], "num_kernels (pyopencl.program_info attribute)": [[6, "pyopencl.program_info.NUM_KERNELS"]], "num_mip_levels (pyopencl.image_info attribute)": [[6, "pyopencl.image_info.NUM_MIP_LEVELS"]], "num_samples (pyopencl.image_info attribute)": [[6, "pyopencl.image_info.NUM_SAMPLES"]], "num_simultaneous_interops_intel (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.NUM_SIMULTANEOUS_INTEROPS_INTEL"]], "nameversion (class in pyopencl)": [[6, "pyopencl.NameVersion"]], "offline_devices_amd (pyopencl.context_properties attribute)": [[6, "pyopencl.context_properties.OFFLINE_DEVICES_AMD"]], "offset (pyopencl.mem_info attribute)": [[6, "pyopencl.mem_info.OFFSET"]], "on_device (pyopencl.command_queue_properties attribute)": [[6, "pyopencl.command_queue_properties.ON_DEVICE"]], "on_device_default (pyopencl.command_queue_properties attribute)": [[6, "pyopencl.command_queue_properties.ON_DEVICE_DEFAULT"]], "opencl_c_all_versions (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.OPENCL_C_ALL_VERSIONS"]], "opencl_c_features (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.OPENCL_C_FEATURES"]], "opencl_c_version (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.OPENCL_C_VERSION"]], "options (pyopencl.program_build_info attribute)": [[6, "pyopencl.program_build_info.OPTIONS"]], "order_acq_rel (pyopencl.device_atomic_capabilities attribute)": [[6, "pyopencl.device_atomic_capabilities.ORDER_ACQ_REL"]], "order_relaxed (pyopencl.device_atomic_capabilities attribute)": [[6, "pyopencl.device_atomic_capabilities.ORDER_RELAXED"]], "order_seq_cst (pyopencl.device_atomic_capabilities attribute)": [[6, "pyopencl.device_atomic_capabilities.ORDER_SEQ_CST"]], "out_of_host_memory (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.OUT_OF_HOST_MEMORY"]], "out_of_order_exec_mode_enable (pyopencl.command_queue_properties attribute)": [[6, "pyopencl.command_queue_properties.OUT_OF_ORDER_EXEC_MODE_ENABLE"]], "out_of_resources (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.OUT_OF_RESOURCES"]], "packet_size (pyopencl.pipe_info attribute)": [[6, "pyopencl.pipe_info.PACKET_SIZE"]], "packet_size (pyopencl.pipe_properties attribute)": [[6, "pyopencl.pipe_properties.PACKET_SIZE"]], "page_size_qcom (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PAGE_SIZE_QCOM"]], "parent_device (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PARENT_DEVICE"]], "partition_affinity_domain (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PARTITION_AFFINITY_DOMAIN"]], "partition_max_sub_devices (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PARTITION_MAX_SUB_DEVICES"]], "partition_properties (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PARTITION_PROPERTIES"]], "partition_type (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PARTITION_TYPE"]], "patch_bits (pyopencl.version_bits attribute)": [[6, "pyopencl.version_bits.PATCH_BITS"]], "patch_mask (pyopencl.version_bits attribute)": [[6, "pyopencl.version_bits.PATCH_MASK"]], "pcie (pyopencl.device_topology_type_amd attribute)": [[6, "pyopencl.device_topology_type_amd.PCIE"]], "pcie_id_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PCIE_ID_AMD"]], "pci_bus_id_nv (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PCI_BUS_ID_NV"]], "pci_domain_id_nv (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PCI_DOMAIN_ID_NV"]], "pci_slot_id_nv (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PCI_SLOT_ID_NV"]], "pipe (pyopencl.kernel_arg_type_qualifier attribute)": [[6, "pyopencl.kernel_arg_type_qualifier.PIPE"]], "pipe (pyopencl.mem_object_type attribute)": [[6, "pyopencl.mem_object_type.PIPE"]], "pipe_max_active_reservations (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PIPE_MAX_ACTIVE_RESERVATIONS"]], "pipe_max_packet_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PIPE_MAX_PACKET_SIZE"]], "pipe_support (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PIPE_SUPPORT"]], "platform (pyopencl.context_properties attribute)": [[6, "pyopencl.context_properties.PLATFORM"]], "platform (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PLATFORM"]], "platform_not_found_khr (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.PLATFORM_NOT_FOUND_KHR"]], "preferred_constant_buffer_size_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PREFERRED_CONSTANT_BUFFER_SIZE_AMD"]], "preferred_global_atomic_alignment (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PREFERRED_GLOBAL_ATOMIC_ALIGNMENT"]], "preferred_interop_user_sync (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PREFERRED_INTEROP_USER_SYNC"]], "preferred_local_atomic_alignment (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PREFERRED_LOCAL_ATOMIC_ALIGNMENT"]], "preferred_platform_atomic_alignment (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PREFERRED_PLATFORM_ATOMIC_ALIGNMENT"]], "preferred_vector_width_char (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PREFERRED_VECTOR_WIDTH_CHAR"]], "preferred_vector_width_double (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PREFERRED_VECTOR_WIDTH_DOUBLE"]], "preferred_vector_width_float (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PREFERRED_VECTOR_WIDTH_FLOAT"]], "preferred_vector_width_half (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PREFERRED_VECTOR_WIDTH_HALF"]], "preferred_vector_width_int (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PREFERRED_VECTOR_WIDTH_INT"]], "preferred_vector_width_long (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PREFERRED_VECTOR_WIDTH_LONG"]], "preferred_vector_width_short (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PREFERRED_VECTOR_WIDTH_SHORT"]], "preferred_work_group_size_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PREFERRED_WORK_GROUP_SIZE_AMD"]], "preferred_work_group_size_multiple (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PREFERRED_WORK_GROUP_SIZE_MULTIPLE"]], "preferred_work_group_size_multiple (pyopencl.kernel_work_group_info attribute)": [[6, "pyopencl.kernel_work_group_info.PREFERRED_WORK_GROUP_SIZE_MULTIPLE"]], "printf_buffer_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PRINTF_BUFFER_SIZE"]], "private (pyopencl.kernel_arg_address_qualifier attribute)": [[6, "pyopencl.kernel_arg_address_qualifier.PRIVATE"]], "private_mem_size (pyopencl.kernel_work_group_info attribute)": [[6, "pyopencl.kernel_work_group_info.PRIVATE_MEM_SIZE"]], "profile (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PROFILE"]], "profile (pyopencl.platform_info attribute)": [[6, "pyopencl.platform_info.PROFILE"]], "profiling_enable (pyopencl.command_queue_properties attribute)": [[6, "pyopencl.command_queue_properties.PROFILING_ENABLE"]], "profiling_info_not_available (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.PROFILING_INFO_NOT_AVAILABLE"]], "profiling_timer_offset_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PROFILING_TIMER_OFFSET_AMD"]], "profiling_timer_resolution (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.PROFILING_TIMER_RESOLUTION"]], "program (pyopencl.kernel_info attribute)": [[6, "pyopencl.kernel_info.PROGRAM"]], "properties (pyopencl.command_queue_info attribute)": [[6, "pyopencl.command_queue_info.PROPERTIES"]], "properties (pyopencl.context_info attribute)": [[6, "pyopencl.context_info.PROPERTIES"]], "properties (pyopencl.mem_info attribute)": [[6, "pyopencl.mem_info.PROPERTIES"]], "properties (pyopencl.pipe_info attribute)": [[6, "pyopencl.pipe_info.PROPERTIES"]], "properties (pyopencl.queue_properties attribute)": [[6, "pyopencl.queue_properties.PROPERTIES"]], "properties (pyopencl.sampler_info attribute)": [[6, "pyopencl.sampler_info.PROPERTIES"]], "properties_array (pyopencl.command_queue_info attribute)": [[6, "pyopencl.command_queue_info.PROPERTIES_ARRAY"]], "queued (pyopencl.command_execution_status attribute)": [[6, "pyopencl.command_execution_status.QUEUED"]], "queued (pyopencl.profiling_info attribute)": [[6, "pyopencl.profiling_info.QUEUED"]], "queue_on_device_max_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.QUEUE_ON_DEVICE_MAX_SIZE"]], "queue_on_device_preferred_size (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.QUEUE_ON_DEVICE_PREFERRED_SIZE"]], "queue_on_device_properties (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.QUEUE_ON_DEVICE_PROPERTIES"]], "queue_on_host_properties (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.QUEUE_ON_HOST_PROPERTIES"]], "queue_properties (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.QUEUE_PROPERTIES"]], "r (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.R"]], "ra (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.RA"]], "read (pyopencl.map_flags attribute)": [[6, "pyopencl.map_flags.READ"]], "read_buffer (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.READ_BUFFER"]], "read_buffer_rect (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.READ_BUFFER_RECT"]], "read_image (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.READ_IMAGE"]], "read_only (pyopencl.kernel_arg_access_qualifier attribute)": [[6, "pyopencl.kernel_arg_access_qualifier.READ_ONLY"]], "read_only (pyopencl.mem_flags attribute)": [[6, "pyopencl.mem_flags.READ_ONLY"]], "read_only (pyopencl.svm_mem_flags attribute)": [[6, "pyopencl.svm_mem_flags.READ_ONLY"]], "read_only_cache (pyopencl.device_mem_cache_type attribute)": [[6, "pyopencl.device_mem_cache_type.READ_ONLY_CACHE"]], "read_write (pyopencl.kernel_arg_access_qualifier attribute)": [[6, "pyopencl.kernel_arg_access_qualifier.READ_WRITE"]], "read_write (pyopencl.mem_flags attribute)": [[6, "pyopencl.mem_flags.READ_WRITE"]], "read_write (pyopencl.svm_mem_flags attribute)": [[6, "pyopencl.svm_mem_flags.READ_WRITE"]], "read_write_cache (pyopencl.device_mem_cache_type attribute)": [[6, "pyopencl.device_mem_cache_type.READ_WRITE_CACHE"]], "reference_count (pyopencl.command_queue_info attribute)": [[6, "pyopencl.command_queue_info.REFERENCE_COUNT"]], "reference_count (pyopencl.context_info attribute)": [[6, "pyopencl.context_info.REFERENCE_COUNT"]], "reference_count (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.REFERENCE_COUNT"]], "reference_count (pyopencl.event_info attribute)": [[6, "pyopencl.event_info.REFERENCE_COUNT"]], "reference_count (pyopencl.kernel_info attribute)": [[6, "pyopencl.kernel_info.REFERENCE_COUNT"]], "reference_count (pyopencl.mem_info attribute)": [[6, "pyopencl.mem_info.REFERENCE_COUNT"]], "reference_count (pyopencl.program_info attribute)": [[6, "pyopencl.program_info.REFERENCE_COUNT"]], "reference_count (pyopencl.sampler_info attribute)": [[6, "pyopencl.sampler_info.REFERENCE_COUNT"]], "registers_per_block_nv (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.REGISTERS_PER_BLOCK_NV"]], "release_gl_objects (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.RELEASE_GL_OBJECTS"]], "renderbuffer (pyopencl.gl_object_type attribute)": [[6, "pyopencl.gl_object_type.RENDERBUFFER"]], "repeat (pyopencl.addressing_mode attribute)": [[6, "pyopencl.addressing_mode.REPEAT"]], "replaceable_default (pyopencl.device_device_enqueue_capabilities attribute)": [[6, "pyopencl.device_device_enqueue_capabilities.REPLACEABLE_DEFAULT"]], "restrict (pyopencl.kernel_arg_type_qualifier attribute)": [[6, "pyopencl.kernel_arg_type_qualifier.RESTRICT"]], "rg (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.RG"]], "rgb (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.RGB"]], "rgba (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.RGBA"]], "rgbx (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.RGBx"]], "rgx (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.RGx"]], "round_to_inf (pyopencl.device_fp_config attribute)": [[6, "pyopencl.device_fp_config.ROUND_TO_INF"]], "round_to_nearest (pyopencl.device_fp_config attribute)": [[6, "pyopencl.device_fp_config.ROUND_TO_NEAREST"]], "round_to_zero (pyopencl.device_fp_config attribute)": [[6, "pyopencl.device_fp_config.ROUND_TO_ZERO"]], "row_pitch (pyopencl.image_info attribute)": [[6, "pyopencl.image_info.ROW_PITCH"]], "running (pyopencl.command_execution_status attribute)": [[6, "pyopencl.command_execution_status.RUNNING"]], "rx (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.Rx"]], "scope_all_devices (pyopencl.device_atomic_capabilities attribute)": [[6, "pyopencl.device_atomic_capabilities.SCOPE_ALL_DEVICES"]], "scope_device (pyopencl.device_atomic_capabilities attribute)": [[6, "pyopencl.device_atomic_capabilities.SCOPE_DEVICE"]], "scope_global_ctors_present (pyopencl.program_info attribute)": [[6, "pyopencl.program_info.SCOPE_GLOBAL_CTORS_PRESENT"]], "scope_global_dtors_present (pyopencl.program_info attribute)": [[6, "pyopencl.program_info.SCOPE_GLOBAL_DTORS_PRESENT"]], "scope_work_group (pyopencl.device_atomic_capabilities attribute)": [[6, "pyopencl.device_atomic_capabilities.SCOPE_WORK_GROUP"]], "scope_work_item (pyopencl.device_atomic_capabilities attribute)": [[6, "pyopencl.device_atomic_capabilities.SCOPE_WORK_ITEM"]], "signed_int16 (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.SIGNED_INT16"]], "signed_int32 (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.SIGNED_INT32"]], "signed_int8 (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.SIGNED_INT8"]], "simd_instruction_width_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.SIMD_INSTRUCTION_WIDTH_AMD"]], "simd_per_compute_unit_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.SIMD_PER_COMPUTE_UNIT_AMD"]], "simd_width_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.SIMD_WIDTH_AMD"]], "simultaneous_interops_intel (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.SIMULTANEOUS_INTEROPS_INTEL"]], "single_fp_config (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.SINGLE_FP_CONFIG"]], "size (pyopencl.mem_info attribute)": [[6, "pyopencl.mem_info.SIZE"]], "size (pyopencl.queue_properties attribute)": [[6, "pyopencl.queue_properties.SIZE"]], "slice_pitch (pyopencl.image_info attribute)": [[6, "pyopencl.image_info.SLICE_PITCH"]], "snorm_int16 (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.SNORM_INT16"]], "snorm_int8 (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.SNORM_INT8"]], "soft_float (pyopencl.device_fp_config attribute)": [[6, "pyopencl.device_fp_config.SOFT_FLOAT"]], "source (pyopencl.program_info attribute)": [[6, "pyopencl.program_info.SOURCE"]], "source (pyopencl.program_kind attribute)": [[6, "pyopencl.program_kind.SOURCE"]], "spir_versions (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.SPIR_VERSIONS"]], "start (pyopencl.profiling_info attribute)": [[6, "pyopencl.profiling_info.START"]], "status (pyopencl.program_build_info attribute)": [[6, "pyopencl.program_build_info.STATUS"]], "submit (pyopencl.profiling_info attribute)": [[6, "pyopencl.profiling_info.SUBMIT"]], "submitted (pyopencl.command_execution_status attribute)": [[6, "pyopencl.command_execution_status.SUBMITTED"]], "sub_group_count_for_ndrange (pyopencl.kernel_sub_group_info attribute)": [[6, "pyopencl.kernel_sub_group_info.SUB_GROUP_COUNT_FOR_NDRANGE"]], "sub_group_independent_forward_progress (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.SUB_GROUP_INDEPENDENT_FORWARD_PROGRESS"]], "success (pyopencl.status_code attribute)": [[6, "pyopencl.status_code.SUCCESS"]], "supported (pyopencl.device_device_enqueue_capabilities attribute)": [[6, "pyopencl.device_device_enqueue_capabilities.SUPPORTED"]], "svm_atomics (pyopencl.svm_mem_flags attribute)": [[6, "pyopencl.svm_mem_flags.SVM_ATOMICS"]], "svm_capabilities (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.SVM_CAPABILITIES"]], "svm_fine_grain_buffer (pyopencl.svm_mem_flags attribute)": [[6, "pyopencl.svm_mem_flags.SVM_FINE_GRAIN_BUFFER"]], "svm_free (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.SVM_FREE"]], "svm_map (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.SVM_MAP"]], "svm_memcpy (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.SVM_MEMCPY"]], "svm_memfill (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.SVM_MEMFILL"]], "svm_migrate_mem (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.SVM_MIGRATE_MEM"]], "svm_unmap (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.SVM_UNMAP"]], "task (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.TASK"]], "texture2d (pyopencl.gl_object_type attribute)": [[6, "pyopencl.gl_object_type.TEXTURE2D"]], "texture3d (pyopencl.gl_object_type attribute)": [[6, "pyopencl.gl_object_type.TEXTURE3D"]], "texture_target (pyopencl.gl_texture_info attribute)": [[6, "pyopencl.gl_texture_info.TEXTURE_TARGET"]], "thread_trace_supported_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.THREAD_TRACE_SUPPORTED_AMD"]], "topology_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.TOPOLOGY_AMD"]], "type (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.TYPE"]], "type (pyopencl.mem_info attribute)": [[6, "pyopencl.mem_info.TYPE"]], "type_name (pyopencl.kernel_arg_info attribute)": [[6, "pyopencl.kernel_arg_info.TYPE_NAME"]], "type_qualifier (pyopencl.kernel_arg_info attribute)": [[6, "pyopencl.kernel_arg_info.TYPE_QUALIFIER"]], "unknown (pyopencl.program_kind attribute)": [[6, "pyopencl.program_kind.UNKNOWN"]], "unmap_mem_object (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.UNMAP_MEM_OBJECT"]], "unorm_int16 (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.UNORM_INT16"]], "unorm_int24 (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.UNORM_INT24"]], "unorm_int8 (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.UNORM_INT8"]], "unorm_int_101010 (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.UNORM_INT_101010"]], "unorm_int_101010_2 (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.UNORM_INT_101010_2"]], "unorm_short_555 (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.UNORM_SHORT_555"]], "unorm_short_565 (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.UNORM_SHORT_565"]], "unsigned_int16 (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.UNSIGNED_INT16"]], "unsigned_int32 (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.UNSIGNED_INT32"]], "unsigned_int8 (pyopencl.channel_type attribute)": [[6, "pyopencl.channel_type.UNSIGNED_INT8"]], "user (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.USER"]], "uses_svm_pointer (pyopencl.mem_info attribute)": [[6, "pyopencl.mem_info.USES_SVM_POINTER"]], "use_host_ptr (pyopencl.mem_flags attribute)": [[6, "pyopencl.mem_flags.USE_HOST_PTR"]], "use_persistent_mem_amd (pyopencl.mem_flags attribute)": [[6, "pyopencl.mem_flags.USE_PERSISTENT_MEM_AMD"]], "vendor (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.VENDOR"]], "vendor (pyopencl.platform_info attribute)": [[6, "pyopencl.platform_info.VENDOR"]], "vendor_id (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.VENDOR_ID"]], "version (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.VERSION"]], "version (pyopencl.platform_info attribute)": [[6, "pyopencl.platform_info.VERSION"]], "volatile (pyopencl.kernel_arg_type_qualifier attribute)": [[6, "pyopencl.kernel_arg_type_qualifier.VOLATILE"]], "warp_size_nv (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.WARP_SIZE_NV"]], "wavefront_width_amd (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.WAVEFRONT_WIDTH_AMD"]], "wgl_hdc_khr (pyopencl.context_properties attribute)": [[6, "pyopencl.context_properties.WGL_HDC_KHR"]], "width (pyopencl.image_info attribute)": [[6, "pyopencl.image_info.WIDTH"]], "work_group_collective_functions_support (pyopencl.device_info attribute)": [[6, "pyopencl.device_info.WORK_GROUP_COLLECTIVE_FUNCTIONS_SUPPORT"]], "work_group_size (pyopencl.kernel_work_group_info attribute)": [[6, "pyopencl.kernel_work_group_info.WORK_GROUP_SIZE"]], "write (pyopencl.map_flags attribute)": [[6, "pyopencl.map_flags.WRITE"]], "write_buffer (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.WRITE_BUFFER"]], "write_buffer_rect (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.WRITE_BUFFER_RECT"]], "write_image (pyopencl.command_type attribute)": [[6, "pyopencl.command_type.WRITE_IMAGE"]], "write_invalidate_region (pyopencl.map_flags attribute)": [[6, "pyopencl.map_flags.WRITE_INVALIDATE_REGION"]], "write_only (pyopencl.kernel_arg_access_qualifier attribute)": [[6, "pyopencl.kernel_arg_access_qualifier.WRITE_ONLY"]], "write_only (pyopencl.mem_flags attribute)": [[6, "pyopencl.mem_flags.WRITE_ONLY"]], "write_only (pyopencl.svm_mem_flags attribute)": [[6, "pyopencl.svm_mem_flags.WRITE_ONLY"]], "__init__() (pyopencl.devicetopologyamd method)": [[6, "pyopencl.DeviceTopologyAmd.__init__"]], "__init__() (pyopencl.nameversion method)": [[6, "pyopencl.NameVersion.__init__"]], "addressing_mode (class in pyopencl)": [[6, "pyopencl.addressing_mode"]], "bus (pyopencl.devicetopologyamd attribute)": [[6, "pyopencl.DeviceTopologyAmd.bus"]], "channel_order (class in pyopencl)": [[6, "pyopencl.channel_order"]], "channel_type (class in pyopencl)": [[6, "pyopencl.channel_type"]], "command_execution_status (class in pyopencl)": [[6, "pyopencl.command_execution_status"]], "command_queue_info (class in pyopencl)": [[6, "pyopencl.command_queue_info"]], "command_queue_properties (class in pyopencl)": [[6, "pyopencl.command_queue_properties"]], "command_type (class in pyopencl)": [[6, "pyopencl.command_type"]], "context_info (class in pyopencl)": [[6, "pyopencl.context_info"]], "context_properties (class in pyopencl)": [[6, "pyopencl.context_properties"]], "device (pyopencl.devicetopologyamd attribute)": [[6, "pyopencl.DeviceTopologyAmd.device"]], "device_affinity_domain (class in pyopencl)": [[6, "pyopencl.device_affinity_domain"]], "device_atomic_capabilities (class in pyopencl)": [[6, "pyopencl.device_atomic_capabilities"]], "device_device_enqueue_capabilities (class in pyopencl)": [[6, "pyopencl.device_device_enqueue_capabilities"]], "device_exec_capabilities (class in pyopencl)": [[6, "pyopencl.device_exec_capabilities"]], "device_fp_config (class in pyopencl)": [[6, "pyopencl.device_fp_config"]], "device_info (class in pyopencl)": [[6, "pyopencl.device_info"]], "device_local_mem_type (class in pyopencl)": [[6, "pyopencl.device_local_mem_type"]], "device_mem_cache_type (class in pyopencl)": [[6, "pyopencl.device_mem_cache_type"]], "device_partition_property (class in pyopencl)": [[6, "pyopencl.device_partition_property"]], "device_svm_capabilities (class in pyopencl)": [[6, "pyopencl.device_svm_capabilities"]], "device_topology_type_amd (class in pyopencl)": [[6, "pyopencl.device_topology_type_amd"]], "device_type (class in pyopencl)": [[6, "pyopencl.device_type"]], "event_info (class in pyopencl)": [[6, "pyopencl.event_info"]], "filter_mode (class in pyopencl)": [[6, "pyopencl.filter_mode"]], "function (pyopencl.devicetopologyamd attribute)": [[6, "pyopencl.DeviceTopologyAmd.function"]], "gl_context_info (class in pyopencl)": [[6, "pyopencl.gl_context_info"]], "gl_object_type (class in pyopencl)": [[6, "pyopencl.gl_object_type"]], "gl_texture_info (class in pyopencl)": [[6, "pyopencl.gl_texture_info"]], "image_info (class in pyopencl)": [[6, "pyopencl.image_info"]], "kernel_arg_access_qualifier (class in pyopencl)": [[6, "pyopencl.kernel_arg_access_qualifier"]], "kernel_arg_address_qualifier (class in pyopencl)": [[6, "pyopencl.kernel_arg_address_qualifier"]], "kernel_arg_info (class in pyopencl)": [[6, "pyopencl.kernel_arg_info"]], "kernel_arg_type_qualifier (class in pyopencl)": [[6, "pyopencl.kernel_arg_type_qualifier"]], "kernel_info (class in pyopencl)": [[6, "pyopencl.kernel_info"]], "kernel_sub_group_info (class in pyopencl)": [[6, "pyopencl.kernel_sub_group_info"]], "kernel_work_group_info (class in pyopencl)": [[6, "pyopencl.kernel_work_group_info"]], "khronos_vendor_id (class in pyopencl)": [[6, "pyopencl.khronos_vendor_id"]], "map_flags (class in pyopencl)": [[6, "pyopencl.map_flags"]], "mem_flags (class in pyopencl)": [[6, "pyopencl.mem_flags"]], "mem_info (class in pyopencl)": [[6, "pyopencl.mem_info"]], "mem_migration_flags (class in pyopencl)": [[6, "pyopencl.mem_migration_flags"]], "mem_object_type (class in pyopencl)": [[6, "pyopencl.mem_object_type"]], "name (pyopencl.nameversion attribute)": [[6, "pyopencl.NameVersion.name"]], "name (pyopencl.program_kind attribute)": [[6, "pyopencl.program_kind.name"]], "pipe_info (class in pyopencl)": [[6, "pyopencl.pipe_info"]], "pipe_properties (class in pyopencl)": [[6, "pyopencl.pipe_properties"]], "platform_info (class in pyopencl)": [[6, "pyopencl.platform_info"]], "profiling_info (class in pyopencl)": [[6, "pyopencl.profiling_info"]], "program_binary_type (class in pyopencl)": [[6, "pyopencl.program_binary_type"]], "program_build_info (class in pyopencl)": [[6, "pyopencl.program_build_info"]], "program_info (class in pyopencl)": [[6, "pyopencl.program_info"]], "program_kind (class in pyopencl)": [[6, "pyopencl.program_kind"]], "queue_properties (class in pyopencl)": [[6, "pyopencl.queue_properties"]], "sbgra (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.sBGRA"]], "srgb (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.sRGB"]], "srgba (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.sRGBA"]], "srgbx (pyopencl.channel_order attribute)": [[6, "pyopencl.channel_order.sRGBx"]], "sampler_info (class in pyopencl)": [[6, "pyopencl.sampler_info"]], "sampler_properties (class in pyopencl)": [[6, "pyopencl.sampler_properties"]], "status_code (class in pyopencl)": [[6, "pyopencl.status_code"]], "svm_mem_flags (class in pyopencl)": [[6, "pyopencl.svm_mem_flags"]], "to_string() (pyopencl.addressing_mode method)": [[6, "pyopencl.addressing_mode.to_string"]], "to_string() (pyopencl.channel_order method)": [[6, "pyopencl.channel_order.to_string"]], "to_string() (pyopencl.channel_type method)": [[6, "pyopencl.channel_type.to_string"]], "to_string() (pyopencl.command_execution_status method)": [[6, "pyopencl.command_execution_status.to_string"]], "to_string() (pyopencl.command_queue_info method)": [[6, "pyopencl.command_queue_info.to_string"]], "to_string() (pyopencl.command_queue_properties method)": [[6, "pyopencl.command_queue_properties.to_string"]], "to_string() (pyopencl.command_type method)": [[6, "pyopencl.command_type.to_string"]], "to_string() (pyopencl.context_info method)": [[6, "pyopencl.context_info.to_string"]], "to_string() (pyopencl.context_properties method)": [[6, "pyopencl.context_properties.to_string"]], "to_string() (pyopencl.device_affinity_domain method)": [[6, "pyopencl.device_affinity_domain.to_string"]], "to_string() (pyopencl.device_atomic_capabilities method)": [[6, "pyopencl.device_atomic_capabilities.to_string"]], "to_string() (pyopencl.device_device_enqueue_capabilities method)": [[6, "pyopencl.device_device_enqueue_capabilities.to_string"]], "to_string() (pyopencl.device_exec_capabilities method)": [[6, "pyopencl.device_exec_capabilities.to_string"]], "to_string() (pyopencl.device_fp_config method)": [[6, "pyopencl.device_fp_config.to_string"]], "to_string() (pyopencl.device_info method)": [[6, "pyopencl.device_info.to_string"]], "to_string() (pyopencl.device_local_mem_type method)": [[6, "pyopencl.device_local_mem_type.to_string"]], "to_string() (pyopencl.device_mem_cache_type method)": [[6, "pyopencl.device_mem_cache_type.to_string"]], "to_string() (pyopencl.device_partition_property method)": [[6, "pyopencl.device_partition_property.to_string"]], "to_string() (pyopencl.device_svm_capabilities method)": [[6, "pyopencl.device_svm_capabilities.to_string"]], "to_string() (pyopencl.device_topology_type_amd method)": [[6, "pyopencl.device_topology_type_amd.to_string"]], "to_string() (pyopencl.device_type method)": [[6, "pyopencl.device_type.to_string"]], "to_string() (pyopencl.event_info method)": [[6, "pyopencl.event_info.to_string"]], "to_string() (pyopencl.filter_mode method)": [[6, "pyopencl.filter_mode.to_string"]], "to_string() (pyopencl.gl_context_info method)": [[6, "pyopencl.gl_context_info.to_string"]], "to_string() (pyopencl.gl_object_type method)": [[6, "pyopencl.gl_object_type.to_string"]], "to_string() (pyopencl.gl_texture_info method)": [[6, "pyopencl.gl_texture_info.to_string"]], "to_string() (pyopencl.image_info method)": [[6, "pyopencl.image_info.to_string"]], "to_string() (pyopencl.kernel_arg_access_qualifier method)": [[6, "pyopencl.kernel_arg_access_qualifier.to_string"]], "to_string() (pyopencl.kernel_arg_address_qualifier method)": [[6, "pyopencl.kernel_arg_address_qualifier.to_string"]], "to_string() (pyopencl.kernel_arg_info method)": [[6, "pyopencl.kernel_arg_info.to_string"]], "to_string() (pyopencl.kernel_arg_type_qualifier method)": [[6, "pyopencl.kernel_arg_type_qualifier.to_string"]], "to_string() (pyopencl.kernel_info method)": [[6, "pyopencl.kernel_info.to_string"]], "to_string() (pyopencl.kernel_sub_group_info method)": [[6, "pyopencl.kernel_sub_group_info.to_string"]], "to_string() (pyopencl.kernel_work_group_info method)": [[6, "pyopencl.kernel_work_group_info.to_string"]], "to_string() (pyopencl.khronos_vendor_id method)": [[6, "pyopencl.khronos_vendor_id.to_string"]], "to_string() (pyopencl.map_flags method)": [[6, "pyopencl.map_flags.to_string"]], "to_string() (pyopencl.mem_flags method)": [[6, "pyopencl.mem_flags.to_string"]], "to_string() (pyopencl.mem_info method)": [[6, "pyopencl.mem_info.to_string"]], "to_string() (pyopencl.mem_migration_flags method)": [[6, "pyopencl.mem_migration_flags.to_string"]], "to_string() (pyopencl.mem_object_type method)": [[6, "pyopencl.mem_object_type.to_string"]], "to_string() (pyopencl.pipe_info method)": [[6, "pyopencl.pipe_info.to_string"]], "to_string() (pyopencl.pipe_properties method)": [[6, "pyopencl.pipe_properties.to_string"]], "to_string() (pyopencl.platform_info method)": [[6, "pyopencl.platform_info.to_string"]], "to_string() (pyopencl.profiling_info method)": [[6, "pyopencl.profiling_info.to_string"]], "to_string() (pyopencl.program_binary_type method)": [[6, "pyopencl.program_binary_type.to_string"]], "to_string() (pyopencl.program_build_info method)": [[6, "pyopencl.program_build_info.to_string"]], "to_string() (pyopencl.program_info method)": [[6, "pyopencl.program_info.to_string"]], "to_string() (pyopencl.program_kind method)": [[6, "pyopencl.program_kind.to_string"]], "to_string() (pyopencl.queue_properties method)": [[6, "pyopencl.queue_properties.to_string"]], "to_string() (pyopencl.sampler_info method)": [[6, "pyopencl.sampler_info.to_string"]], "to_string() (pyopencl.sampler_properties method)": [[6, "pyopencl.sampler_properties.to_string"]], "to_string() (pyopencl.status_code method)": [[6, "pyopencl.status_code.to_string"]], "to_string() (pyopencl.svm_mem_flags method)": [[6, "pyopencl.svm_mem_flags.to_string"]], "to_string() (pyopencl.version_bits method)": [[6, "pyopencl.version_bits.to_string"]], "type (pyopencl.devicetopologyamd attribute)": [[6, "pyopencl.DeviceTopologyAmd.type"]], "value (pyopencl.program_kind attribute)": [[6, "pyopencl.program_kind.value"]], "version (pyopencl.nameversion attribute)": [[6, "pyopencl.NameVersion.version"]], "version_bits (class in pyopencl)": [[6, "pyopencl.version_bits"]], "glbuffer (class in pyopencl)": [[7, "pyopencl.GLBuffer"]], "glrenderbuffer (class in pyopencl)": [[7, "pyopencl.GLRenderBuffer"]], "gltexture (class in pyopencl)": [[7, "pyopencl.GLTexture"]], "enqueue_acquire_gl_objects() (in module pyopencl)": [[7, "pyopencl.enqueue_acquire_gl_objects"]], "enqueue_release_gl_objects() (in module pyopencl)": [[7, "pyopencl.enqueue_release_gl_objects"]], "get_apple_cgl_share_group() (in module pyopencl)": [[7, "pyopencl.get_apple_cgl_share_group"]], "get_gl_context_info_khr() (in module pyopencl)": [[7, "pyopencl.get_gl_context_info_khr"]], "get_gl_sharing_context_properties() (in module pyopencl)": [[7, "pyopencl.get_gl_sharing_context_properties"]], "get_gl_texture_info() (pyopencl.gltexture method)": [[7, "pyopencl.GLTexture.get_gl_texture_info"]], "gl_object (pyopencl.glbuffer attribute)": [[7, "pyopencl.GLBuffer.gl_object"]], "gl_object (pyopencl.glrenderbuffer attribute)": [[7, "pyopencl.GLRenderBuffer.gl_object"]], "gl_object (pyopencl.gltexture attribute)": [[7, "pyopencl.GLTexture.gl_object"]], "have_gl() (in module pyopencl)": [[7, "pyopencl.have_gl"]], "buffer (class in pyopencl)": [[8, "pyopencl.Buffer"]], "buffer (class in pyopencl._cl)": [[8, "pyopencl._cl.Buffer"]], "image (class in pyopencl)": [[8, "pyopencl.Image"]], "imageformat (class in pyopencl)": [[8, "pyopencl.ImageFormat"]], "memorymap (class in pyopencl)": [[8, "pyopencl.MemoryMap"]], "memoryobject (class in pyopencl)": [[8, "pyopencl.MemoryObject"]], "pipe (class in pyopencl)": [[8, "pyopencl.Pipe"]], "svm (class in pyopencl)": [[8, "pyopencl.SVM"]], "svmallocation (class in pyopencl)": [[8, "pyopencl.SVMAllocation"]], "svmmap (class in pyopencl)": [[8, "pyopencl.SVMMap"]], "svmpointer (class in pyopencl)": [[8, "pyopencl.SVMPointer"]], "sampler (class in pyopencl)": [[8, "pyopencl.Sampler"]], "__getitem__() (pyopencl.buffer method)": [[8, "pyopencl.Buffer.__getitem__"]], "__init__() (pyopencl.svm method)": [[8, "pyopencl.SVM.__init__"]], "__init__() (pyopencl.svmallocation method)": [[8, "pyopencl.SVMAllocation.__init__"]], "__init__() (pyopencl.sampler method)": [[8, "pyopencl.Sampler.__init__"]], "__repr__() (pyopencl.imageformat method)": [[8, "pyopencl.ImageFormat.__repr__"]], "as_buffer() (pyopencl.svmpointer method)": [[8, "pyopencl.SVMPointer.as_buffer"]], "bind_to_queue() (pyopencl.svmallocation method)": [[8, "pyopencl.SVMAllocation.bind_to_queue"]], "buf (pyopencl.svmpointer property)": [[8, "pyopencl.SVMPointer.buf"]], "channel_count (pyopencl.imageformat attribute)": [[8, "pyopencl.ImageFormat.channel_count"]], "channel_data_type (pyopencl.imageformat attribute)": [[8, "pyopencl.ImageFormat.channel_data_type"]], "channel_order (pyopencl.imageformat attribute)": [[8, "pyopencl.ImageFormat.channel_order"]], "csvm_empty() (in module pyopencl)": [[8, "pyopencl.csvm_empty"]], "csvm_empty_like() (in module pyopencl)": [[8, "pyopencl.csvm_empty_like"]], "dtype_size (pyopencl.imageformat attribute)": [[8, "pyopencl.ImageFormat.dtype_size"]], "enqueue_copy() (in module pyopencl)": [[8, "pyopencl.enqueue_copy"]], "enqueue_copy_buffer_p2p_amd() (in module pyopencl)": [[8, "pyopencl.enqueue_copy_buffer_p2p_amd"]], "enqueue_fill() (in module pyopencl)": [[8, "pyopencl.enqueue_fill"]], "enqueue_fill_buffer() (in module pyopencl)": [[8, "pyopencl.enqueue_fill_buffer"]], "enqueue_fill_image() (in module pyopencl)": [[8, "pyopencl.enqueue_fill_image"]], "enqueue_map_buffer() (in module pyopencl)": [[8, "pyopencl.enqueue_map_buffer"]], "enqueue_map_image() (in module pyopencl)": [[8, "pyopencl.enqueue_map_image"]], "enqueue_migrate_mem_objects() (in module pyopencl)": [[8, "pyopencl.enqueue_migrate_mem_objects"]], "enqueue_release() (pyopencl.svmallocation method)": [[8, "pyopencl.SVMAllocation.enqueue_release"]], "enqueue_svm_memfill() (in module pyopencl)": [[8, "pyopencl.enqueue_svm_memfill"]], "enqueue_svm_migratemem() (in module pyopencl)": [[8, "pyopencl.enqueue_svm_migratemem"]], "event (pyopencl.svmmap property)": [[8, "pyopencl.SVMMap.event"]], "from_int_ptr() (pyopencl.memoryobject static method)": [[8, "pyopencl.MemoryObject.from_int_ptr"]], "from_int_ptr() (pyopencl.sampler static method)": [[8, "pyopencl.Sampler.from_int_ptr"]], "fsvm_empty() (in module pyopencl)": [[8, "pyopencl.fsvm_empty"]], "fsvm_empty_like() (in module pyopencl)": [[8, "pyopencl.fsvm_empty_like"]], "get_host_array() (pyopencl.memoryobject method)": [[8, "pyopencl.MemoryObject.get_host_array"]], "get_image_info() (pyopencl.image method)": [[8, "pyopencl.Image.get_image_info"]], "get_info() (pyopencl.memoryobject method)": [[8, "pyopencl.MemoryObject.get_info"]], "get_info() (pyopencl.sampler method)": [[8, "pyopencl.Sampler.get_info"]], "get_pipe_info() (pyopencl.pipe method)": [[8, "pyopencl.Pipe.get_pipe_info"]], "get_sub_region() (pyopencl.buffer method)": [[8, "pyopencl.Buffer.get_sub_region"]], "get_supported_image_formats() (in module pyopencl)": [[8, "pyopencl.get_supported_image_formats"]], "hostbuf (pyopencl.memoryobject attribute)": [[8, "pyopencl.MemoryObject.hostbuf"]], "image_from_array() (in module pyopencl)": [[8, "pyopencl.image_from_array"]], "info (pyopencl.image attribute)": [[8, "pyopencl.Image.info"]], "info (pyopencl.memoryobject attribute)": [[8, "pyopencl.MemoryObject.info"]], "info (pyopencl.sampler attribute)": [[8, "pyopencl.Sampler.info"]], "int_ptr (pyopencl.memoryobject attribute)": [[8, "pyopencl.MemoryObject.int_ptr"]], "int_ptr (pyopencl.sampler attribute)": [[8, "pyopencl.Sampler.int_ptr"]], "itemsize (pyopencl.imageformat attribute)": [[8, "pyopencl.ImageFormat.itemsize"]], "map() (pyopencl.svm method)": [[8, "pyopencl.SVM.map"]], "map() (pyopencl.svmpointer method)": [[8, "pyopencl.SVMPointer.map"]], "map_ro() (pyopencl.svm method)": [[8, "pyopencl.SVM.map_ro"]], "map_ro() (pyopencl.svmpointer method)": [[8, "pyopencl.SVMPointer.map_ro"]], "map_rw() (pyopencl.svm method)": [[8, "pyopencl.SVM.map_rw"]], "map_rw() (pyopencl.svmpointer method)": [[8, "pyopencl.SVMPointer.map_rw"]], "mem (pyopencl.svm attribute)": [[8, "pyopencl.SVM.mem"]], "release() (pyopencl.image method)": [[8, "pyopencl.Image.release"]], "release() (pyopencl.memorymap method)": [[8, "pyopencl.MemoryMap.release"]], "release() (pyopencl.memoryobject method)": [[8, "pyopencl.MemoryObject.release"]], "release() (pyopencl.svmmap method)": [[8, "pyopencl.SVMMap.release"]], "shape (pyopencl.image attribute)": [[8, "pyopencl.Image.shape"]], "size (pyopencl.svmpointer property)": [[8, "pyopencl.SVMPointer.size"]], "svm_empty() (in module pyopencl)": [[8, "pyopencl.svm_empty"]], "svm_empty_like() (in module pyopencl)": [[8, "pyopencl.svm_empty_like"]], "svm_ptr (pyopencl.svmpointer property)": [[8, "pyopencl.SVMPointer.svm_ptr"]], "unbind_from_queue() (pyopencl.svmallocation method)": [[8, "pyopencl.SVMAllocation.unbind_from_queue"]], "context (class in pyopencl)": [[9, "pyopencl.Context"]], "device (class in pyopencl)": [[9, "pyopencl.Device"]], "platform (class in pyopencl)": [[9, "pyopencl.Platform"]], "create_some_context() (in module pyopencl)": [[9, "pyopencl.create_some_context"]], "create_sub_devices() (pyopencl.device method)": [[9, "pyopencl.Device.create_sub_devices"]], "device_and_host_timer() (pyopencl.device method)": [[9, "pyopencl.Device.device_and_host_timer"]], "from_int_ptr() (pyopencl.context static method)": [[9, "pyopencl.Context.from_int_ptr"]], "from_int_ptr() (pyopencl.device static method)": [[9, "pyopencl.Device.from_int_ptr"]], "from_int_ptr() (pyopencl.platform static method)": [[9, "pyopencl.Platform.from_int_ptr"]], "get_devices() (pyopencl.platform method)": [[9, "pyopencl.Platform.get_devices"]], "get_info() (pyopencl.context method)": [[9, "pyopencl.Context.get_info"]], "get_info() (pyopencl.device method)": [[9, "pyopencl.Device.get_info"]], "get_info() (pyopencl.platform method)": [[9, "pyopencl.Platform.get_info"]], "get_platforms() (in module pyopencl)": [[9, "pyopencl.get_platforms"]], "hashable_model_and_version_identifier (pyopencl.device attribute)": [[9, "pyopencl.Device.hashable_model_and_version_identifier"]], "host_timer() (pyopencl.device method)": [[9, "pyopencl.Device.host_timer"]], "info (pyopencl.context attribute)": [[9, "pyopencl.Context.info"]], "info (pyopencl.device attribute)": [[9, "pyopencl.Device.info"]], "info (pyopencl.platform attribute)": [[9, "pyopencl.Platform.info"]], "int_ptr (pyopencl.context attribute)": [[9, "pyopencl.Context.int_ptr"]], "int_ptr (pyopencl.device attribute)": [[9, "pyopencl.Device.int_ptr"]], "int_ptr (pyopencl.platform attribute)": [[9, "pyopencl.Platform.int_ptr"]], "set_default_device_command_queue() (pyopencl.context method)": [[9, "pyopencl.Context.set_default_device_command_queue"]], "kernel (class in pyopencl)": [[10, "pyopencl.Kernel"]], "localmemory (class in pyopencl)": [[10, "pyopencl.LocalMemory"]], "pyopencl_build_options": [[10, "envvar-PYOPENCL_BUILD_OPTIONS"], [10, "index-1"], [10, "index-3"]], "program (class in pyopencl)": [[10, "pyopencl.Program"]], "__call__() (pyopencl.kernel method)": [[10, "pyopencl.Kernel.__call__"]], "all_kernels() (pyopencl.program method)": [[10, "pyopencl.Program.all_kernels"]], "build() (pyopencl.program method)": [[10, "pyopencl.Program.build"]], "capture_call() (pyopencl.kernel method)": [[10, "pyopencl.Kernel.capture_call"]], "clone() (pyopencl.kernel method)": [[10, "pyopencl.Kernel.clone"]], "compile() (pyopencl.program method)": [[10, "pyopencl.Program.compile"]], "create_program_with_built_in_kernels() (in module pyopencl)": [[10, "pyopencl.create_program_with_built_in_kernels"]], "enqueue_nd_range_kernel() (in module pyopencl)": [[10, "pyopencl.enqueue_nd_range_kernel"]], "from_int_ptr() (pyopencl.kernel static method)": [[10, "pyopencl.Kernel.from_int_ptr"]], "from_int_ptr() (pyopencl.program static method)": [[10, "pyopencl.Program.from_int_ptr"]], "get_arg_info() (pyopencl.kernel method)": [[10, "pyopencl.Kernel.get_arg_info"]], "get_build_info() (pyopencl.program method)": [[10, "pyopencl.Program.get_build_info"]], "get_info() (pyopencl.kernel method)": [[10, "pyopencl.Kernel.get_info"]], "get_info() (pyopencl.program method)": [[10, "pyopencl.Program.get_info"]], "get_sub_group_info() (pyopencl.kernel method)": [[10, "pyopencl.Kernel.get_sub_group_info"]], "get_work_group_info() (pyopencl.kernel method)": [[10, "pyopencl.Kernel.get_work_group_info"]], "info (pyopencl.kernel attribute)": [[10, "pyopencl.Kernel.info"]], "info (pyopencl.program attribute)": [[10, "pyopencl.Program.info"]], "int_ptr (pyopencl.kernel attribute)": [[10, "pyopencl.Kernel.int_ptr"]], "int_ptr (pyopencl.program attribute)": [[10, "pyopencl.Program.int_ptr"]], "kernel_name (pyopencl.program attribute)": [[10, "pyopencl.Program.kernel_name"]], "link_program() (in module pyopencl)": [[10, "pyopencl.link_program"]], "set_arg() (pyopencl.kernel method)": [[10, "pyopencl.Kernel.set_arg"]], "set_args() (pyopencl.kernel method)": [[10, "pyopencl.Kernel.set_args"]], "set_scalar_arg_dtypes() (pyopencl.kernel method)": [[10, "pyopencl.Kernel.set_scalar_arg_dtypes"]], "set_specialization_constant() (pyopencl.program method)": [[10, "pyopencl.Program.set_specialization_constant"]], "size (pyopencl.localmemory attribute)": [[10, "pyopencl.LocalMemory.size"]], "unload_platform_compiler() (in module pyopencl)": [[10, "pyopencl.unload_platform_compiler"]], "commandqueue (class in pyopencl)": [[11, "pyopencl.CommandQueue"]], "event (class in pyopencl)": [[11, "pyopencl.Event"]], "nannyevent (class in pyopencl)": [[11, "pyopencl.NannyEvent"]], "profilinginfogetter (class in pyopencl)": [[11, "pyopencl.ProfilingInfoGetter"]], "userevent (class in pyopencl)": [[11, "pyopencl.UserEvent"]], "enqueue_barrier() (in module pyopencl)": [[11, "pyopencl.enqueue_barrier"]], "enqueue_marker() (in module pyopencl)": [[11, "pyopencl.enqueue_marker"]], "finish() (pyopencl.commandqueue method)": [[11, "pyopencl.CommandQueue.finish"]], "flush() (pyopencl.commandqueue method)": [[11, "pyopencl.CommandQueue.flush"]], "from_int_ptr() (pyopencl.commandqueue static method)": [[11, "pyopencl.CommandQueue.from_int_ptr"]], "from_int_ptr() (pyopencl.event static method)": [[11, "pyopencl.Event.from_int_ptr"]], "get_info() (pyopencl.commandqueue method)": [[11, "pyopencl.CommandQueue.get_info"]], "get_info() (pyopencl.event method)": [[11, "pyopencl.Event.get_info"]], "get_profiling_info() (pyopencl.event method)": [[11, "pyopencl.Event.get_profiling_info"]], "get_ward() (pyopencl.nannyevent method)": [[11, "pyopencl.NannyEvent.get_ward"]], "info (pyopencl.commandqueue attribute)": [[11, "pyopencl.CommandQueue.info"]], "info (pyopencl.event attribute)": [[11, "pyopencl.Event.info"]], "info (pyopencl.profilinginfogetter attribute)": [[11, "pyopencl.ProfilingInfoGetter.info"]], "int_ptr (pyopencl.commandqueue attribute)": [[11, "pyopencl.CommandQueue.int_ptr"]], "int_ptr (pyopencl.event attribute)": [[11, "pyopencl.Event.int_ptr"]], "profile (pyopencl.event attribute)": [[11, "pyopencl.Event.profile"]], "set_callback() (pyopencl.event method)": [[11, "pyopencl.Event.set_callback"]], "set_property() (pyopencl.commandqueue method)": [[11, "pyopencl.CommandQueue.set_property"]], "set_status() (pyopencl.userevent method)": [[11, "pyopencl.UserEvent.set_status"]], "wait() (pyopencl.event method)": [[11, "pyopencl.Event.wait"]], "wait() (pyopencl.nannyevent method)": [[11, "pyopencl.NannyEvent.wait"]], "wait_for_events() (in module pyopencl)": [[11, "pyopencl.wait_for_events"]], "allocatorbase (class in pyopencl._cl)": [[12, "pyopencl._cl.AllocatorBase"]], "allocatorbase (class in pyopencl.tools)": [[12, "pyopencl.tools.AllocatorBase"]], "argument (class in pyopencl.tools)": [[12, "pyopencl.tools.Argument"]], "clcharacterizationwarning": [[12, "pyopencl.characterize.CLCharacterizationWarning"]], "deferredallocator (class in pyopencl.tools)": [[12, "pyopencl.tools.DeferredAllocator"]], "dtypedargument (class in pyopencl.tools)": [[12, "pyopencl.tools.DtypedArgument"]], "immediateallocator (class in pyopencl.tools)": [[12, "pyopencl.tools.ImmediateAllocator"]], "memorypool (class in pyopencl.tools)": [[12, "pyopencl.tools.MemoryPool"]], "otherarg (class in pyopencl.tools)": [[12, "pyopencl.tools.OtherArg"]], "pooledbuffer (class in pyopencl.tools)": [[12, "pyopencl.tools.PooledBuffer"]], "pooledsvm (class in pyopencl.tools)": [[12, "pyopencl.tools.PooledSVM"]], "svmallocator (class in pyopencl.tools)": [[12, "pyopencl.tools.SVMAllocator"]], "svmpool (class in pyopencl.tools)": [[12, "pyopencl.tools.SVMPool"]], "scalararg (class in pyopencl.tools)": [[12, "pyopencl.tools.ScalarArg"]], "vectorarg (class in pyopencl.tools)": [[12, "pyopencl.tools.VectorArg"]], "__call__() (pyopencl.tools.allocatorbase method)": [[12, "pyopencl.tools.AllocatorBase.__call__"]], "__call__() (pyopencl.tools.deferredallocator method)": [[12, "pyopencl.tools.DeferredAllocator.__call__"]], "__call__() (pyopencl.tools.immediateallocator method)": [[12, "pyopencl.tools.ImmediateAllocator.__call__"]], "__call__() (pyopencl.tools.memorypool method)": [[12, "pyopencl.tools.MemoryPool.__call__"]], "__call__() (pyopencl.tools.svmallocator method)": [[12, "pyopencl.tools.SVMAllocator.__call__"]], "__call__() (pyopencl.tools.svmpool method)": [[12, "pyopencl.tools.SVMPool.__call__"]], "__init__() (pyopencl.tools.deferredallocator method)": [[12, "pyopencl.tools.DeferredAllocator.__init__"]], "__init__() (pyopencl.tools.immediateallocator method)": [[12, "pyopencl.tools.ImmediateAllocator.__init__"]], "__init__() (pyopencl.tools.memorypool method)": [[12, "pyopencl.tools.MemoryPool.__init__"]], "__init__() (pyopencl.tools.svmallocator method)": [[12, "pyopencl.tools.SVMAllocator.__init__"]], "__init__() (pyopencl.tools.svmpool method)": [[12, "pyopencl.tools.SVMPool.__init__"]], "__init__() (pyopencl.tools.vectorarg method)": [[12, "pyopencl.tools.VectorArg.__init__"]], "active_blocks (pyopencl.tools.memorypool attribute)": [[12, "pyopencl.tools.MemoryPool.active_blocks"]], "active_blocks (pyopencl.tools.svmpool attribute)": [[12, "pyopencl.tools.SVMPool.active_blocks"]], "active_bytes (pyopencl.tools.memorypool attribute)": [[12, "pyopencl.tools.MemoryPool.active_bytes"]], "active_bytes (pyopencl.tools.svmpool attribute)": [[12, "pyopencl.tools.SVMPool.active_bytes"]], "allocate() (pyopencl.tools.memorypool method)": [[12, "pyopencl.tools.MemoryPool.allocate"]], "bind_to_queue() (pyopencl.tools.pooledsvm method)": [[12, "pyopencl.tools.PooledSVM.bind_to_queue"]], "clear_first_arg_caches() (in module pyopencl.tools)": [[12, "pyopencl.tools.clear_first_arg_caches"]], "declarator() (pyopencl.tools.argument method)": [[12, "pyopencl.tools.Argument.declarator"]], "dtype (pyopencl.tools.dtypedargument attribute)": [[12, "pyopencl.tools.DtypedArgument.dtype"]], "enqueue_release() (pyopencl.tools.pooledsvm method)": [[12, "pyopencl.tools.PooledSVM.enqueue_release"]], "first_arg_dependent_memoize() (in module pyopencl.tools)": [[12, "pyopencl.tools.first_arg_dependent_memoize"]], "free_held() (pyopencl.tools.memorypool method)": [[12, "pyopencl.tools.MemoryPool.free_held"]], "free_held() (pyopencl.tools.svmpool method)": [[12, "pyopencl.tools.SVMPool.free_held"]], "get_fast_inaccurate_build_options() (in module pyopencl.characterize)": [[12, "pyopencl.characterize.get_fast_inaccurate_build_options"]], "get_simd_group_size() (in module pyopencl.characterize)": [[12, "pyopencl.characterize.get_simd_group_size"]], "has_amd_double_support() (in module pyopencl.characterize)": [[12, "pyopencl.characterize.has_amd_double_support"]], "has_struct_arg_count_bug() (in module pyopencl.characterize)": [[12, "pyopencl.characterize.has_struct_arg_count_bug"]], "held_blocks (pyopencl.tools.memorypool attribute)": [[12, "pyopencl.tools.MemoryPool.held_blocks"]], "held_blocks (pyopencl.tools.svmpool attribute)": [[12, "pyopencl.tools.SVMPool.held_blocks"]], "local_memory_access_granularity() (in module pyopencl.characterize)": [[12, "pyopencl.characterize.local_memory_access_granularity"]], "local_memory_bank_count() (in module pyopencl.characterize)": [[12, "pyopencl.characterize.local_memory_bank_count"]], "managed_bytes (pyopencl.tools.memorypool attribute)": [[12, "pyopencl.tools.MemoryPool.managed_bytes"]], "managed_bytes (pyopencl.tools.svmpool attribute)": [[12, "pyopencl.tools.SVMPool.managed_bytes"]], "name (pyopencl.tools.dtypedargument attribute)": [[12, "pyopencl.tools.DtypedArgument.name"]], "nv_compute_capability() (in module pyopencl.characterize)": [[12, "pyopencl.characterize.nv_compute_capability"]], "parse_arg_list() (in module pyopencl.tools)": [[12, "pyopencl.tools.parse_arg_list"]], "pyopencl.characterize": [[12, "module-pyopencl.characterize"]], "pyopencl.tools": [[12, "module-pyopencl.tools"]], "pytest_generate_tests_for_pyopencl() (in module pyopencl.tools)": [[12, "pyopencl.tools.pytest_generate_tests_for_pyopencl"]], "release() (pyopencl.tools.pooledsvm method)": [[12, "pyopencl.tools.PooledSVM.release"]], "simultaneous_work_items_on_local_access() (in module pyopencl.characterize)": [[12, "pyopencl.characterize.simultaneous_work_items_on_local_access"]], "stop_holding() (pyopencl.tools.memorypool method)": [[12, "pyopencl.tools.MemoryPool.stop_holding"]], "stop_holding() (pyopencl.tools.svmpool method)": [[12, "pyopencl.tools.SVMPool.stop_holding"]], "unbind_from_queue() (pyopencl.tools.pooledsvm method)": [[12, "pyopencl.tools.PooledSVM.unbind_from_queue"]], "usable_local_mem_size() (in module pyopencl.characterize)": [[12, "pyopencl.characterize.usable_local_mem_size"]], "why_not_local_access_conflict_free() (in module pyopencl.characterize)": [[12, "pyopencl.characterize.why_not_local_access_conflict_free"]], "pyopencl.cltypes": [[13, "module-pyopencl.cltypes"]]}})